/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of MPFR.xs. Do not edit this file, edit MPFR.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "MPFR.xs"

#ifdef  __MINGW32__
#ifndef __USE_MINGW_ANSI_STDIO
#define __USE_MINGW_ANSI_STDIO 1
#endif
#endif

#define PERL_NO_GET_CONTEXT 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"


#include "math_mpfr_include.h"
#include "math_mpfr_unused.h"

#if NVSIZE == 8
#  include "grisu3.h"
#endif

int nnum = 0; /* flag that is incremented whenever a string containing
                 non-numeric characters is treated as a number */

int nok_pok = 0; /* flag that is incremented whenever a scalar that is both
                 NOK and POK is passed to new or an overloaded operator */

/* Has inttypes.h been included ? */
int _has_inttypes(void) {
#if defined MATH_MPFR_NEED_LONG_LONG_INT
  return 1;
#else
  return 0;
#endif
}

int NNW_val(pTHX) {
  /* return the numeric value of $Math::MPFR::NNW - ie the no. of non-numeric instances encountered */
  return (int)SvIV(get_sv("Math::MPFR::NNW", 0));
}

int NOK_POK_val(pTHX) {
  /* return the numeric value of $Math::MPFR::NOK_POK */
  return (int)SvIV(get_sv("Math::MPFR::NOK_POK", 0));
}

int _win32_infnanstring(char * s) { /* MS Windows only - detect 1.#INF and 1.#IND
                                     * Need to do this to correctly handle a scalar
                                     * that is both NOK and POK on older win32 perls */

  /*************************************
  * if input string    =~ /^\-1\.#INF$/ return -1
  * elsif input string =~ /^\+?1\.#INF$/i return 1
  * elsif input string =~ /^(\-|\+)?1\.#IND$/i return 2
  * else return 0
  **************************************/

#ifdef _WIN32_BIZARRE_INFNAN

  int sign = 1;
  int factor = 1;

  if(s[0] == '-') {
    sign = -1;
    s++;
  }
  else {
    if(s[0] == '+') s++;
  }

  if(!strcmp(s, "1.#INF")) return sign;
  if(!strcmp(s, "1.#IND")) return 2;

  return 0;
#else
  PERL_UNUSED_ARG(s);
  croak("Math::MPFR::_win32_infnanstring not implemented for this build of perl");
#endif
}

/* _fmt_flt is used by _nvtoa, doubletoa and _mpfrtoa to format numeric strings */

SV * _fmt_flt(pTHX_ char * out, int k, int sign, int max_decimal_prec, int sf) {
/*

  out             : the string that contains the mantissa of the value as decimal digits;
                    does not contain a radix point.
  k               : the exponent of the value.
  sign            : is 0 if the value is non-negative; else is non-zero.
  max_decimal_prec: calculated as ceil(0x1.34413509f79ffp-2 * p) + 1, where p is the precision
                    in bits of the given floating point value.
  sf              : If non-zero, then Safefree(out) will be run prior to this function returning;
                    else Safefree(out) will not be run. The doubletoa function requires that
                    Safefree(out) is not run.

*/

  int k_index, critical, skip;
  SV * outsv;
  char *bstr;
  char str[] = {'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'};

/*******************************/
/*  Include following to return *
 *  the string as is - ie with  *
 *  no reformatting             */
/********************************
*  int as_is = 1;
*  if(as_is) {
*    sprintf(str, "e%03d", k);
*    strcat(out, str);
*    outsv = newSVpv(out, 0);
*    if(sf) Safefree(out);
*    return outsv;
*  }
********************************/

  k_index = (int)strlen(out);
  critical = k; /* formatting is based around this value */
  k -= k_index;

  if(critical < -3) {

    sprintf(str, "e%03d", critical - 1);
    if(sign || k_index > 1) {
      /* insert decimal point */
      for(skip = k_index + sign; skip > 1 + sign; skip--) {
        out[skip] = out[skip - 1 - sign];
      }

      if(k_index > 1) {
        out[1 + sign] = '.';
        out[k_index + 1 + sign] = 0;
      }

      if(sign) {
        out[1] = out[0];
        out[0] = '-';
      }
    }
    strcat(out, str);

    outsv = newSVpv(out, 0);
    if(sf) Safefree(out);
    return outsv;

  }

  if(critical <= 0 ) {

    /* bstr = concatenate "0." . ("0" x -critical) . out; */

    Newxz(bstr, 8 - critical + strlen(out), char); /* Note: 'critical' has -ve value */

    /* Newxz(bstr, (int)(16 + ceil(0.30103 * NVSIZE_BITS)), char); <= OLD VERSION */

    if(bstr == NULL) croak("Failed to allocate memory for 2nd output string in _fmt_flt sub");

    if(sign) bstr[0] = '-';

    bstr[0 + sign] = '0';
    bstr[1 + sign] = '.';

    sign += 2;

    for(skip = critical; skip < 0; skip++) {
      bstr[sign] = '0';
      sign++;
    }

    bstr[sign] = 0;
    strcat(bstr, out);

    outsv = newSVpv(bstr, 0);
    if(sf) Safefree(out);
    Safefree(bstr);
    return outsv;

  }

  if(critical < max_decimal_prec) {

    if(sign) {
      for(skip = k_index; skip > 0; skip--) out[skip] = out[skip - 1];
      out[0] = '-';
      out[k_index + 1] = 0;
    }

   if(k >= 0) {
      /* out = concatenate out . ('0' x k); */
      for(skip = 0; skip < k; skip++) out[k_index + skip + sign] = '0';
      out[k_index + k + sign] = '.';
      out[k_index + k + sign + 1] = '0';
      out[k_index + k + sign + 2] = 0;

      outsv = newSVpv(out, 0);
      if(sf) Safefree(out);
      return outsv;

    }

    /* insert decimal point; */
    for(skip = k_index + sign; skip > k_index + k + sign; skip--) out[skip] = out[skip - 1];
    out[k_index + k + sign] = '.';
    out[k_index + sign + 1] = 0;

    outsv = newSVpv(out, 0);
    if(sf) Safefree(out);
    return outsv;

  }

  if( k_index > 1) {
    /* insert decimal point */
    for(skip = k_index + sign; skip > 1 + sign; skip--) {
      out[skip] = out[skip - 1 - sign];
    }

    out[1 + sign] = '.';
    out[k_index + 1 + sign] = 0;
  }

  if(sign) {
    out[1] = out[0];
    out[0] = '-';
  }

  sprintf(str, "e+%d", critical - 1);
  strcat(out, str);

  outsv = newSVpv(out, 0);
  if(sf) Safefree(out);
  return outsv;

}

void Rmpfr_set_default_rounding_mode(pTHX_ SV * round) {
  CHECK_ROUNDING_VALUE
  mpfr_set_default_rounding_mode((mpfr_rnd_t)SvUV(round));
}

unsigned long Rmpfr_get_default_rounding_mode(void) {
  return __gmpfr_default_rounding_mode;
}

SV * Rmpfr_prec_round(pTHX_ mpfr_t * p, SV * prec, SV * round) {
  return newSViv(mpfr_prec_round(*p, (mpfr_prec_t)SvIV(prec), (mpfr_rnd_t)SvUV(round)));
}

void DESTROY(pTHX_ mpfr_t * p) {
  mpfr_clear(*p);
  Safefree(p);
}

void Rmpfr_clear(pTHX_ mpfr_t * p) {
  mpfr_clear(*p);
  Safefree(p);
}

void Rmpfr_clear_mpfr(mpfr_t * p) {
  mpfr_clear(*p);
}

void Rmpfr_clear_ptr(pTHX_ mpfr_t * p) {
  Safefree(p);
}

void Rmpfr_clears(pTHX_ SV * p, ...) {
  dXSARGS;
  long int i;
  PERL_UNUSED_ARG(p);
  for(i = 0; i < items; i++) {
    mpfr_clear(*(INT2PTR(mpfr_t *, SvIVX(SvRV(ST(i))))));
    Safefree(INT2PTR(mpfr_t *, SvIVX(SvRV(ST(i)))));
  }
  XSRETURN(0);
}

SV * Rmpfr_init(pTHX) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * Rmpfr_init2(pTHX_ SV * prec) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init2) /* defined in math_mpfr_include.h */
  mpfr_init2 (*mpfr_t_obj, (mpfr_prec_t)SvIV(prec));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * Rmpfr_init_nobless(pTHX) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_nobless) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * Rmpfr_init2_nobless(pTHX_ SV * prec) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init2_nobless) /* defined in math_mpfr_include.h */
  mpfr_init2 (*mpfr_t_obj, (mpfr_prec_t)SvIV(prec));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

void Rmpfr_init_set(pTHX_ mpfr_t * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_ui(pTHX_ SV * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set_ui) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_ui(*mpfr_t_obj, (unsigned long)SvUV(q), (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_si(pTHX_ SV * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set_si) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_si(*mpfr_t_obj, (long)SvIV(q), (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_d(pTHX_ SV * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set_d) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_d(*mpfr_t_obj, (double)SvNV(q), (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_ld(pTHX_ SV * q, SV * round) {
#ifdef USE_LONG_DOUBLE
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set_ld) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_ld(*mpfr_t_obj, (long double)SvNV(q), (mpfr_rnd_t)SvUV(round));
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
#else
  PERL_UNUSED_ARG2(q, round);
  croak("Rmpfr_init_set_ld not implemented on this build of perl");
#endif
}

void Rmpfr_init_set_f(pTHX_ mpf_t * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set_f) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_f(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_z(pTHX_ mpz_t * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set_z) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_z(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_q(pTHX_ mpq_t * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set_q) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_q(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_str(pTHX_ SV * q, SV * base, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_INPUT_BASE )
    croak("2nd argument supplied to Rmpfr_init_set str is out of allowable range");

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set_str) /* defined in math_mpfr_include.h */
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */

#ifdef _WIN32_BIZARRE_INFNAN
  inf_or_nan = _win32_infnanstring(SvPV_nolen(q));
  if(inf_or_nan) {
    mpfr_init(*mpfr_t_obj);
    if(inf_or_nan != 2) mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
  }
  else {
    ret = mpfr_init_set_str(*mpfr_t_obj, SvPV_nolen(q), (int)SvIV(base), (mpfr_rnd_t)SvUV(round));
  }
#else
  ret = mpfr_init_set_str(*mpfr_t_obj, SvPV_nolen(q), (int)SvIV(base), (mpfr_rnd_t)SvUV(round));
#endif

  NON_NUMERIC_CHAR_CHECK(q), "Rmpfr_init_set_str");}
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_nobless(pTHX_ mpfr_t * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_set_nobless) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_ui_nobless(pTHX_ SV * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_set_ui_nobless) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_ui(*mpfr_t_obj, (unsigned long)SvUV(q), (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_si_nobless(pTHX_ SV * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_set_si_nobless) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_si(*mpfr_t_obj, (long)SvIV(q), (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_d_nobless(pTHX_ SV * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_set_d_nobless) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_d(*mpfr_t_obj, (double)SvNV(q), (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_ld_nobless(pTHX_ SV * q, SV * round) {
#ifdef USE_LONG_DOUBLE
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_set_ld_nobless) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_ld(*mpfr_t_obj, (long double)SvNV(q), (mpfr_rnd_t)SvUV(round));
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */

#else
  PERL_UNUSED_ARG2(q, round);
  croak("Rmpfr_init_set_ld_nobless not implemented on this build of perl");

#endif
}

void Rmpfr_init_set_f_nobless(pTHX_ mpf_t * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_set_f_nobless) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_f(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_z_nobless(pTHX_ mpz_t * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_set_z_nobless) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_z(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_q_nobless(pTHX_ mpq_t * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_set_q_nobless) /* defined in math_mpfr_include.h */
  ret = mpfr_init_set_q(*mpfr_t_obj, *q, (mpfr_rnd_t)SvUV(round));

  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_str_nobless(pTHX_ SV * q, SV * base, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_INPUT_BASE )
    croak("2nd argument supplied to Rmpfr_init_set_str_nobless is out of allowable range");

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_set_str_nobless) /* defined in math_mpfr_include.h */
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  ret = mpfr_init_set_str(*mpfr_t_obj, SvPV_nolen(q), (int)SvIV(base), (mpfr_rnd_t)SvUV(round));

  NON_NUMERIC_CHAR_CHECK(q), "Rmpfr_init_set_str_nobless");}
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_deref2(pTHX_ mpfr_t * p, SV * base, SV * n_digits, SV * round) {
  dXSARGS;
  char * out;
  mpfr_exp_t ptr;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_OUTPUT_BASE )
    croak("Second argument supplied to Rmpfr_get_str is not in acceptable range");

  out = mpfr_get_str(NULL, &ptr, (int)SvIV(base), (unsigned long)SvUV(n_digits), *p, (mpfr_rnd_t)SvUV(round));

  if(out == NULL) croak("An error occurred in memory allocation in mpfr_get_str\n");

  ST(0) = MORTALIZED_PV(out);    /* defined in math_mpfr_include.h */
  mpfr_free_str(out);
  ST(1) = sv_2mortal(newSViv(ptr));
  XSRETURN(2);
}

void Rmpfr_set_default_prec(pTHX_ SV * prec) {
#if MPFR_VERSION < 262144      /* earlier than version 4.0.0 */
  if(SvIV(prec) < 2) croak("Precision must be set to at least 2 for this version (%s) of the mpfr library", MPFR_VERSION_STRING);
#endif
  mpfr_set_default_prec((mpfr_prec_t)SvIV(prec));
}

SV * Rmpfr_get_default_prec(pTHX) {
  return newSViv(mpfr_get_default_prec());
}

SV * Rmpfr_min_prec(pTHX_ mpfr_t * x) {
  return newSViv((mpfr_prec_t)mpfr_min_prec(*x));
}

void Rmpfr_set_prec(pTHX_ mpfr_t * p, SV * prec) {
#if MPFR_VERSION < 262144      /* earlier than version 4.0.0 */
  if(SvIV(prec) < 2) croak("Precision must be set to at least 2 for this version (%s) of the mpfr library", MPFR_VERSION_STRING);
#endif
  mpfr_set_prec(*p, (mpfr_prec_t)SvIV(prec));
}

void Rmpfr_set_prec_raw(pTHX_ mpfr_t * p, SV * prec) {
#if MPFR_VERSION < 262144      /* earlier than version 4.0.0 */
  if(SvIV(prec) < 2) croak("Precision must be set to at least 2 for this version (%s) of the mpfr library", MPFR_VERSION_STRING);
#endif
  mpfr_set_prec_raw(*p, (mpfr_prec_t)SvIV(prec));
}

SV * Rmpfr_get_prec(pTHX_ mpfr_t * p) {
  return newSViv(mpfr_get_prec(*p));
}

SV * Rmpfr_set(pTHX_ mpfr_t * p, mpfr_t * q, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_set(*p, *q, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_ui(pTHX_ mpfr_t * p, SV * q, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_set_ui(*p, (unsigned long)SvUV(q), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_si(pTHX_ mpfr_t * p, SV * q, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_set_si(*p, (long)SvIV(q), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_uj(pTHX_ mpfr_t * p, SV * q, SV * round) {
  CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  return newSViv(mpfr_set_uj(*p, SvUV(q), (mpfr_rnd_t)SvUV(round)));
#else
  croak("Rmpfr_set_uj not implemented on this build of perl");
#endif
}

SV * Rmpfr_set_sj(pTHX_ mpfr_t * p, SV * q, SV * round) {
  CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  return newSViv(mpfr_set_sj(*p, SvIV(q), (mpfr_rnd_t)SvUV(round)));
#else
  croak("Rmpfr_set_sj not implemented on this build of perl");
#endif
}

int Rmpfr_set_NV(pTHX_ mpfr_t * p, SV * q, unsigned int round) {
#if MPFR_VERSION_MAJOR < 3
  if((mpfr_rnd_t)round > 3)
    croak("Illegal rounding value supplied for this version (%s) of the mpfr library", MPFR_VERSION_STRING);
#endif
#if defined(USE_LONG_DOUBLE)
  if(!SV_IS_NOK(q))
    croak("In Rmpfr_set_NV, 2nd argument is not an NV");

  return mpfr_set_ld(*p, (long double)SvNV(q), (mpfr_rnd_t)round);
#elif defined(CAN_PASS_FLOAT128)
  if(!SV_IS_NOK(q))
    croak("In Rmpfr_set_NV, 2nd argument is not an NV");

  return mpfr_set_float128(*p, (float128)SvNV(q), (mpfr_rnd_t)round);
#elif defined(USE_QUADMATH)
  char buffer[45];
  int exp;
  float128 ld;
  int returned;

  if(!SV_IS_NOK(q))
    croak("In Rmpfr_set_NV, 2nd argument is not an NV");

  ld = (float128)SvNV(q);

  if(ld != ld) {
    mpfr_set_nan(*p);
    return 0;
  }

  if(ld != 0.0Q && (ld / ld != 1)) {
    returned = ld > 0.0Q ? 1 : -1;
    mpfr_set_inf(*p, returned);
    return 0;
  }

  ld = frexpq(ld, &exp); /* 0.5 <= returned value < 1.0 */
     /* Convert ld to an integer by right shifting it 113 bits */
  ld *= 0x1p+113Q;      /* ld *= powq(2.0Q, 113); */
  returned = quadmath_snprintf(buffer, 45, "%.0Qf", ld);
  if(returned < 0) croak("In Rmpfr_set_NV, encoding error in quadmath_snprintf function");
  if(returned >= 45) croak("In Rmpfr_set_NV, buffer given to quadmath_snprintf function was too small");
  returned = mpfr_set_str(*p, buffer, 10, (mpfr_rnd_t)round);
  mpfr_mul_2si(*p, *p, exp - 113, GMP_RNDN);
  return returned;
#else
  if(!SV_IS_NOK(q))
    croak("In Rmpfr_set_NV, 2nd argument is not an NV");
  return mpfr_set_d (*p, SvNV(q), (mpfr_rnd_t)round);
#endif
}


void Rmpfr_init_set_NV(pTHX_ SV * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set_NV) /* defined in math_mpfr_include.h */

  mpfr_init(*mpfr_t_obj);
  sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
  ret = Rmpfr_set_NV(aTHX_ mpfr_t_obj, q, (mpfr_rnd_t)SvUV(round));
  SvREADONLY_on(obj);
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_NV_nobless(pTHX_ SV * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_set_NV_nobless) /* defined in math_mpfr_include.h */

  mpfr_init(*mpfr_t_obj);
  sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
  ret = Rmpfr_set_NV(aTHX_ mpfr_t_obj, q, (mpfr_rnd_t)SvUV(round));
  SvREADONLY_on(obj);
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

int Rmpfr_cmp_float128(pTHX_ mpfr_t * a, SV * b) {
#if defined(CAN_PASS_FLOAT128)
  mpfr_t t;
  int ret;

  mpfr_init2(t, FLT128_MANT_DIG);
  mpfr_set_float128(t, SvNV(b), GMP_RNDN);
  ret = mpfr_cmp(*a, t);
  mpfr_clear(t);
  return ret;
#elif defined(USE_QUADMATH)
  mpfr_t t;
  char buffer[45];
  int exp;
  float128 ld;
  int returned;

  ld = (float128)SvNV(b);
  if(ld != ld || mpfr_nan_p(*a)) {
    mpfr_set_erangeflag();
    return 0;
  }

  if(ld != 0.0Q && (ld / ld != 1)) {
    if(ld > 0.0Q) {
      if(mpfr_inf_p(*a)) {
        if(mpfr_signbit(*a)) return -1;
        return 0;
      }
      return -1;
    }
    if(mpfr_inf_p(*a)) {
      if(mpfr_signbit(*a)) return 0;
      return 1;
    }
    return 1;
  }

  if(ld == 0.0Q) {
    if(mpfr_zero_p (*a)) return 0;
    if(mpfr_signbit(*a)) return -1;
    return 1;
  }

  ld = frexpq(ld, &exp); /* 0.5 <= returned value < 1.0 */
     /* Convert ld to an integer by right shifting it 113 bits */
  ld *= 0x1p+113Q;      /* ld *= powq(2.0Q, 113); */
  returned = quadmath_snprintf(buffer, 45, "%.0Qf", ld);
  if(returned < 0) croak("In Rmpfr_set_NV, encoding error in quadmath_snprintf function");
  if(returned >= 45) croak("In Rmpfr_set_NV, buffer given to quadmath_snprintf function was too small");
  mpfr_init2(t, FLT128_MANT_DIG);
  returned = mpfr_set_str(t, buffer, 10, GMP_RNDN);
  mpfr_mul_2si(t, t, exp - 113, GMP_RNDN);
  returned = mpfr_cmp(*a, t);
  mpfr_clear(t);
  return returned;
#else
  PERL_UNUSED_ARG2(a, b);
  croak("Rmpfr_cmp_float128 not available on this build of perl");
#endif
}

int Rmpfr_cmp_NV(pTHX_ mpfr_t * a, SV * b) {
  if(!SvNOK(b))
    croak("In Rmpfr_cmp_NV, 2nd argument is not an NV");
#if defined(USE_LONG_DOUBLE)
  return mpfr_cmp_ld(*a, SvNV(b));
#elif defined(USE_QUADMATH)
  return Rmpfr_cmp_float128(aTHX_ a, b);
#else
  return mpfr_cmp_d(*a, SvNV(b));
#endif
}

SV * Rmpfr_set_ld(pTHX_ mpfr_t * p, SV * q, SV * round) {
  CHECK_ROUNDING_VALUE
#if defined(USE_LONG_DOUBLE) || defined(USE_QUADMATH)
  return newSViv(mpfr_set_ld(*p, (long double)SvNV(q), (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG3(p, q, round);
  croak("Rmpfr_set_ld not implemented on this build of perl");
#endif
}

SV * Rmpfr_set_d(pTHX_ mpfr_t * p, SV * q, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_set_d(*p, (double)SvNV(q), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_z(pTHX_ mpfr_t * p, mpz_t * q, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_set_z(*p, *q, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_q(pTHX_ mpfr_t * p, mpq_t * q, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_set_q(*p, *q, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_f(pTHX_ mpfr_t * p, mpf_t * q, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_set_f(*p, *q, (mpfr_rnd_t)SvUV(round)));
}

int Rmpfr_set_str(pTHX_ mpfr_t * p, SV * num, SV * base, SV * round) {
 int ret;
#ifdef _WIN32_BIZARRE_INFNAN
 int inf_or_nan;
#endif

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_INPUT_BASE )
    croak("3rd argument supplied to Rmpfr_set_str is out of allowable range");

#ifdef _WIN32_BIZARRE_INFNAN
  inf_or_nan = _win32_infnanstring(SvPV_nolen(num));

  if(inf_or_nan) {
    if(inf_or_nan == 2) {
      mpfr_set_nan(*p);
    }
    else mpfr_set_inf(*p, inf_or_nan);
  }
  else {
    ret = mpfr_set_str(*p, SvPV_nolen(num), (int)SvIV(base), (mpfr_rnd_t)SvUV(round));
  }
#else
  ret = mpfr_set_str(*p, SvPV_nolen(num), (int)SvIV(base), (mpfr_rnd_t)SvUV(round));
#endif

  NON_NUMERIC_CHAR_CHECK(num), "Rmpfr_set_str");}

  return ret;
}

void Rmpfr_set_inf(mpfr_t * p, int sign) {
  mpfr_set_inf(*p, sign);
}

void Rmpfr_set_nan(mpfr_t * p) {
  mpfr_set_nan(*p);
}

void Rmpfr_swap(mpfr_t *p, mpfr_t * q) {
  mpfr_swap(*p, *q);
}

SV * Rmpfr_get_d(pTHX_ mpfr_t * p, SV * round){
  CHECK_ROUNDING_VALUE
  return newSVnv(mpfr_get_d(*p, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_d_2exp(pTHX_ SV * exp, mpfr_t * p, SV * round){
  long _exp;
  double ret;

  CHECK_ROUNDING_VALUE
  ret = mpfr_get_d_2exp(&_exp, *p, (mpfr_rnd_t)SvUV(round));
  sv_setiv(exp, _exp);
  return newSVnv(ret);
}

SV * Rmpfr_get_ld_2exp(pTHX_ SV * exp, mpfr_t * p, SV * round){
#if defined(USE_LONG_DOUBLE) || defined(USE_QUADMATH)
#  if defined(USE_QUADMATH) && defined(__GNUC__) && ((__GNUC__ > 4 && __GNUC__ < 7) || (__GNUC__ == 4 && __GNUC_MINOR__ >= 9))
  /*
     Casting long double Inf to float128 might result in NaN.
     This is GCC bug 77265, which was fixed for GCC 7:
     https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77265
     The fix might yet be backported to GCC 6. (Not sure.)
     It was earlier reported (also by me) to MinGW:
     https://sourceforge.net/p/mingw-w64/bugs/479/
     Let us take the cautious approach and simply avoid
     making that cast. Instead, we will cast the double Inf
     to a float128.
  */
     if(mpfr_inf_p(*p))
       return newSVnv(mpfr_get_d(*p, (mpfr_rnd_t)SvUV(round)));
#  endif
  long _exp;
  long double ret;

  CHECK_ROUNDING_VALUE
  ret = mpfr_get_ld_2exp(&_exp, *p, (mpfr_rnd_t)SvUV(round));
  sv_setiv(exp, _exp);
  return newSVnv(ret);
#else
  PERL_UNUSED_ARG3(exp, p, round);
  croak("Rmpfr_get_ld_2exp not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_ld(pTHX_ mpfr_t * p, SV * round){
   CHECK_ROUNDING_VALUE
#if defined(USE_LONG_DOUBLE) || defined(USE_QUADMATH)
#  if defined(USE_QUADMATH) && defined(__GNUC__) && ((__GNUC__ > 4 && __GNUC__ < 7) || (__GNUC__ == 4 && __GNUC_MINOR__ >= 9))
    /*
    Casting long double Inf to float128 might result in NaN.
    This is GCC bug 77265, which was fixed for GCC 7:
    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=77265
    The fix might yet be backported to GCC 6. (Not sure.)
    It was earlier reported (also by me) to MinGW:
    https://sourceforge.net/p/mingw-w64/bugs/479/
    Let us take the cautious approach and simply avoid
    making that cast. Instead, we will cast the double Inf
    to a float128.
    */
    if(mpfr_inf_p(*p))
      return newSVnv(mpfr_get_d(*p, (mpfr_rnd_t)SvUV(round)));

#  elif LDBL_MANT_DIG == 106
#    if !defined(MPFR_VERSION) || (defined(MPFR_VERSION) && MPFR_VERSION <= DD_INF_BUG)
      double d = mpfr_get_ld(*p, (mpfr_rnd_t)SvUV(round));

      if(d == 0.0 || d != d || d / d != 1) return newSVnv((long double)d);
#    endif
#  endif

#  if defined MPFR_VERSION && MPFR_VERSION > 196868            /* mpfr_get_ld handles subnormals correctly */
    return newSVnv(mpfr_get_ld(*p, (mpfr_rnd_t)SvUV(round)));
#  else                                                        /* mpfr_get_ld handling of subnormals is buggy */

    if(strtold("2e-4956", NULL) == 0.0L) { /* extended precision (80-bit) long double */
      if(mpfr_regular_p(*p) && mpfr_get_exp(*p) < -16381 && mpfr_get_exp(*p) >= -16445) {
        warn("\n mpfr_get_ld is buggy (subnormal values only)\n for this version (%s) of the MPFR library\n", MPFR_VERSION_STRING);
        croak(" Version 3.1.5 or later is required");
      }
    }
    return newSVnv(mpfr_get_ld(*p, (mpfr_rnd_t)SvUV(round)));

#  endif

#else
  PERL_UNUSED_ARG2(p, round);
  croak("Rmpfr_get_ld not implemented on this build of perl");
#endif
}

double Rmpfr_get_d1(mpfr_t * p) {
     return mpfr_get_d1(*p);
}

/* Alias for the perl function Rmpfr_get_z_exp
*  (which will perhaps one day be removed).
*  The mpfr headers define 'mpfr_get_z_exp' to
*  'mpfr_get_z_2exp' when that function is
*  available.
*/
SV * Rmpfr_get_z_2exp(pTHX_ mpz_t * z, mpfr_t * p){
  return newSViv(mpfr_get_z_exp(*z, *p));
}

SV * Rmpfr_add(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_add(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
  CHECK_ROUNDING_VALUE
  DEAL_WITH_NANFLAG_BUG
  return newSViv(mpfr_add_ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_add_d(*a, *b, (double)SvNV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
  CHECK_ROUNDING_VALUE
  DEAL_WITH_NANFLAG_BUG
  return newSViv(mpfr_add_si(*a, *b, (int)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_add_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_add_z(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

/* No need for rounding as result will be exact */
void Rmpfr_get_q(mpq_t * a, mpfr_t * b) {

#if defined(MPFR_VERSION_MAJOR) && MPFR_VERSION_MAJOR >= 4
  if(!mpfr_number_p(*b)) croak("In Rmpfr_get_q: Cannot coerce an 'Inf' or 'NaN' to a Math::GMPq object");
  mpfr_get_q(*a, *b);

#else
  mpf_t temp;

  if(!mpfr_number_p(*b)) croak("In Rmpfr_get_q: Cannot coerce an 'Inf' or 'NaN' to a Math::GMPq object");
  mpf_init2 (temp, (mp_bitcnt_t)mpfr_get_prec(*b));
  mpfr_get_f(temp, *b, GMP_RNDN);
  mpq_set_f (*a, temp);
  mpf_clear(temp);
#endif
}

SV * Rmpfr_add_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_add_q(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

void q_add_fr(mpq_t * a, mpq_t * b, mpfr_t * c) {
  mpq_t temp;
  mpq_init(temp);
#if defined(MPFR_VERSION_MAJOR) && MPFR_VERSION_MAJOR >= 4
  mpfr_get_q(temp, *c);
#else
  Rmpfr_get_q(&temp, c);
#endif
  mpq_add(*a, *b, temp);
  mpq_clear(temp);
}

SV * Rmpfr_sub(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sub(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
  DEAL_WITH_NANFLAG_BUG
  return newSViv(mpfr_sub_ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sub_d(*a, *b, (double)SvNV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sub_z(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sub_q(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

void q_sub_fr(mpq_t * a, mpq_t * b, mpfr_t * c) {
  mpq_t temp;
  mpq_init(temp);
#if defined(MPFR_VERSION_MAJOR) && MPFR_VERSION_MAJOR >= 4
  mpfr_get_q(temp, *c);
#else
  Rmpfr_get_q(&temp, c);
#endif
  mpq_sub(*a, *b, temp);
  mpq_clear(temp);
}

SV * Rmpfr_ui_sub(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_ui_sub(*a, (unsigned long)SvUV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_d_sub(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_d_sub(*a, (double)SvNV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_mul(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_mul_ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_mul_d(*a, *b, (double)SvNV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_mul_z(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_mul_q(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

void q_mul_fr(mpq_t * a, mpq_t * b, mpfr_t * c) {
  mpq_t temp;
  mpq_init(temp);
#if defined(MPFR_VERSION_MAJOR) && MPFR_VERSION_MAJOR >= 4
  mpfr_get_q(temp, *c);
#else
  Rmpfr_get_q(&temp, c);
#endif
  mpq_mul(*a, *b, temp);
  mpq_clear(temp);
}

SV * Rmpfr_dim(pTHX_ mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, SV * round) {
  CHECK_ROUNDING_VALUE
  int ret = mpfr_dim( *rop, *op1, *op2, (mpfr_rnd_t)SvUV(round));
  return newSViv(ret);
}

SV * Rmpfr_div(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_div(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_div_ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_d(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_div_d(*a, *b, (double)SvNV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_div_z(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_q(pTHX_ mpfr_t * a, mpfr_t * b, mpq_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_div_q(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

void q_div_fr(mpq_t * a, mpq_t * b, mpfr_t * c) {
  mpq_t temp;
  mpq_init(temp);
#if defined(MPFR_VERSION_MAJOR) && MPFR_VERSION_MAJOR >= 4
  mpfr_get_q(temp, *c);
#else
  Rmpfr_get_q(&temp, c);
#endif
  mpq_div(*a, *b, temp);
  mpq_clear(temp);
}

void q_fmod_fr(mpq_t * a, mpq_t * b, mpfr_t * c) {
  mpq_t q;
  mpz_t z;
  mpq_init(q);
  mpz_init(z);
#if defined(MPFR_VERSION_MAJOR) && MPFR_VERSION_MAJOR >= 4
  mpfr_get_q(q, *c);
#else
  Rmpfr_get_q(&q, c);
#endif

  mpq_div(*a, *b, q);
  mpz_set_q(z, *a);
  mpq_set_z(*a, z);
  mpz_clear(z);
  mpq_mul(*a, q, *a);
  mpq_clear(q);
  mpq_sub(*a, *b, *a);
}

SV * Rmpfr_ui_div(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_ui_div(*a, (unsigned long)SvUV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_d_div(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_d_div(*a, (double)SvNV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sqrt(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sqrt(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_rec_sqrt(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_rec_sqrt(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_cbrt(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_cbrt(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sqrt_ui(pTHX_ mpfr_t * a, SV * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sqrt_ui(*a, (unsigned long)SvUV(b), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow_ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_pow_ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow_uj(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
#if MPFR_VERSION >= 262656
#  ifdef MATH_MPFR_NEED_LONG_LONG_INT
    return newSViv(mpfr_pow_uj(*a, *b, (uintmax_t)SvUV(c), (mpfr_rnd_t)SvUV(round)));
#  else
    PERL_UNUSED_ARG4(a, b, c, round);
    croak("Rmpfr_pow_uj not implemented for this build of perl");
#  endif
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_pow_uj function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_pow_IV(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
  if(SV_IS_IOK(c)) {

#if defined(MATH_MPFR_NEED_LONG_LONG_INT)
#  if MPFR_VERSION >= 262656
    if(SvUOK(c)) {
      return newSViv(mpfr_pow_uj(*a, *b, (uintmax_t)SvUV(c), (mpfr_rnd_t)SvUV(round)));
    }
    return newSViv(mpfr_pow_sj(*a, *b, (intmax_t)SvIV(c), (mpfr_rnd_t)SvUV(round)));
#  else
    mpfr_t t;
    int ret;
    mpfr_init2(t, 64);
    if(SvUOK(c)) {
      mpfr_set_uj(t, (uintmax_t)SvUV(c), (mpfr_rnd_t)SvUV(round));
    }
    else {
      mpfr_set_sj(t, (intmax_t)SvIV(c), (mpfr_rnd_t)SvUV(round));
    }
    ret = mpfr_pow(*a, *b, t, (mpfr_rnd_t)SvUV(round));
    mpfr_clear(t);
    return newSViv(ret);
#  endif
#else
  if(SvUOK(c)) {
    return newSViv(mpfr_pow_ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
  }
    return newSViv(mpfr_pow_si(*a, *b, (unsigned long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
#endif
  }
  croak("Arg provided to Rmpfr_pow_IV is not an IV");
}

SV * Rmpfr_ui_pow_ui(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_ui_pow_ui(*a, (unsigned long)SvUV(b), (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_ui_pow(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_ui_pow(*a, (unsigned long)SvUV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_pow_si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_pow_sj(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
#if MPFR_VERSION >= 262656
#  ifdef MATH_MPFR_NEED_LONG_LONG_INT
    return newSViv(mpfr_pow_sj(*a, *b, (intmax_t)SvIV(c), (mpfr_rnd_t)SvUV(round)));
#  else
    PERL_UNUSED_ARG4(a, b, c, round);
    croak("Rmpfr_pow_sj not implemented for this build of perl");
#  endif
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_pow_sj function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_pow(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_pow(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_powr(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_powr(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
#else
  croak("Rmpfr_powr function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_pown(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
#if MPFR_VERSION >= 262656
#  ifdef MATH_MPFR_NEED_LONG_LONG_INT
    return newSViv(mpfr_pown(*a, *b, (intmax_t)SvIV(c), (mpfr_rnd_t)SvUV(round)));
#  else
    PERL_UNUSED_ARG4(a, b, c, round);
    croak("Rmpfr_pown not implemented for this build of perl");
#  endif
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_pown function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_compound_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_compound_si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_compound_si function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_compound(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
#if MPFR_VERSION >= 262912
  return newSViv(mpfr_compound(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_compound function not implemented until mpfr-4.3.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_neg(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_neg(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_abs(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_abs(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_2exp(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_mul_2exp(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_2ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_mul_2ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_2si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_mul_2si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_2exp(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_div_2exp(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_2ui(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_div_2ui(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_2si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_div_2si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

int Rmpfr_total_order_p(mpfr_t * a, mpfr_t * b) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= 262400 /* version 4.1.0 */
  return mpfr_total_order_p(*a, *b);
#else
  if(mpfr_nan_p(*a)) {
    if(mpfr_signbit(*a)) return 1;    /* *a <= *b */
    if(mpfr_nan_p(*b)) {
      if(mpfr_signbit(*b)) return 0;
      return 1;
    }
    return 0;
  }

  if(mpfr_nan_p(*b)) {
    if(mpfr_signbit(*b)) return 0;    /* *a > *b */
    return 1;
  }

  if(mpfr_zero_p(*a) && mpfr_zero_p(*b)) {
    if(!mpfr_signbit(*a) && mpfr_signbit(*b)) return 0; /* (*a, *b) is (+0, -0) */
    return 1; /* (*a, *b) is either (-0, -0) or (-0, +0) or (+0, +0) */
  }

  return mpfr_lessequal_p(*a, *b);
#endif
}

int Rmpfr_cmp(mpfr_t * a, mpfr_t * b) {
  return mpfr_cmp(*a, *b);
}

int Rmpfr_cmpabs(mpfr_t * a, mpfr_t * b) {
  return mpfr_cmpabs(*a, *b);
}

int Rmpfr_cmpabs_ui(mpfr_t * a, unsigned long b) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= 262400 /* version 4.1.0 */
  return mpfr_cmpabs_ui(*a, b);
#else
  PERL_UNUSED_ARG2(a, b);
  croak("The Rmpfr_cmpabs_ui function requires mpfr-4.1.0");
#endif
}

int Rmpfr_cmp_ui(mpfr_t * a, unsigned long b) {
  return mpfr_cmp_ui(*a, b);
}

int Rmpfr_cmp_si(mpfr_t * a, long b) {
  return mpfr_cmp_si(*a, b);
}

int Rmpfr_cmp_uj(pTHX_ mpfr_t * a, UV b) {
#if defined(MATH_MPFR_NEED_LONG_LONG_INT)
  int ret;
  mpfr_t temp;
  mpfr_init2(temp, 64);

  mpfr_set_uj(temp, b, GMP_RNDN);
  ret = mpfr_cmp(*a, temp);
  mpfr_clear(temp);
  return ret;
#else
  PERL_UNUSED_ARG2(a, b);
  croak("Rmpfr_cmp_uj is unavailable because MATH_MPFR_NEED_LONG_LONG_INT is not defined");
#endif
}

int Rmpfr_cmp_sj(pTHX_ mpfr_t * a, IV b) {
#if defined(MATH_MPFR_NEED_LONG_LONG_INT)
  int ret;
  mpfr_t temp;
  mpfr_init2(temp, 64);

  mpfr_set_sj(temp, b, GMP_RNDN);
  ret = mpfr_cmp(*a, temp);
  mpfr_clear(temp);
  return ret;
#else
  PERL_UNUSED_ARG2(a, b);
  croak("Rmpfr_cmp_sj is unavailable because MATH_MPFR_NEED_LONG_LONG_INT is not defined");
#endif
}

int Rmpfr_cmp_IV(pTHX_ mpfr_t *a, SV * b) {
  if(!SV_IS_IOK(b))
    croak("Arg provided to Rmpfr_cmp_IV is not an IV");

#if defined(MATH_MPFR_NEED_LONG_LONG_INT)
  if(SvUOK(b)) {
    return Rmpfr_cmp_uj(aTHX_ a, SvUV(b));
  }
  return Rmpfr_cmp_sj(aTHX_ a, SvIV(b));
#else
  if(SvUOK(b)) {
    return mpfr_cmp_ui(*a, SvUV(b));
  }
  return mpfr_cmp_si(*a, SvIV(b));
#endif
}

int Rmpfr_cmp_d(mpfr_t * a, double b) {
  return mpfr_cmp_d(*a, b);
}

int Rmpfr_cmp_ld(pTHX_ mpfr_t * a, SV * b) {
#if defined(USE_LONG_DOUBLE) || defined(USE_QUADMATH)
  return mpfr_cmp_ld(*a, (long double)SvNV(b));
#else
  PERL_UNUSED_ARG2(a, b);
  croak("Rmpfr_cmp_ld not implemented on this build of perl");
#endif
}

int Rmpfr_cmp_ui_2exp(pTHX_ mpfr_t * a, SV * b, SV * c) {
  return mpfr_cmp_ui_2exp(*a, (unsigned long)SvUV(b), (mpfr_exp_t)SvIV(c));
}

int Rmpfr_cmp_si_2exp(pTHX_ mpfr_t * a, SV * b, SV * c) {
  return mpfr_cmp_si_2exp(*a, (long)SvIV(b), (mpfr_exp_t)SvIV(c));
}

int Rmpfr_eq(mpfr_t * a, mpfr_t * b, unsigned long c) {
  return mpfr_eq(*a, *b, c);
}

int Rmpfr_nan_p(mpfr_t * p) {
  return mpfr_nan_p(*p);
}

int Rmpfr_inf_p(mpfr_t * p) {
  return mpfr_inf_p(*p);
}

int Rmpfr_number_p(mpfr_t * p) {
  return mpfr_number_p(*p);
}

void Rmpfr_reldiff(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  mpfr_reldiff(*a, *b, *c, (mpfr_rnd_t)SvUV(round));
}

int Rmpfr_sgn(mpfr_t * p) {
  return mpfr_sgn(*p);
}

int Rmpfr_greater_p(mpfr_t * a, mpfr_t * b) {
  return mpfr_greater_p(*a, *b);
}

int Rmpfr_greaterequal_p(mpfr_t * a, mpfr_t * b) {
  return mpfr_greaterequal_p(*a, *b);
}

int Rmpfr_less_p(mpfr_t * a, mpfr_t * b) {
  return mpfr_less_p(*a, *b);
}

int Rmpfr_lessequal_p(mpfr_t * a, mpfr_t * b) {
  return mpfr_lessequal_p(*a, *b);
}

int Rmpfr_lessgreater_p(mpfr_t * a, mpfr_t * b) {
  return mpfr_lessgreater_p(*a, *b);
}

int Rmpfr_equal_p(mpfr_t * a, mpfr_t * b) {
  return mpfr_equal_p(*a, *b);
}

int Rmpfr_unordered_p(mpfr_t * a, mpfr_t * b) {
  return mpfr_unordered_p(*a, *b);
}

SV * Rmpfr_sin_cos(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sin_cos(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sinh_cosh(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sinh_cosh(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sin(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sin(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sinu(pTHX_ mpfr_t *a, mpfr_t *b, unsigned long c, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_sinu(*a, *b, c, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_sinu function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_sinpi(pTHX_ mpfr_t *a, mpfr_t *b, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_sinpi(*a, *b, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG3(a, b, round);
  croak("Rmpfr_sinpi function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_cos(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_cos(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_cosu(pTHX_ mpfr_t *a, mpfr_t *b, unsigned long c, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_cosu(*a, *b, c, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_cosu function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_cospi(pTHX_ mpfr_t *a, mpfr_t *b, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_cospi(*a, *b, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG3(a, b, round);
  croak("Rmpfr_cospi function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_tan(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_tan(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_tanu(pTHX_ mpfr_t *a, mpfr_t *b, unsigned long c, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_tanu(*a, *b, c, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_tanu function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_tanpi(pTHX_ mpfr_t *a, mpfr_t *b, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_tanpi(*a, *b, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG3(a, b, round);
  croak("Rmpfr_tanpi function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_asin(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_asin(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_asinu(pTHX_ mpfr_t *a, mpfr_t *b, unsigned long c, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_asinu(*a, *b, c, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_asinu function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_asinpi(pTHX_ mpfr_t *a, mpfr_t *b, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_asinpi(*a, *b, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG3(a, b, round);
  croak("Rmpfr_asinpi function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_acos(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_acos(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_acosu(pTHX_ mpfr_t *a, mpfr_t *b, unsigned long c, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_acosu(*a, *b, c, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_acosu function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_acospi(pTHX_ mpfr_t *a, mpfr_t *b, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_acospi(*a, *b, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG3(a, b, round);
  croak("Rmpfr_acospi function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_atan(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_atan(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_atanu(pTHX_ mpfr_t *a, mpfr_t *b, unsigned long c, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_atanu(*a, *b, c, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_atanu function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_atanpi(pTHX_ mpfr_t *a, mpfr_t *b, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_atanpi(*a, *b, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG3(a, b, round);
  croak("Rmpfr_atanpi function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_sinh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sinh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_cosh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_cosh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_tanh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_tanh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_asinh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_asinh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_acosh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_acosh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_atanh(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_atanh(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fac_ui(pTHX_ mpfr_t * a, SV * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_fac_ui(*a, (unsigned long)SvUV(b), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_log1p(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_log1p(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_expm1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_expm1(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_exp2m1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_exp2m1(*a, *b, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG3(a, b, round);
  croak("Rmpfr_exp2m1 function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_exp10m1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_exp10m1(*a, *b, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG3(a, b, round);
  croak("Rmpfr_exp10m1 function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_log2(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_log2(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_log2p1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_log2p1(*a, *b, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG3(a, b, round);
  croak("Rmpfr_log2p1 function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_log10(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_log10(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_log10p1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_log10p1(*a, *b, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG3(a, b, round);
  croak("Rmpfr_log10p1 function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_fma(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, mpfr_t * d, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_fma(*a, *b, *c, *d, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fms(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, mpfr_t * d, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_fms(*a, *b, *c, *d, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_agm(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_agm(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_hypot(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_hypot(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_log2(pTHX_ mpfr_t * p, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_const_log2(*p, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_pi(pTHX_ mpfr_t * p, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_const_pi(*p, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_euler(pTHX_ mpfr_t * p, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_const_euler(*p, (mpfr_rnd_t)SvUV(round)));
}

/*
Removed in Math-MPFR-3.30. Should have been removed much earlier
void Rmpfr_print_binary(mpfr_t * p) {
  mpfr_print_binary(*p);
}
*/

SV * Rmpfr_rint(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_rint(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

int Rmpfr_ceil(mpfr_t * a, mpfr_t * b) {
  return mpfr_ceil(*a, *b);
}

int Rmpfr_floor(mpfr_t * a, mpfr_t * b) {
  return mpfr_floor(*a, *b);
}

int Rmpfr_round(mpfr_t * a, mpfr_t * b) {
  return mpfr_round(*a, *b);
}

int Rmpfr_trunc(mpfr_t * a, mpfr_t * b) {
  return mpfr_trunc(*a, *b);
}

/* NO LONGER SUPPORTED - use Rmpfr_nextabove instead
SV * Rmpfr_add_one_ulp(mpfr_t * p, SV * round) {
  return newSViv(mpfr_add_one_ulp(*p, (mpfr_rnd_t)SvUV(round)));
} */

/* NO LONGER SUPPORTED - use Rmpfr_nextbelow instead
SV * Rmpfr_sub_one_ulp(mpfr_t * p, SV * round) {
  return newSViv(mpfr_sub_one_ulp(*p, (mpfr_rnd_t)SvUV(round)));
} */

SV * Rmpfr_can_round(pTHX_ mpfr_t * p, SV * err, SV * round1, SV * round2, SV * prec) {
#if MPFR_VERSION_MAJOR < 3
  if((mpfr_rnd_t)SvUV(round1) > 3 || (mpfr_rnd_t)SvUV(round2) > 3) {
    PERL_UNUSED_ARG5(p, err, round1, round2, prec);
    croak("Illegal rounding value supplied for this version (%s) of the mpfr library", MPFR_VERSION_STRING);
  }
#endif
  return newSViv(mpfr_can_round(*p, (mpfr_exp_t)SvIV(err), SvUV(round1), SvUV(round2), (mpfr_prec_t)SvIV(prec)));
}

SV * Rmpfr_print_rnd_mode(pTHX_ SV * rnd) {
  const char * x = mpfr_print_rnd_mode((mpfr_rnd_t)SvIV(rnd));
  if(x == NULL) return &PL_sv_undef;
  return newSVpv(x, 0);
}

SV * Rmpfr_get_emin(pTHX) {
  return newSViv(mpfr_get_emin());
}

SV * Rmpfr_get_emax(pTHX) {
  return newSViv(mpfr_get_emax());
}

int Rmpfr_set_emin(pTHX_ SV * e) {
  return mpfr_set_emin((mpfr_exp_t)SvIV(e));
}

int Rmpfr_set_emax(pTHX_ SV * e) {
  return mpfr_set_emax((mpfr_exp_t)SvIV(e));
}

SV * Rmpfr_check_range(pTHX_ mpfr_t * p, SV * t, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_check_range(*p, (int)SvIV(t), (mpfr_rnd_t)SvUV(round)));
}

void Rmpfr_clear_underflow(void) {
  mpfr_clear_underflow();
}

void Rmpfr_clear_overflow(void) {
  mpfr_clear_overflow();
}

void Rmpfr_clear_nanflag(void) {
  mpfr_clear_nanflag();
}

void Rmpfr_clear_inexflag(void) {
  mpfr_clear_inexflag();
}

void Rmpfr_clear_flags(void) {
  mpfr_clear_flags();
}

int Rmpfr_underflow_p(void) {
  return mpfr_underflow_p();
}

int Rmpfr_overflow_p(void) {
  return mpfr_overflow_p();
}

int Rmpfr_nanflag_p(void) {
  return mpfr_nanflag_p();
}

int Rmpfr_inexflag_p(void) {
  return mpfr_inexflag_p();
}

SV * Rmpfr_log(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_log(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_exp(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_exp(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_exp2(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_exp2(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_exp10(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_exp10(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

void Rmpfr_urandomb(pTHX_ SV * x, ...) {
  dXSARGS;
  unsigned long i, t;
  PERL_UNUSED_ARG(x);

  t = items;
  --t;

  for(i = 0; i < t; ++i) {
    mpfr_urandomb(*(INT2PTR(mpfr_t *, SvIVX(SvRV(ST(i))))), *(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(ST(t))))));
  }
  XSRETURN(0);
}

void Rmpfr_random2(pTHX_ mpfr_t * p, SV * s, SV * exp) {
#if MPFR_VERSION_MAJOR > 2
  PERL_UNUSED_ARG3(p, s, exp);
  croak("Rmpfr_random2 no longer implemented. Use Rmpfr_urandom or Rmpfr_urandomb");
#else
  mpfr_random2(*p, (int)SvIV(s), (mpfr_exp_t)SvIV(exp));
#endif
}

SV * _TRmpfr_out_str(pTHX_ FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round) {
  size_t ret;

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_OUTPUT_BASE )
    croak("2nd argument supplied to TRmpfr_out_str is out of allowable range" );

  ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
  fflush(stream);
  return newSVuv(ret);
}

SV * _Rmpfr_out_str(pTHX_ mpfr_t * p, SV * base, SV * dig, SV * round) {
  size_t ret;

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_OUTPUT_BASE )
    croak("2nd argument supplied to Rmpfr_out_str is out of allowable range" );

  ret = mpfr_out_str(stdout, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
  fflush(stdout);
  return newSVuv(ret);
}

SV * _TRmpfr_out_strS(pTHX_ FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round, SV * suff) {
  size_t ret;

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_OUTPUT_BASE )
    croak("2nd argument supplied to TRmpfr_out_str is out of allowable range" );

  ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
  fflush(stream);
  fprintf(stream, "%s", SvPV_nolen(suff));
  fflush(stream);
  return newSVuv(ret);
}

SV * _TRmpfr_out_strP(pTHX_ SV * pre, FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round) {
  size_t ret;

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_OUTPUT_BASE )
    croak("3rd argument supplied to TRmpfr_out_str is out of allowable range" );

  fprintf(stream, "%s", SvPV_nolen(pre));
  fflush(stream);
  ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
  fflush(stream);
  return newSVuv(ret);
}

SV * _TRmpfr_out_strPS(pTHX_ SV * pre, FILE * stream, SV * base, SV * dig, mpfr_t * p, SV * round, SV * suff) {
  size_t ret;

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_OUTPUT_BASE )
    croak("3rd argument supplied to TRmpfr_out_str is out of allowable range" );

  fprintf(stream, "%s", SvPV_nolen(pre));
  fflush(stream);
  ret = mpfr_out_str(stream, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
  fflush(stream);
  fprintf(stream, "%s", SvPV_nolen(suff));
  fflush(stream);
  return newSVuv(ret);
}

SV * _Rmpfr_out_strS(pTHX_ mpfr_t * p, SV * base, SV * dig, SV * round, SV * suff) {
  size_t ret;

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_OUTPUT_BASE )
    croak("2nd argument supplied to Rmpfr_out_str is out of allowable range" );

  ret = mpfr_out_str(stdout, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
  printf("%s", SvPV_nolen(suff));
  fflush(stdout);
  return newSVuv(ret);
}

SV * _Rmpfr_out_strP(pTHX_ SV * pre, mpfr_t * p, SV * base, SV * dig, SV * round) {
  size_t ret;

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_OUTPUT_BASE )
    croak("3rd argument supplied to Rmpfr_out_str is out of allowable range" );

  printf("%s", SvPV_nolen(pre));
  ret = mpfr_out_str(stdout, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
  fflush(stdout);
  return newSVuv(ret);
}

SV * _Rmpfr_out_strPS(pTHX_ SV * pre, mpfr_t * p, SV * base, SV * dig, SV * round, SV * suff) {
  size_t ret;

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_OUTPUT_BASE )
    croak("3rd argument supplied to Rmpfr_out_str is out of allowable range" );

  printf("%s", SvPV_nolen(pre));
  ret = mpfr_out_str(stdout, (int)SvIV(base), (size_t)SvUV(dig), *p, (mpfr_rnd_t)SvUV(round));
  printf("%s", SvPV_nolen(suff));
  fflush(stdout);
  return newSVuv(ret);
}

SV * TRmpfr_inp_str(pTHX_ mpfr_t * p, FILE * stream, SV * base, SV * round) {
  size_t ret;

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_INPUT_BASE )
    croak("3rd argument supplied to TRmpfr_inp_str is out of allowable range" );

  ret = mpfr_inp_str(*p, stream, (int)SvIV(base), (mpfr_rnd_t)SvUV(round));
  if(!ret) {
    nnum++;
    if(SvIV(get_sv("Math::MPFR::NNW", 0)))
      warn("input to TRmpfr_inp_str contains non-numeric characters");
  }
  /* fflush(stream); */
  return newSVuv(ret);
}

SV * Rmpfr_inp_str(pTHX_ mpfr_t * p, SV * base, SV * round) {
  size_t ret;

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_INPUT_BASE )
    croak("2nd argument supplied to Rmpfr_inp_str is out of allowable range" );

  ret = mpfr_inp_str(*p, stdin, (int)SvIV(base), (mpfr_rnd_t)SvUV(round));
  if(!ret) {
    nnum++;
    if(SvIV(get_sv("Math::MPFR::NNW", 0)))
      warn("input to Rmpfr_inp_str contains non-numeric characters");
  }
  /* fflush(stdin); */
  return newSVuv(ret);
}

SV * Rmpfr_gamma(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_gamma(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_zeta(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_zeta(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_zeta_ui(pTHX_ mpfr_t * a, SV * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_zeta_ui(*a, (unsigned long)SvUV(b), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_erf(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_erf(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_frac(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_frac(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_remainder(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_remainder(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_modf(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_modf(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fmod(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_fmod(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fmod_ui(pTHX_ mpfr_t * a, mpfr_t * b, unsigned long c, SV * round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_fmod_ui(*a, *b, c, (mpfr_rnd_t)SvUV(round)));
#else
  mpfr_t temp;
  int ret;
  CHECK_ROUNDING_VALUE
  mpfr_init2(temp, LONGSIZE * 8);
  mpfr_set_ui(temp, c, GMP_RNDN);
  ret = mpfr_fmod(*a, *b, temp, (mpfr_rnd_t)SvUV(round));
  mpfr_clear(temp);
  return newSViv(ret);
#endif
}

void Rmpfr_remquo(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  dXSARGS;
  long ret, q;
  PERL_UNUSED_ARG(items);
  CHECK_ROUNDING_VALUE
  ret = mpfr_remquo(*a, &q, *b, *c, (mpfr_rnd_t)SvUV(round));
  ST(0) = sv_2mortal(newSViv(q));
  ST(1) = sv_2mortal(newSViv(ret));
  XSRETURN(2);
}

int Rmpfr_integer_p(mpfr_t * p) {
  return mpfr_integer_p(*p);
}

void Rmpfr_nexttoward(mpfr_t * a, mpfr_t * b) {
  mpfr_nexttoward(*a, *b);
}

void Rmpfr_nextabove(mpfr_t * p) {
  mpfr_nextabove(*p);
}

void Rmpfr_nextbelow(mpfr_t * p) {
  mpfr_nextbelow(*p);
}

SV * Rmpfr_min(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_min(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_max(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_max(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_exp(pTHX_ mpfr_t * p) {
  return newSViv(mpfr_get_exp(*p));
}

SV * Rmpfr_set_exp(pTHX_ mpfr_t * p, SV * exp) {
  return newSViv(mpfr_set_exp(*p, (mpfr_exp_t)SvIV(exp)));
}

int Rmpfr_signbit(mpfr_t * op) {
  return mpfr_signbit(*op);
}

SV * Rmpfr_setsign(pTHX_ mpfr_t * rop, mpfr_t * op, SV * sign, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_setsign(*rop, *op, SvIV(sign), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_copysign(pTHX_ mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_copysign(*rop, *op1, *op2, (mpfr_rnd_t)SvUV(round)));
}

SV * get_refcnt(pTHX_ SV * s) {
  return newSVuv(SvREFCNT(s));
}

SV * get_package_name(pTHX_ SV * x) {
  if(sv_isobject(x)) return newSVpv(HvNAME(SvSTASH(SvRV(x))), 0);
  return newSViv(0);
}

void Rmpfr_dump(mpfr_t * a) { /* Once took a 'round' argument */
  mpfr_dump(*a);
}

SV * gmp_v(pTHX) {
#if __GNU_MP_VERSION >= 4
  return newSVpv(gmp_version, 0);
#else
  warn("From Math::MPFR::gmp_v(aTHX): 'gmp_version' is not implemented - returning '0'");
  return newSVpv("0", 0);
#endif
}

/* NEW in MPFR-2.1.0 */

SV * Rmpfr_set_ui_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
  return newSViv(mpfr_set_ui_2exp(*a, (unsigned long)SvUV(b), (mpfr_exp_t)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_si_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
   return newSViv(mpfr_set_si_2exp(*a, (long)SvIV(b), (mpfr_exp_t)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_uj_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  return newSViv(mpfr_set_uj_2exp(*a, SvUV(b), SvIV(c), (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak ("Rmpfr_set_uj_2exp not implemented on this build of perl");
#endif
}

SV * Rmpfr_set_sj_2exp(pTHX_ mpfr_t * a, SV * b, SV * c, SV * round) {
  CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  return newSViv(mpfr_set_sj_2exp(*a, SvIV(b), SvIV(c), (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak ("Rmpfr_set_sj_2exp not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_z(pTHX_ mpz_t * a, mpfr_t * b, SV * round) {
  if(!mpfr_number_p(*b)) croak("In Rmpfr_get_z: Cannot coerce an 'Inf' or 'NaN' to a Math::GMPz object");
#if MPFR_VERSION_MAJOR < 3
  CHECK_ROUNDING_VALUE
  mpfr_get_z(*a, *b, (mpfr_rnd_t)SvUV(round));
  return &PL_sv_undef;
#else
  PERL_UNUSED_ARG3(a, b, round);
  return newSViv(mpfr_get_z(*a, *b, (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_si_sub(pTHX_ mpfr_t * a, SV * c, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  DEAL_WITH_NANFLAG_BUG
  return newSViv(mpfr_si_sub(*a, (long)SvIV(c), *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sub_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
  CHECK_ROUNDING_VALUE
  DEAL_WITH_NANFLAG_BUG
  return newSViv(mpfr_sub_si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_mul_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_mul_si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_si_div(pTHX_ mpfr_t * a, SV * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_si_div(*a, (long)SvIV(b), *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_div_si(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round){
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_div_si(*a, *b, (long)SvIV(c), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sqr(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sqr(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

int Rmpfr_cmp_z(mpfr_t * a, mpz_t * b) {
  return mpfr_cmp_z(*a, *b);
}

int Rmpfr_cmp_q(mpfr_t * a, mpq_t * b) {
  return mpfr_cmp_q(*a, *b);
}

int fr_cmp_q_rounded(pTHX_ mpfr_t * a, mpq_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  mpfr_t temp;
  int ret;
  mpfr_init(temp);
  mpfr_set_q(temp, *b, (mpfr_rnd_t)SvUV(round));
  ret = mpfr_cmp(*a, temp);
  mpfr_clear(temp);
  return ret;
}

int Rmpfr_cmp_f(mpfr_t * a, mpf_t * b) {
  return mpfr_cmp_f(*a, *b);
}

int Rmpfr_zero_p(mpfr_t * a) {
  return mpfr_zero_p(*a);
}

void Rmpfr_free_cache(void) {
  mpfr_free_cache();
}

void Rmpfr_free_cache2(unsigned int way) {
#if MPFR_VERSION_MAJOR >= 4
  mpfr_free_cache2((mpfr_free_cache_t) way);
#else
  PERL_UNUSED_ARG(way);
  croak("Rmpfr_free_cache2 not implemented with this mpfr version (%s) - need 4.0.0 or later", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_free_pool(void) {
#if MPFR_VERSION_MAJOR >= 4
  mpfr_free_pool();
#else
  croak("Rmpfr_free_pool not implemented with this mpfr version (%s) - need 4.0.0 or later", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_get_version(pTHX) {
  return newSVpv(mpfr_get_version(), 0);
}

SV * Rmpfr_get_patches(pTHX) {
  return newSVpv(mpfr_get_patches(), 0);
}

SV * Rmpfr_get_emin_min(pTHX) {
  return newSViv(mpfr_get_emin_min());
}

SV * Rmpfr_get_emin_max(pTHX) {
  return newSViv(mpfr_get_emin_max());
}

SV * Rmpfr_get_emax_min(pTHX) {
  return newSViv(mpfr_get_emax_min());
}

SV * Rmpfr_get_emax_max(pTHX) {
  return newSViv(mpfr_get_emax_max());
}

void Rmpfr_clear_erangeflag(void) {
  mpfr_clear_erangeflag();
}

int Rmpfr_erangeflag_p(void) {
  return mpfr_erangeflag_p();
}

SV * Rmpfr_rint_round(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_rint_round(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_rint_trunc(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_rint_trunc(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_rint_ceil(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_rint_ceil(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_rint_floor(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_rint_floor(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_ui(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSVuv(mpfr_get_ui(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_si(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_get_si(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_uj(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  return newSVuv(mpfr_get_uj(*a, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG2(a, round);
  croak ("Rmpfr_get_uj not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_sj(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  return newSViv(mpfr_get_sj(*a, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG2(a, round);
  croak ("Rmpfr_get_sj not implemented on this build of perl");
#endif
}

SV * Rmpfr_get_IV(pTHX_ mpfr_t * x, SV * round) {
  CHECK_ROUNDING_VALUE

  /* FLAGS:                                                                *
   * This will set the erange flag if *x is NaN or if *x overflows the IV  *
   * If the erangeflag does not get set, then the inexact flag will be set *
   * if *x is not an integer.                                              */

#if defined MATH_MPFR_NEED_LONG_LONG_INT

  if(mpfr_fits_uintmax_p(*x, (mpfr_rnd_t)SvNV(round)))
    return newSVuv(mpfr_get_uj(*x, (mpfr_rnd_t)SvUV(round)));
  if(mpfr_fits_intmax_p(*x, (mpfr_rnd_t)SvNV(round)))
    return newSViv(mpfr_get_sj(*x, (mpfr_rnd_t)SvUV(round)));

  if(mpfr_sgn(*x) < 0)
    return newSViv(mpfr_get_sj(*x, (mpfr_rnd_t)SvUV(round))); /* returns IV_MIN     */

  return newSVuv(mpfr_get_uj(*x, (mpfr_rnd_t)SvUV(round)));   /* returns UV_MAX, or *
                                                                  * 0 if *x is NaN     */

#else
  if(mpfr_fits_ulong_p(*x, (mpfr_rnd_t)SvNV(round)))
    return newSVuv(mpfr_get_ui(*x, (mpfr_rnd_t)SvUV(round)));
  if(mpfr_fits_slong_p(*x, (mpfr_rnd_t)SvNV(round)))
    return newSViv(mpfr_get_si(*x, (mpfr_rnd_t)SvUV(round)));

  if(mpfr_sgn(*x) < 0)
    return newSViv(mpfr_get_si(*x, (mpfr_rnd_t)SvUV(round))); /* returns IV_MIN     */

  return newSVuv(mpfr_get_ui(*x, (mpfr_rnd_t)SvUV(round)));   /* returns UV_MAX, or *
                                                                  * 0 if *x is NaN     */
#endif
}

int Rmpfr_set_IV(pTHX_ mpfr_t * x, SV * sv,  SV * round) {
  CHECK_ROUNDING_VALUE

  if(!SV_IS_IOK(sv))
    croak("Arg provided to Rmpfr_set_IV is not an IV");

#if defined MATH_MPFR_NEED_LONG_LONG_INT
  if(SvUOK(sv))
    return mpfr_set_uj(*x, SvUV(sv), (mpfr_rnd_t)SvNV(round));

  return mpfr_set_sj(*x, SvIV(sv), (mpfr_rnd_t)SvNV(round));
#else
  if(SvUOK(sv))
    return mpfr_set_ui(*x, SvUV(sv), (mpfr_rnd_t)SvNV(round));

  return mpfr_set_si(*x, SvIV(sv), (mpfr_rnd_t)SvNV(round));
#endif
}

void Rmpfr_init_set_IV(pTHX_ SV * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set_IV) /* defined in math_mpfr_include.h */

  mpfr_init(*mpfr_t_obj);
  sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
  ret = Rmpfr_set_IV(aTHX_ mpfr_t_obj, q, round);
  SvREADONLY_on(obj);
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

void Rmpfr_init_set_IV_nobless(pTHX_ SV * q, SV * round) {
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT(NULL,Rmpfr_init_set_IV_nobless) /* defined in math_mpfr_include.h */

  mpfr_init(*mpfr_t_obj);
  sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
  ret = Rmpfr_set_IV(aTHX_ mpfr_t_obj, q, round);
  SvREADONLY_on(obj);
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
}

SV * Rmpfr_get_NV(pTHX_ mpfr_t * x, SV * round) {
  CHECK_ROUNDING_VALUE

#if defined(CAN_PASS_FLOAT128)
  return newSVnv(mpfr_get_float128(*x, (mpfr_rnd_t)SvUV(round)));
#elif defined(USE_QUADMATH)

  mpfr_t t;
  int i, c = 0;
  mpfr_prec_t exp, bits = 113;
  mpfr_rnd_t r = (mpfr_rnd_t)SvUV(round);
  char *out;
  float128 ret = 0.0Q, sign = 1.0Q;

  float128 add_on[113] = {
   5192296858534827628530496329220096e0Q, 2596148429267413814265248164610048e0Q,
   1298074214633706907132624082305024e0Q, 649037107316853453566312041152512e0Q,
   324518553658426726783156020576256e0Q, 162259276829213363391578010288128e0Q,
   81129638414606681695789005144064e0Q, 40564819207303340847894502572032e0Q,
   20282409603651670423947251286016e0Q, 10141204801825835211973625643008e0Q,
   5070602400912917605986812821504e0Q, 2535301200456458802993406410752e0Q,
   1267650600228229401496703205376e0Q, 633825300114114700748351602688e0Q,
   316912650057057350374175801344e0Q, 158456325028528675187087900672e0Q, 79228162514264337593543950336e0Q,
   39614081257132168796771975168e0Q, 19807040628566084398385987584e0Q, 9903520314283042199192993792e0Q,
   4951760157141521099596496896e0Q, 2475880078570760549798248448e0Q, 1237940039285380274899124224e0Q,
   618970019642690137449562112e0Q, 309485009821345068724781056e0Q, 154742504910672534362390528e0Q,
   77371252455336267181195264e0Q, 38685626227668133590597632e0Q, 19342813113834066795298816e0Q,
   9671406556917033397649408e0Q, 4835703278458516698824704e0Q, 2417851639229258349412352e0Q,
   1208925819614629174706176e0Q, 604462909807314587353088e0Q, 302231454903657293676544e0Q,
   151115727451828646838272e0Q, 75557863725914323419136e0Q, 37778931862957161709568e0Q,
   18889465931478580854784e0Q, 9444732965739290427392e0Q, 4722366482869645213696e0Q,
   2361183241434822606848e0Q, 1180591620717411303424e0Q, 590295810358705651712e0Q, 295147905179352825856e0Q,
   147573952589676412928e0Q, 73786976294838206464e0Q, 36893488147419103232e0Q, 18446744073709551616e0Q,
   9223372036854775808e0Q, 4611686018427387904e0Q, 2305843009213693952e0Q, 1152921504606846976e0Q,
   576460752303423488e0Q, 288230376151711744e0Q, 144115188075855872e0Q, 72057594037927936e0Q,
   36028797018963968e0Q, 18014398509481984e0Q, 9007199254740992e0Q, 4503599627370496e0Q,
   2251799813685248e0Q, 1125899906842624e0Q, 562949953421312e0Q, 281474976710656e0Q, 140737488355328e0Q,
   70368744177664e0Q, 35184372088832e0Q, 17592186044416e0Q, 8796093022208e0Q, 4398046511104e0Q,
   2199023255552e0Q, 1099511627776e0Q, 549755813888e0Q, 274877906944e0Q, 137438953472e0Q, 68719476736e0Q,
   34359738368e0Q, 17179869184e0Q, 8589934592e0Q, 4294967296e0Q, 2147483648e0Q, 1073741824e0Q, 536870912e0Q,
   268435456e0Q, 134217728e0Q, 67108864e0Q, 33554432e0Q, 16777216e0Q, 8388608e0Q, 4194304e0Q, 2097152e0Q,
   1048576e0Q, 524288e0Q, 262144e0Q, 131072e0Q, 65536e0Q, 32768e0Q, 16384e0Q, 8192e0Q, 4096e0Q, 2048e0Q,
   1024e0Q, 512e0Q, 256e0Q, 128e0Q, 64e0Q, 32e0Q, 16e0Q, 8e0Q, 4e0Q, 2e0Q, 1e0Q };

  if(!mpfr_regular_p(*x)) return newSVnv((float128)mpfr_get_d(*x, GMP_RNDZ));

  exp = mpfr_get_exp(*x);
  if(exp < -16381)
    bits = exp + 16494;

  if(bits <= 0) {
    mpfr_init2(t, 53);
    if(mpfr_sgn(*x) > 0) {	/* positive */
      mpfr_set_str(t, "0.1e-16494", 2, GMP_RNDZ);
      c = mpfr_cmp(*x, t);
      mpfr_clear(t);
      if(c <= 0) {
        if(r == GMP_RNDN || r == GMP_RNDD || r == GMP_RNDZ) return newSVnv(0.0Q);
        return newSVnv(0x1p-16494Q);
      }
      else {
        if(r == GMP_RNDN || r == GMP_RNDU || r == MPFR_RNDA)
          return newSVnv(0x1p-16494Q);
        return newSVnv(0.0Q);
      }
    }
    else {			/* negative */
      mpfr_set_str(t, "-0.1e-16494", 2, GMP_RNDZ);
      c = mpfr_cmp(*x, t);
      mpfr_clear(t);
      if(c >= 0) {
        if(r == GMP_RNDN || r == GMP_RNDU || r == GMP_RNDZ) return newSVnv(0.0Q);
        return newSVnv(-0x1p-16494Q);
      }
      if(c < 0) {
        if(r == GMP_RNDN || r == GMP_RNDD || r == MPFR_RNDA)
          return newSVnv(-0x1p-16494Q);
        return newSVnv(0.0Q);
      }
    }
  }
  else {
    mpfr_init2(t, bits);
    mpfr_set(t, *x, r);
  }

  Newxz(out, 115, char);
  if(out == NULL) croak("Failed to allocate memory in Rmpfr_get_NV function");

  mpfr_get_str(out, &exp, 2, 113, t, (mpfr_rnd_t)SvUV(round));

  mpfr_clear(t);

  if(out[0] == '-') {
    sign = -1.0Q;
    out++;
    c++;
  }
  else {
    if(out[0] == '+') {
      out++;
      c++;
    }
  }

  for(i = 0; i < bits; i++) {
    if(out[i] == '1') ret += add_on[i];
  }

  if(c) out--;
  Safefree(out);

  c = exp < -16381 ? exp + 16381 : 0;	/* function has already returned if exp < -16494 */

  if(c) { 			/* powq(2.0Q, exp) will be zero - so do the calculation in 2 steps */
    ret *= powq(2.0Q, c);
    exp -= c;		/* exp += abs(c) */
  }

  ret *= powq(2.0Q, exp - 113);
  return newSVnv(ret * sign);

#elif defined(USE_LONG_DOUBLE)
#  if defined(LD_SUBNORMAL_BUG)

    if(mpfr_get_exp(*x) < -16381 && mpfr_regular_p(*x) && mpfr_get_exp(*x) >= -16445 ) {
      warn("\n mpfr_get_ld is buggy (subnormal values only)\n for this version (%s) of the MPFR library\n", MPFR_VERSION_STRING);
      croak(" Version 3.1.5 or later is required");
    }

    return newSVnv(mpfr_get_ld(*x, (mpfr_rnd_t)SvUV(round)));

#  else
    return newSVnv(mpfr_get_ld(*x, (mpfr_rnd_t)SvUV(round)));
#  endif
#else
  return newSVnv(mpfr_get_d(*x, (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_ulong_p(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
  return newSVuv(mpfr_fits_ulong_p(*a, (mpfr_rnd_t)SvUV(round)));
#else
  if((mpfr_rnd_t)SvUV(round) < 3) {
    if((mpfr_rnd_t)SvUV(round) == 0) {
      if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
    }
    else {
      if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
    }
  }
  return newSVuv(mpfr_fits_ulong_p(*a, (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_slong_p(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSVuv(mpfr_fits_slong_p(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_ushort_p(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
  return newSVuv(mpfr_fits_ushort_p(*a, (mpfr_rnd_t)SvUV(round)));
#else
  if((mpfr_rnd_t)SvUV(round) < 3) {
    if((mpfr_rnd_t)SvUV(round) == 0) {
      if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
    }
    else {
      if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
    }
  }
  return newSVuv(mpfr_fits_ushort_p(*a, (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_sshort_p(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSVuv(mpfr_fits_sshort_p(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_uint_p(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
  return newSVuv(mpfr_fits_uint_p(*a, (mpfr_rnd_t)SvUV(round)));
#else
  if((mpfr_rnd_t)SvUV(round) < 3) {
    if((mpfr_rnd_t)SvUV(round) == 0) {
      if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
    }
    else {
      if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
    }
  }
  return newSVuv(mpfr_fits_uint_p(*a, (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_sint_p(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSVuv(mpfr_fits_sint_p(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_uintmax_p(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
#if defined(MPFR_VERSION) && MPFR_VERSION > NEG_ZERO_BUG
  return newSVuv(mpfr_fits_uintmax_p(*a, (mpfr_rnd_t)SvUV(round)));
#else
  if(mpfr_zero_p(*a)) return newSVuv(1);
  if((mpfr_rnd_t)SvUV(round) < 3) {
    if((mpfr_rnd_t)SvUV(round) == 0) {
      if((mpfr_cmp_d(*a, -0.5) >= 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
    }
    else {
      if((mpfr_cmp_d(*a, -1.0) > 0) && (mpfr_cmp_d(*a, 0.0) <= 0)) return newSVuv(1);
    }
  }
  return newSVuv(mpfr_fits_uintmax_p(*a, (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_fits_intmax_p(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSVuv(mpfr_fits_intmax_p(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_fits_IV_p(pTHX_ mpfr_t * x, SV * round) {
  CHECK_ROUNDING_VALUE
#if defined(MATH_MPFR_NEED_LONG_LONG_INT)
  if(mpfr_fits_uintmax_p(*x, (mpfr_rnd_t)SvUV(round))
        ||
     mpfr_fits_intmax_p (*x, (mpfr_rnd_t)SvUV(round))) return newSViv(1);
  return newSViv(0);
#else
  if(mpfr_fits_ulong_p(*x, (mpfr_rnd_t)SvUV(round))
        ||
     mpfr_fits_slong_p (*x, (mpfr_rnd_t)SvUV(round))) return newSViv(1);
  return newSViv(0);
#endif
}


SV * Rmpfr_strtofr(pTHX_ mpfr_t * a, SV * str, SV * base, SV * round) {
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif

  CHECK_ROUNDING_VALUE

  if( FAILS_CHECK_INPUT_BASE )
    croak("3rd argument supplied to Rmpfr_strtofr is out of allowable range");

#ifdef _WIN32_BIZARRE_INFNAN
  inf_or_nan = _win32_infnanstring(SvPV_nolen(str));
  if(inf_or_nan) {
    if(inf_or_nan == 2) {
      mpfr_set_nan(*a);
      return newSViv(0);
    }

    mpfr_set_inf(*a, inf_or_nan);
    return newSViv(0);
  }
  else {
    return newSViv(mpfr_strtofr(*a, SvPV_nolen(str), NULL, (int)SvIV(base), (mpfr_rnd_t)SvUV(round)));
  }
#else
  return newSViv(mpfr_strtofr(*a, SvPV_nolen(str), NULL, (int)SvIV(base), (mpfr_rnd_t)SvUV(round)));
#endif
}

void Rmpfr_set_erangeflag(void) {
  mpfr_set_erangeflag();
}

void Rmpfr_set_underflow(void) {
  mpfr_set_underflow();
}

void Rmpfr_set_overflow(void) {
  mpfr_set_overflow();
}

void Rmpfr_set_nanflag(void) {
  mpfr_set_nanflag();
}

void Rmpfr_set_inexflag(void) {
  mpfr_set_inexflag();
}

SV * Rmpfr_erfc(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_erfc(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_j0(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_j0(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_j1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_j1(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_jn(pTHX_ mpfr_t * a, SV * n, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_jn(*a, (long)SvIV(n), *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_y0(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_y0(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_y1(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_y1(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_yn(pTHX_ mpfr_t * a, SV * n, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_yn(*a, (long)SvIV(n), *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_atan2(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_atan2(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_atan2u(pTHX_ mpfr_t *a, mpfr_t *b, mpfr_t *c, unsigned long d, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_atan2u(*a, *b, *c, d, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG5(a, b, c, d, round);
  croak("Rmpfr_atan2u function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_atan2pi(pTHX_ mpfr_t *a, mpfr_t *b, mpfr_t *c, SV *round) {
#if MPFR_VERSION >= 262656
  return newSViv(mpfr_atan2pi(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_atan2pi function not implemented until mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_pow_z(pTHX_ mpfr_t * a, mpfr_t * b, mpz_t * c,  SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_pow_z(*a, *b, *c, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_subnormalize(pTHX_ mpfr_t * a, SV * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_subnormalize(*a, (int)SvIV(b), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_const_catalan(pTHX_ mpfr_t * a, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_const_catalan(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sec(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sec(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_csc(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_csc(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_cot(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_cot(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_root(pTHX_ mpfr_t * a, mpfr_t * b, SV * c, SV * round) {
#if MPFR_VERSION_MAJOR >= 4
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_root is deprecated, and now removed - use Rmpfr_rootn_ui instead");
#else
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_root(*a, *b, (unsigned long)SvUV(c), (mpfr_rnd_t)SvUV(round)));
#endif
}

SV * Rmpfr_eint(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_eint(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_li2(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_li2(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_f(pTHX_ mpf_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  if(!mpfr_number_p(*b)) croak("In Rmpfr_get_f: Cannot coerce an 'Inf' or 'NaN' to a Math::GMPf object");
  return newSViv(mpfr_get_f(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_sech(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_sech(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_csch(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_csch(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_coth(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
  return newSViv(mpfr_coth(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_lngamma(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  CHECK_ROUNDING_VALUE
#if !defined(MPFR_VERSION) || (defined(MPFR_VERSION) && MPFR_VERSION <= LNGAMMA_BUG)
  if(!mpfr_nan_p(*b) && mpfr_sgn(*b) <= 0) {
    mpfr_set_inf(*a, 1);
    return newSViv(0);
  }
#endif
  return newSViv(mpfr_lngamma(*a, *b, (mpfr_rnd_t)SvUV(round)));
}

void Rmpfr_lgamma(pTHX_ mpfr_t * a, mpfr_t * b, SV * round) {
  dXSARGS;
  int ret, signp;
  PERL_UNUSED_ARG(items);
  CHECK_ROUNDING_VALUE
  ret = mpfr_lgamma(*a, &signp, *b, (mpfr_rnd_t)SvUV(round));
  ST(0) = sv_2mortal(newSViv(signp));
  ST(1) = sv_2mortal(newSViv(ret));
  XSRETURN(2);
}

SV * _MPFR_VERSION(pTHX) {
#if defined(MPFR_VERSION)
  return newSVuv(MPFR_VERSION);
#else
  return &PL_sv_undef;
#endif
}

SV * _MPFR_VERSION_MAJOR(pTHX) {
  return newSVuv(MPFR_VERSION_MAJOR);
}

SV * _MPFR_VERSION_MINOR(pTHX) {
  return newSVuv(MPFR_VERSION_MINOR);
}

SV * _MPFR_VERSION_PATCHLEVEL(pTHX) {
  return newSVuv(MPFR_VERSION_PATCHLEVEL);
}

SV * _MPFR_VERSION_STRING(pTHX) {
  return newSVpv(MPFR_VERSION_STRING, 0);
}

SV * RMPFR_VERSION_NUM(pTHX_ SV * a, SV * b, SV * c) {
  return newSVuv(MPFR_VERSION_NUM((unsigned long)SvUV(a), (unsigned long)SvUV(b), (unsigned long)SvUV(c)));
}

SV * Rmpfr_sum(pTHX_ mpfr_t * rop, SV * avref, SV * len, SV * round) {
  mpfr_ptr *p;
  SV ** elem;
  int ret;
  unsigned long i, s = (unsigned long)SvUV(len);

  if(s > av_len((AV*)SvRV(avref)) + 1)croak("2nd last arg to Rmpfr_sum is greater than the size of the array");

  CHECK_ROUNDING_VALUE

  Newx(p, s, mpfr_ptr);
  if(p == NULL) croak("Unable to allocate memory in Rmpfr_sum");

  for(i = 0; i < s; ++i) {
    elem = av_fetch((AV*)SvRV(avref), i, 0);
    p[i] = *(INT2PTR(mpfr_t *, SvIVX(SvRV(*elem))));
  }

  ret = mpfr_sum(*rop, p, s, (mpfr_rnd_t)SvUV(round));

  Safefree(p);
  return newSViv(ret);
}

void _fr_to_q(mpq_t * q, mpfr_t * fr) {
  mpfr_exp_t exponent, denpow;
  char * str;
  size_t numlen;

  if(!mpfr_number_p(*fr)) {
    if(mpfr_nan_p(*fr))
      croak ("In Math::MPFR::_fr_to_q, cannot coerce a NaN to a Math::GMPq value");
    croak ("In Math::MPFR::_fr_to_q, cannot coerce an Inf to a Math::GMPq value");
  }

  str = mpfr_get_str(NULL, &exponent, 2, 0, *fr, GMP_RNDN);
  mpz_set_str(mpq_numref(*q), str, 2);
  mpz_set_ui (mpq_denref(*q), 1);
  mpfr_free_str(str);
  numlen = mpz_sizeinbase(mpq_numref(*q), 2);
  denpow = (mpfr_exp_t)(numlen - exponent);

  if(denpow < 0) {
    mpz_mul_2exp(mpq_numref(*q), mpq_numref(*q), -denpow);
  }
  else {
    mpz_mul_2exp(mpq_denref(*q), mpq_denref(*q), denpow);
  }

  mpq_canonicalize(*q);
}

int Rmpfr_q_div(mpfr_t * rop, mpq_t * q, mpfr_t * fr, int round) {
  mpq_t t;
  int ret;

  /* Handle Inf, NaN and zero values of *fr */
  if(!mpfr_regular_p(*fr)) {
    ret = mpfr_si_div(*rop, mpz_sgn(mpq_numref(*q)), *fr, (mpfr_rnd_t)round);
    return ret;
  }

  mpq_init(t);

  _fr_to_q(&t, fr);
  mpq_div(t, *q, t);
  ret = mpfr_set_q(*rop, t, (mpfr_rnd_t)round);
  mpq_clear(t);
  return ret;
}

int Rmpfr_z_div(mpfr_t * rop, mpz_t * z, mpfr_t * fr, int round) {
  mpq_t t, tz;
  int ret;

  /* Handle Inf, NaN and zero values of *fr */
  if(!mpfr_regular_p(*fr)) {
    ret = mpfr_si_div(*rop, mpz_sgn(*z), *fr, (mpfr_rnd_t)round);
    return ret;
  }

  mpq_init(t);
  mpq_init(tz);
  mpq_set_z(tz, *z);

  _fr_to_q(&t, fr);
  mpq_div(t, tz, t);
  ret = mpfr_set_q(*rop, t, (mpfr_rnd_t)round);
  mpq_clear(t);
  mpq_clear(tz);
  return ret;
}

SV * overload_mul(pTHX_ SV * a, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj, t;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(third);
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_mul) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  if(SV_IS_IOK(b)) {
    mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
    if(SvUOK(b)) mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
    else         mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);

    mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#else
  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) {
      mpfr_mul_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return obj_ref;
    }

    mpfr_mul_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
    return obj_ref;
  }
#endif
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_mul");}

#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan == 2) {
        mpfr_set_nan(*mpfr_t_obj);
        mpfr_set_nanflag();
        return obj_ref;
      }

      mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
    }
    else {
      ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
    }
#else
    ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif

    NON_NUMERIC_CHAR_CHECK(b), "overload_mul subroutine");}

    mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
    return obj_ref;
  }

  if(SV_IS_NOK(b)) {

#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_mul");}
#endif
#if defined(USE_QUADMATH)
    mpfr_init2(t, FLT128_MANT_DIG);
    Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);
    mpfr_mul(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#elif defined(USE_LONG_DOUBLE)
    mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
    mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
    mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#else
    mpfr_mul_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), (double)SvNVX(b), __gmpfr_default_rounding_mode);
    return obj_ref;
  }
#endif
  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      mpfr_mul_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                              *(INT2PTR(mpz_t * , SvIVX(SvRV(b)))),
                              __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPq")) {
      mpfr_mul_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                              *(INT2PTR(mpq_t * , SvIVX(SvRV(b)))),
                              __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPf")) {
      mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
      mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      mpfr_mul(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
      return obj_ref;
    }
  }

  croak("Invalid argument supplied to Math::MPFR::overload_mul");
}

SV * overload_add(pTHX_ SV * a, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj, t;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(third);
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_add) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  if(SV_IS_IOK(b)) {
    mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
    if(SvUOK(b)) mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
    else         mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);

    mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#else

  DEAL_WITH_NANFLAG_BUG_OVERLOADED
  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) {
      mpfr_add_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return obj_ref;
    }

    mpfr_add_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
    return obj_ref;
  }
#endif
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_add");}

#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan == 2) {
        mpfr_set_nan(*mpfr_t_obj);
        mpfr_set_nanflag();
        return obj_ref;
      }

      mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
    }
    else {
      ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
    }
#else
    ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif

    NON_NUMERIC_CHAR_CHECK(b), "overload_add subroutine");}

    mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
    return obj_ref;
  }

  if(SV_IS_NOK(b)) {

#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_add");}
#endif
#if defined(USE_QUADMATH)
    mpfr_init2(t, FLT128_MANT_DIG);
    Rmpfr_set_NV(aTHX_ &t, b, GMP_RNDN);
    mpfr_add(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#elif defined(USE_LONG_DOUBLE)
    mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
    mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
    mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#else
    mpfr_add_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), (double)SvNVX(b), __gmpfr_default_rounding_mode);
    return obj_ref;
  }
#endif
  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));
    if(strEQ(h, "Math::MPFR")) {
      mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                            *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))),
                            __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      mpfr_add_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                              *(INT2PTR(mpz_t * , SvIVX(SvRV(b)))),
                              __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPq")) {
      mpfr_add_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                              *(INT2PTR(mpq_t * , SvIVX(SvRV(b)))),
                              __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPf")) {
      mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
      mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      mpfr_add(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
      return obj_ref;
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_add");
}

SV * overload_sub(pTHX_ SV * a, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj, t;
  SV * obj_ref, * obj;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_sub) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  if(SV_IS_IOK(b)) {
    mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
    if(SvUOK(b)) mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
    else         mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);

    if(SWITCH_ARGS) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#else
  DEAL_WITH_NANFLAG_BUG_OVERLOADED
  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) {
      if(SWITCH_ARGS) mpfr_ui_sub(*mpfr_t_obj, SvUVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
      else mpfr_sub_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return obj_ref;
    }

    if(SWITCH_ARGS) mpfr_si_sub(*mpfr_t_obj, SvIVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else mpfr_sub_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
    return obj_ref;
  }
#endif
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
         ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_sub");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan == 2) {
         mpfr_set_nan(*mpfr_t_obj);
        mpfr_set_nanflag();
        return obj_ref;
      }

      mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
    }
    else {
      ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
    }
#else
    ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif
    NON_NUMERIC_CHAR_CHECK(b), "overload_sub subroutine");}

    if(SWITCH_ARGS) mpfr_sub(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
    return obj_ref;
  }

  if(SV_IS_NOK(b)) {

#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_sub");}
#endif

#if defined(USE_QUADMATH)

    mpfr_init2(t, FLT128_MANT_DIG);
    Rmpfr_set_NV(aTHX_ &t, b, GMP_RNDN);
    if(SWITCH_ARGS)
      mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else
      mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#elif defined(USE_LONG_DOUBLE)
    mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
    mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
    if(SWITCH_ARGS) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#else
    if(SWITCH_ARGS) mpfr_d_sub(*mpfr_t_obj, SvNVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else mpfr_sub_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvNVX(b), __gmpfr_default_rounding_mode);
    return obj_ref;
  }
#endif
  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      mpfr_sub_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                   *(INT2PTR(mpz_t * , SvIVX(SvRV(b)))),
                                   __gmpfr_default_rounding_mode);
      if(SWITCH_ARGS) mpfr_neg(*mpfr_t_obj, *mpfr_t_obj, GMP_RNDN);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPq")) {
      mpfr_sub_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                   *(INT2PTR(mpq_t * , SvIVX(SvRV(b)))),
                                   __gmpfr_default_rounding_mode);
      if(SWITCH_ARGS) mpfr_neg(*mpfr_t_obj, *mpfr_t_obj, GMP_RNDN);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPf")) {
      mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
      mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      if(SWITCH_ARGS) mpfr_sub(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
      else mpfr_sub(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
      return obj_ref;
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_sub function");
}

SV * overload_div(pTHX_ SV * a, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj, t;
  SV * obj_ref, * obj;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_div) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  if(SV_IS_IOK(b)) {
    mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
    if(SvUOK(b)) mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
    else         mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);

    if(SWITCH_ARGS) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#else
  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) {
      if(SWITCH_ARGS) mpfr_ui_div(*mpfr_t_obj, SvUVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
      else mpfr_div_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return obj_ref;
    }

    if(SWITCH_ARGS) mpfr_si_div(*mpfr_t_obj, SvIVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else mpfr_div_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
    return obj_ref;
  }
#endif
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_div");}

#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan == 2) {
        mpfr_set_nan(*mpfr_t_obj);
        mpfr_set_nanflag();
        return obj_ref;
      }

      mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
    }
    else {
      ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
    }
#else
    ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif
    NON_NUMERIC_CHAR_CHECK(b), "overload_div subroutine");}

    if(SWITCH_ARGS) mpfr_div(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
    return obj_ref;
  }

  if(SV_IS_NOK(b)) {

#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_div");}
#endif
#if defined(USE_QUADMATH)
    mpfr_init2(t, FLT128_MANT_DIG);
    Rmpfr_set_NV(aTHX_ &t, b, GMP_RNDN);
    if(SWITCH_ARGS)
      mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else
      mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#elif defined(USE_LONG_DOUBLE)
    mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
    mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
    if(SWITCH_ARGS) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#else
    if(SWITCH_ARGS) mpfr_d_div(*mpfr_t_obj, SvNVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
    else mpfr_div_d(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvNVX(b), __gmpfr_default_rounding_mode);
    return obj_ref;
  }
#endif
  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {

      if(SWITCH_ARGS) {
        Rmpfr_z_div(mpfr_t_obj, INT2PTR(mpz_t * , SvIVX(SvRV(b))),
                                INT2PTR(mpfr_t *, SvIVX(SvRV(a))),
                                __gmpfr_default_rounding_mode);
      }
      else {
        mpfr_div_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                *(INT2PTR(mpz_t * , SvIVX(SvRV(b)))),
                                __gmpfr_default_rounding_mode);
      }
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPq")) {
      if(SWITCH_ARGS) {
        Rmpfr_q_div(mpfr_t_obj, INT2PTR(mpq_t * , SvIVX(SvRV(b))),
                                INT2PTR(mpfr_t *, SvIVX(SvRV(a))),
                                __gmpfr_default_rounding_mode);
      }
      else {
        mpfr_div_q(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))),
                                *(INT2PTR(mpq_t * , SvIVX(SvRV(b)))),
                                 __gmpfr_default_rounding_mode);
      }
      return obj_ref;
    }

    if(strEQ(h, "Math::GMPf")) {
      mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
      mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      if(SWITCH_ARGS) mpfr_div(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), __gmpfr_default_rounding_mode);
      else mpfr_div(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
      return obj_ref;
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_div function");
}

SV * overload_copy(pTHX_ mpfr_t * p, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  PERL_UNUSED_ARG2(b, third);

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_copy) /* defined in math_mpfr_include.h */

  mpfr_init2(*mpfr_t_obj, mpfr_get_prec(*p));
  mpfr_set(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * overload_abs(pTHX_ mpfr_t * p, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  PERL_UNUSED_ARG2(b, third);

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_abs) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_abs(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * overload_gt(pTHX_ mpfr_t * a, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif

  if(mpfr_nan_p(*a)){
    mpfr_set_erangeflag();
    return newSVuv(0);
  }

  if(SV_IS_IOK(b)) {
    ret = Rmpfr_cmp_IV(aTHX_ a, b);
    if(SWITCH_ARGS) ret *= -1;
    if(ret > 0) return newSViv(1);
    return newSViv(0);
  }

#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_gt");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan != 2) {
        mpfr_init(t);
        mpfr_set_inf(t, inf_or_nan);
      }
      else { /* it's a NaN */
        mpfr_set_erangeflag();
        return newSViv(0);
      }
    }
    else {
      ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

      NON_NUMERIC_CHAR_CHECK(b), "overload_gt subroutine");}

      if(mpfr_nan_p(t)) {
        mpfr_clear(t);
        mpfr_set_erangeflag();
        return newSViv(0);
      }
    }
#else
    ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

    NON_NUMERIC_CHAR_CHECK(b), "overload_gt subroutine");}

    if(mpfr_nan_p(t)) {
      mpfr_clear(t);
      mpfr_set_erangeflag();
      return newSViv(0);
    }
#endif
    ret = mpfr_cmp(*a, t);
    mpfr_clear(t);
    if(SWITCH_ARGS) ret *= -1;
    if(ret > 0) return newSViv(1);
    return newSViv(0);
  }

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_gt");}
#endif
    if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
      mpfr_set_erangeflag();
      return newSVuv(0);
    }

    ret = Rmpfr_cmp_NV(aTHX_ a, b);
    if(SWITCH_ARGS) ret *= -1;
    if(ret > 0) return newSViv(1);
    return newSViv(0);
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      return newSVuv(mpfr_greater_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));
    }

    if(strEQ(h, "Math::GMPq")) {
      ret = mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
      if(ret > 0) return newSViv(1);
      return newSViv(0);
    }

    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      ret = mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
      if(ret > 0) return newSViv(1);
      return newSViv(0);
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_gt");
}

SV * overload_gte(pTHX_ mpfr_t * a, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif
  if(mpfr_nan_p(*a)){
    mpfr_set_erangeflag();
    return newSVuv(0);
  }

  if(SV_IS_IOK(b)) {
    ret = Rmpfr_cmp_IV(aTHX_ a, b);
    if(SWITCH_ARGS) ret *= -1;
    if(ret >= 0) return newSViv(1);
    return newSViv(0);
  }
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_gte");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan != 2) {
        mpfr_init(t);
        mpfr_set_inf(t, inf_or_nan);
      }
      else { /* it's a NaN */
        mpfr_set_erangeflag();
        return newSViv(0);
      }
    }
    else {
      ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

      NON_NUMERIC_CHAR_CHECK(b), "overload_gte subroutine");}

      if(mpfr_nan_p(t)) {
        mpfr_clear(t);
        mpfr_set_erangeflag();
        return newSViv(0);
      }
    }
#else
    ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

    NON_NUMERIC_CHAR_CHECK(b), "overload_gte subroutine");}

    if(mpfr_nan_p(t)) {
      mpfr_clear(t);
      mpfr_set_erangeflag();
      return newSViv(0);
    }
#endif
    ret = mpfr_cmp(*a, t);
    mpfr_clear(t);
    if(SWITCH_ARGS) ret *= -1;
    if(ret >= 0) return newSViv(1);
    return newSViv(0);
  }

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_gte");}
#endif
    if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
      mpfr_set_erangeflag();
      return newSVuv(0);
    }

    ret = Rmpfr_cmp_NV(aTHX_ a, b);
    if(SWITCH_ARGS) ret *= -1;
    if(ret >= 0) return newSViv(1);
    return newSViv(0);
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      return newSVuv(mpfr_greaterequal_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));
    }

    if(strEQ(h, "Math::GMPq")) {
      ret = mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
      if(ret >= 0) return newSViv(1);
      return newSViv(0);
    }

    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      ret = mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
      if(ret >= 0) return newSViv(1);
      return newSViv(0);
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_gte");
}

SV * overload_lt(pTHX_ mpfr_t * a, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif

  if(mpfr_nan_p(*a)){
    mpfr_set_erangeflag();
    return newSVuv(0);
  }

  if(SV_IS_IOK(b)) {
    ret = Rmpfr_cmp_IV(aTHX_ a, b);
    if(SWITCH_ARGS) ret *= -1;
    if(ret < 0) return newSViv(1);
    return newSViv(0);
  }
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_lt");}

#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan != 2) {
        mpfr_init(t);
        mpfr_set_inf(t, inf_or_nan);
      }
      else { /* it's a NaN */
        mpfr_set_erangeflag();
        return newSViv(0);
      }
    }
    else {
      ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

      NON_NUMERIC_CHAR_CHECK(b), "overload_lt subroutine");}

      if(mpfr_nan_p(t)) {
        mpfr_clear(t);
        mpfr_set_erangeflag();
        return newSViv(0);
      }
    }
#else
    ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

    NON_NUMERIC_CHAR_CHECK(b), "overload_lt subroutine");}

    if(mpfr_nan_p(t)) {
      mpfr_clear(t);
      mpfr_set_erangeflag();
      return newSViv(0);
    }
#endif
    ret = mpfr_cmp(*a, t);
    mpfr_clear(t);
    if(SWITCH_ARGS) ret *= -1;
    if(ret < 0) return newSViv(1);
    return newSViv(0);
  }

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_lt");}
#endif

    if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
      mpfr_set_erangeflag();
      return newSVuv(0);
    }

    ret = Rmpfr_cmp_NV(aTHX_ a, b);
    if(SWITCH_ARGS) ret *= -1;
    if(ret < 0) return newSViv(1);
    return newSViv(0);
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      return newSVuv(mpfr_less_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));
    }

    if(strEQ(h, "Math::GMPq")) {
      ret = mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
      if(ret < 0) return newSViv(1);
      return newSViv(0);
    }

    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      ret = mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
      if(ret < 0) return newSViv(1);
      return newSViv(0);
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_lt");
}

SV * overload_lte(pTHX_ mpfr_t * a, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif

  if(mpfr_nan_p(*a)){
    mpfr_set_erangeflag();
    return newSVuv(0);
  }

  if(SV_IS_IOK(b)) {
    ret = Rmpfr_cmp_IV(aTHX_ a, b);
    if(SWITCH_ARGS) ret *= -1;
    if(ret <= 0) return newSViv(1);
    return newSViv(0);
  }
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_lte(aTHX_ <=)");}

#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan != 2) {
        mpfr_init(t);
        mpfr_set_inf(t, inf_or_nan);
      }
      else { /* it's a NaN */
        mpfr_set_erangeflag();
        return newSViv(0);
      }
    }
    else {
      ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
       NON_NUMERIC_CHAR_CHECK(b), "overload_lte subroutine");}
       if(mpfr_nan_p(t)) {
        mpfr_clear(t);
        mpfr_set_erangeflag();
        return newSViv(0);
      }
    }
#else
    ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

    NON_NUMERIC_CHAR_CHECK(b), "overload_lte subroutine");}

    if(mpfr_nan_p(t)) {
      mpfr_clear(t);
      mpfr_set_erangeflag();
      return newSViv(0);
    }
#endif
    ret = mpfr_cmp(*a, t);
    mpfr_clear(t);
    if(SWITCH_ARGS) ret *= -1;
    if(ret <= 0) return newSViv(1);
    return newSViv(0);
  }

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_lte(aTHX_ <=)");}
#endif

    if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
      mpfr_set_erangeflag();
      return newSVuv(0);
    }

    ret = Rmpfr_cmp_NV(aTHX_ a, b);
    if(SWITCH_ARGS) ret *= -1;
    if(ret <= 0) return newSViv(1);
    return newSViv(0);
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR"))
      return newSVuv(mpfr_lessequal_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));

    if(strEQ(h, "Math::GMPq")) {
      ret = mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
      if(ret <= 0) return newSViv(1);
      return newSViv(0);
    }

    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      ret = mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
      if(ret <= 0) return newSViv(1);
      return newSViv(0);
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_lte");
}

SV * overload_spaceship(pTHX_ mpfr_t * a, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif

  if(mpfr_nan_p(*a)) {
    mpfr_set_erangeflag();
    return &PL_sv_undef;
  }

  if(SV_IS_IOK(b)) {
    ret = Rmpfr_cmp_IV(aTHX_ a, b);
    if(SWITCH_ARGS) ret *= -1;
    if(ret < 0) return newSViv(-1);
    if(ret > 0) return newSViv(1);
    return newSViv(0);
  }

#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_spaceship");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan != 2) {
        mpfr_init(t);
        mpfr_set_inf(t, inf_or_nan);
      }
      else { /* it's a NaN */
        mpfr_set_erangeflag();
        return &PL_sv_undef;
      }
    }
    else {
      ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

      NON_NUMERIC_CHAR_CHECK(b), "overload_spaceship subroutine");}

      if(mpfr_nan_p(t)) {
        mpfr_clear(t);
        mpfr_set_erangeflag();
        return &PL_sv_undef;
      }
    }
#else
    ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

    NON_NUMERIC_CHAR_CHECK(b), "overload_spaceship subroutine");}

    if(mpfr_nan_p(t)) {
      mpfr_clear(t);
      mpfr_set_erangeflag();
      return &PL_sv_undef;
    }
#endif
    ret = mpfr_cmp(*a, t);
    mpfr_clear(t);
    if(SWITCH_ARGS) ret *= -1;
    if(ret < 0) return newSViv(-1);
    if(ret > 0) return newSViv(1);
    return newSViv(0);
  }

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_spaceship");}
#endif
    if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
    mpfr_set_erangeflag();
    return &PL_sv_undef;
    }

    ret = Rmpfr_cmp_NV(aTHX_ a, b);
    if(SWITCH_ARGS) ret *= -1;
    if(ret < 0) return newSViv(-1);
    if(ret > 0) return newSViv(1);
    return newSViv(0);
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      if( mpfr_nan_p( *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))) ) {
        mpfr_set_erangeflag();
        return &PL_sv_undef;
      }
      return newSViv(mpfr_cmp(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));
    }

    if(strEQ(h, "Math::GMPq")) {
      return newSViv(mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b))))));
    }

    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      return newSViv(mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b))))));
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_spaceship");
}

SV * overload_equiv(pTHX_ mpfr_t * a, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif
  PERL_UNUSED_ARG(third);

  if(mpfr_nan_p(*a)){
    mpfr_set_erangeflag();
    return newSVuv(0);
  }

  if(SV_IS_IOK(b)) {
    ret = Rmpfr_cmp_IV(aTHX_ a, b);
    if(ret == 0) return newSViv(1);
    return newSViv(0);
  }

#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_equiv");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan != 2) {
        mpfr_init(t);
        mpfr_set_inf(t, inf_or_nan);
      }
      else { /* it's a NaN */
        mpfr_set_erangeflag();
        return newSViv(0);
      }
    }
    else {
      ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

      NON_NUMERIC_CHAR_CHECK(b), "overload_equiv subroutine");}

      if(mpfr_nan_p(t)) {
        mpfr_clear(t);
        mpfr_set_erangeflag();
        return newSViv(0);
      }
    }
#else
    ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

    NON_NUMERIC_CHAR_CHECK(b), "overload_equiv subroutine");}

    if(mpfr_nan_p(t)) {
      mpfr_clear(t);
      mpfr_set_erangeflag();
      return newSViv(0);
    }
#endif
    ret = mpfr_cmp(*a, t);
    mpfr_clear(t);
    if(ret == 0) return newSViv(1);
    return newSViv(0);
  }

   if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_equiv");}
#endif
    if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
      mpfr_set_erangeflag();
      return newSVuv(0);
    }

    ret = Rmpfr_cmp_NV(aTHX_ a, b);
    if(ret == 0) return newSViv(1);
    return newSViv(0);
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      return newSVuv(mpfr_equal_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b))))));
    }

    if(strEQ(h, "Math::GMPq")) {
      if(mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))))) return newSViv(0);
      return newSViv(1);
    }

    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      if(mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))))) return newSViv(0);
      return newSViv(1);
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_equiv");
}

SV * overload_not_equiv(pTHX_ mpfr_t * a, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif
  PERL_UNUSED_ARG(third);

  if(mpfr_nan_p(*a)){
    mpfr_set_erangeflag();
    return newSVuv(1);
  }

  if(SV_IS_IOK(b)) {
    ret = Rmpfr_cmp_IV(aTHX_ a, b);
    if(ret != 0) return newSViv(1);
    return newSViv(0);
  }

#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) { /*open IS_POK*/
#endif
    NOK_POK_DUALVAR_CHECK , "overload_not_equiv");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan != 2) {
        mpfr_init(t);
        mpfr_set_inf(t, inf_or_nan);
      }
      else { /* it's a NaN */
        mpfr_set_erangeflag();
        return newSViv(1);
      }
    }
    else {
      ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

      NON_NUMERIC_CHAR_CHECK(b), "overload_not_equiv subroutine");}

      if(mpfr_nan_p(t)) {
        mpfr_clear(t);
        mpfr_set_erangeflag();
        return newSViv(1);
      }
    }
#else
    ret = mpfr_init_set_str(t, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);

    NON_NUMERIC_CHAR_CHECK(b), "overload_not_equiv subroutine");}

    if(mpfr_nan_p(t)) {
      mpfr_clear(t);
      mpfr_set_erangeflag();
      return newSViv(1);
    }
#endif
    ret = mpfr_cmp(*a, t);
    mpfr_clear(t);
    if(ret != 0) return newSViv(1);
    return newSViv(0);
  } /*close IS_POK*/

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_not_equiv");}
#endif
    if(SvNVX(b) != SvNVX(b)) { /* it's a NaN */
      mpfr_set_erangeflag();
      return newSVuv(1);
    }
    ret = Rmpfr_cmp_NV(aTHX_ a, b);
    if(ret != 0) return newSViv(1);
    return newSViv(0);
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      if(mpfr_equal_p(*a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))))) return newSViv(0);
      return newSViv(1);
    }

    if(strEQ(h, "Math::GMPq")) {
      if(mpfr_cmp_q(*a, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))))) return newSViv(1);
      return newSViv(0);
    }

    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      if(mpfr_cmp_z(*a, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))))) return newSViv(1);
      return newSViv(0);
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_not_equiv");
}

SV * overload_true(pTHX_ mpfr_t *a, SV *b, SV * third) {
  PERL_UNUSED_ARG2(b, third);
  if(mpfr_nan_p(*a)) return newSVuv(0);
  if(mpfr_cmp_ui(*a, 0)) return newSVuv(1);
  return newSVuv(0);
}

SV * overload_not(pTHX_ mpfr_t * a, SV * b, SV * third) {
  PERL_UNUSED_ARG2(b, third);
  if(mpfr_nan_p(*a)) return newSViv(1);
  if(mpfr_cmp_ui(*a, 0)) return newSViv(0);
  return newSViv(1);
}

SV * overload_sqrt(pTHX_ mpfr_t * p, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  PERL_UNUSED_ARG2(b, third);

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_sqrt) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  /* No - this was wrong. If a negative value is supplied, a NaN should be returned instad */
  /* if(mpfr_cmp_ui(*p, 0) < 0) croak("Negative value supplied as argument to overload_sqrt"); */

  mpfr_sqrt(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * overload_pow(pTHX_ SV * p, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj, t;
  SV * obj_ref, * obj;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_pow) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  if(SV_IS_IOK(b)) {
    mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
    if(SvUOK(b)) mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
    else         mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);

    if(SWITCH_ARGS) mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
    else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }
#else
  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) {
      if(SWITCH_ARGS) mpfr_ui_pow(*mpfr_t_obj, SvUVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
      else mpfr_pow_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return obj_ref;
    }

    /* Need to do it this way as there's no mpfr_si_pow function */
    if(SvIV(b) >= 0) {
      if(SWITCH_ARGS) mpfr_ui_pow(*mpfr_t_obj, SvUVX(b), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
      else mpfr_pow_ui(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(NO_SWITCH_ARGS) {
      mpfr_pow_si(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvIV(b), __gmpfr_default_rounding_mode);
      return obj_ref;
    }
  }
#endif
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
         ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
       NOK_POK_DUALVAR_CHECK , "overload_pow");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan == 2) {
        mpfr_set_nan(*mpfr_t_obj);
        mpfr_set_nanflag();
        return obj_ref;
      }

      mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
    }
    else {
      ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
    }
#else
    ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif
    NON_NUMERIC_CHAR_CHECK(b), "overload_pow subroutine");}

    if(SWITCH_ARGS) mpfr_pow(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
    else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
    return obj_ref;
  }

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_pow");}
#endif
#if defined(USE_QUADMATH)
    mpfr_init2(t, FLT128_MANT_DIG);
    Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);
#elif defined(USE_LONG_DOUBLE)
    mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
    mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
#else
    mpfr_init2(t, DBL_MANT_DIG);
    mpfr_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);
#endif

    if(SWITCH_ARGS) mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
    else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return obj_ref;
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      if(SWITCH_ARGS) {
        mpfr_init2(t, (mpfr_prec_t)mpz_sizeinbase(*(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), 2));
        mpfr_set_z(t, *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
        mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
        mpfr_clear(t);
      }
      else mpfr_pow_z(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p     )))),
                                   *(INT2PTR(mpz_t * , SvIVX(SvRV(b)))),
                                   __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPq")) {
      mpfr_set_q(*mpfr_t_obj, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      if(SWITCH_ARGS) mpfr_pow(*mpfr_t_obj, *mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
      else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *mpfr_t_obj, __gmpfr_default_rounding_mode);
      return obj_ref;
    }
    if(strEQ(h, "Math::GMPf")) {
      mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
      mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      if(SWITCH_ARGS) mpfr_pow(*mpfr_t_obj, t, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), __gmpfr_default_rounding_mode);
      else mpfr_pow(*mpfr_t_obj, *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
      return obj_ref;
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_pow.");
}

SV * overload_log(pTHX_ mpfr_t * p, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  PERL_UNUSED_ARG2(b, third);

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_log) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_log(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * log_2(pTHX_ mpfr_t * p) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;

  NEW_MATH_MPFR_OBJECT("Math::MPFR",log_2) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_log2(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * log_10(pTHX_ mpfr_t * p) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;

  NEW_MATH_MPFR_OBJECT("Math::MPFR",log_10) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_log10(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * overload_exp(pTHX_ mpfr_t * p, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  PERL_UNUSED_ARG2(b, third);

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_exp) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_exp(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */;
  return obj_ref;
}

SV * overload_sin(pTHX_ mpfr_t * p, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  PERL_UNUSED_ARG2(b, third);

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_sin) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_sin(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * sind(pTHX_ mpfr_t * p) {
#if MPFR_VERSION >= 262656
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;

  NEW_MATH_MPFR_OBJECT("Math::MPFR",sind) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_sinu(*mpfr_t_obj, *p, 360, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
#else
  PERL_UNUSED_ARG(p);
  croak("sind function requires mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * overload_cos(pTHX_ mpfr_t * p, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  PERL_UNUSED_ARG2(b, third);

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_cos) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_cos(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * cosd(pTHX_ mpfr_t * p) {
#if MPFR_VERSION >= 262656
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;

  NEW_MATH_MPFR_OBJECT("Math::MPFR",cosd) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_cosu(*mpfr_t_obj, *p, 360, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
#else
  PERL_UNUSED_ARG(p);
  croak("cosd function requires mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * tangent(pTHX_ mpfr_t * p) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;

  NEW_MATH_MPFR_OBJECT("Math::MPFR",tangent) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_tan(*mpfr_t_obj, *p, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * tand(pTHX_ mpfr_t * p) {
#if MPFR_VERSION >= 262656
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;

  NEW_MATH_MPFR_OBJECT("Math::MPFR",tand) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_tanu(*mpfr_t_obj, *p, 360, __gmpfr_default_rounding_mode);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
#else
  PERL_UNUSED_ARG(p);
  croak("tand function requires mpfr-4.2.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif
}

SV * overload_int(pTHX_ mpfr_t * p, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  PERL_UNUSED_ARG2(b, third);

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_int) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);

  mpfr_trunc(*mpfr_t_obj, *p);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */
  return obj_ref;
}

SV * overload_atan2(pTHX_ mpfr_t * a, SV * b, SV * third) {
  mpfr_t * mpfr_t_obj, t;
  SV * obj_ref, * obj;
#ifdef _WIN32_BIZARRE_INFNAN
  int ret, inf_or_nan;
#else
  int ret;
#endif
  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_atan2) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  if(SV_IS_IOK(b)) {
    mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
    if(SvUOK(b)) mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
    else         mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);

    if(SWITCH_ARGS){
      mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
    }
    else {
      mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
    }
    mpfr_clear(t);
    OBJ_READONLY_ON /*defined in math_mpfr_include.h */
    return obj_ref;
  }
#else
  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) {
      mpfr_init2(t, 8 * sizeof(long));
      mpfr_set_ui(t, SvUVX(b), __gmpfr_default_rounding_mode);
      if(SWITCH_ARGS){
        mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
      }
      else {
        mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
      }
      mpfr_clear(t);
      OBJ_READONLY_ON /*defined in math_mpfr_include.h */
      return obj_ref;
    }

    mpfr_init2(t, 8 * sizeof(long));
    mpfr_set_si(t, SvIVX(b), __gmpfr_default_rounding_mode);
    if(SWITCH_ARGS){
      mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
    }
    else {
      mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
    }
    mpfr_clear(t);
    OBJ_READONLY_ON /*defined in math_mpfr_include.h */
    return obj_ref;
  }
#endif
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_atan2");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    if(inf_or_nan) {
      if(inf_or_nan != 2) {
        mpfr_set_inf(*mpfr_t_obj, inf_or_nan);
      }
      /* else we want *mpfr_t_obj to be a NaN ... which it already is !! :-) */
    }
    else {
      ret = mpfr_init_set_str(*mpfr_t_obj, (char *)SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
    }
#else
    ret = mpfr_set_str(*mpfr_t_obj, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif
    NON_NUMERIC_CHAR_CHECK(b), "overload_atan2");}

    if(SWITCH_ARGS){
      mpfr_atan2(*mpfr_t_obj, *mpfr_t_obj, *a, __gmpfr_default_rounding_mode);
    }
    else {
      mpfr_atan2(*mpfr_t_obj, *a, *mpfr_t_obj, __gmpfr_default_rounding_mode);
    }
    OBJ_READONLY_ON /*defined in math_mpfr_include.h */
    return obj_ref;
  }

  if(SV_IS_NOK(b)) {

#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_atan2");}
#endif
#if defined(USE_QUADMATH)
    mpfr_init2(t, FLT128_MANT_DIG);
    Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);
#elif defined(USE_LONG_DOUBLE)
    mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
    mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
#else
    mpfr_init2(t, DBL_MANT_DIG);
    mpfr_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);
#endif

    if(SWITCH_ARGS){
         mpfr_atan2(*mpfr_t_obj, t, *a, __gmpfr_default_rounding_mode);
    }
    else {
      mpfr_atan2(*mpfr_t_obj, *a, t, __gmpfr_default_rounding_mode);
    }
    mpfr_clear(t);
    OBJ_READONLY_ON /*defined in math_mpfr_include.h */
    return obj_ref;
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      mpfr_atan2(*mpfr_t_obj, *a, *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      OBJ_READONLY_ON /*defined in math_mpfr_include.h */
      return obj_ref;
    }
  }
  croak("Invalid argument supplied to Math::MPFR::overload_atan2 function");
}

/* Finish typemapping */

SV * Rmpfr_randinit_default_nobless(pTHX) {
  gmp_randstate_t * state;
  SV * obj_ref, * obj;

  Newx(state, 1, gmp_randstate_t);
  if(state == NULL) croak("Failed to allocate memory in Rmpfr_randinit_default function");
  obj_ref = newSV(0);
  obj = newSVrv(obj_ref, NULL);
  gmp_randinit_default(*state);

  sv_setiv(obj, INT2PTR(IV,state));
  SvREADONLY_on(obj);
  return obj_ref;
}

SV * Rmpfr_randinit_mt_nobless(pTHX) {
  gmp_randstate_t * rand_obj;
  SV * obj_ref, * obj;

  Newx(rand_obj, 1, gmp_randstate_t);
  if(rand_obj == NULL) croak("Failed to allocate memory in Math::GMPz::Random::Rmpfr_randinit_mt function");
  obj_ref = newSV(0);
  obj = newSVrv(obj_ref, NULL);
  gmp_randinit_mt(*rand_obj);

  sv_setiv(obj, INT2PTR(IV, rand_obj));
  SvREADONLY_on(obj);
  return obj_ref;
}

SV * Rmpfr_randinit_lc_2exp_nobless(pTHX_ SV * a, SV * c, SV * m2exp ) {
  gmp_randstate_t * state;
  mpz_t aa;
  SV * obj_ref, * obj;

  Newx(state, 1, gmp_randstate_t);
  if(state == NULL) croak("Failed to allocate memory in Rmpfr_randinit_lc_2exp function");
  obj_ref = newSV(0);
  obj = newSVrv(obj_ref, NULL);
  if(sv_isobject(a)) {
    const char* h = HvNAME(SvSTASH(SvRV(a)));

    if(strEQ(h, "Math::GMP") ||
       strEQ(h, "GMP::Mpz")  ||
       strEQ(h, "Math::GMPz"))
         gmp_randinit_lc_2exp(*state, *(INT2PTR(mpz_t *, SvIVX(SvRV(a)))), (unsigned long)SvUV(c), (unsigned long)SvUV(m2exp));
    else croak("First arg to Rmpfr_randinit_lc_2exp is of invalid type");
  }
  else {
    if(!mpz_init_set_str(aa, SvPV_nolen(a), 0)) {
      gmp_randinit_lc_2exp(*state, aa, (unsigned long)SvUV(c), (unsigned long)SvUV(m2exp));
      mpz_clear(aa);
    }
    else croak("Seedstring supplied to Rmpfr_randinit_lc_2exp is not a valid number");
  }

  sv_setiv(obj, INT2PTR(IV,state));
  SvREADONLY_on(obj);
  return obj_ref;
}

SV * Rmpfr_randinit_lc_2exp_size_nobless(pTHX_ SV * size) {
  gmp_randstate_t * state;
  SV * obj_ref, * obj;

  if(SvUV(size) > 128) croak("The argument supplied to Rmpfr_randinit_lc_2exp_size_nobless function is too large - ie greater than 128");

  Newx(state, 1, gmp_randstate_t);
  if(state == NULL) croak("Failed to allocate memory in Rmpfr_randinit_lc_2exp_size_nobless function");
  obj_ref = newSV(0);
  obj = newSVrv(obj_ref, NULL);

  if(gmp_randinit_lc_2exp_size(*state, (unsigned long)SvUV(size))) {
    sv_setiv(obj, INT2PTR(IV,state));
    SvREADONLY_on(obj);
    return obj_ref;
    }
  croak("Rmpfr_randinit_lc_2exp_size_nobless function failed");
}

void Rmpfr_randclear(pTHX_ SV * p) {
  gmp_randclear(*(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(p)))));
  Safefree(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(p))));
}

void Rmpfr_randseed(pTHX_ SV * state, SV * seed) {
  mpz_t s;

  if(sv_isobject(seed)) {
    const char* h = HvNAME(SvSTASH(SvRV(seed)));

    if(strEQ(h, "Math::GMP")  ||
       strEQ(h, "GMP::Mpz")   ||
       strEQ(h, "Math::GMPz"))
         gmp_randseed(*(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(state)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(seed)))));
    else croak("2nd arg to Rmpfr_randseed is of invalid type");
  }
  else {
    if(!mpz_init_set_str(s, SvPV_nolen(seed), 0)) {
      gmp_randseed(*(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(state)))), s);
      mpz_clear(s);
    }
    else croak("Seedstring supplied to Rmpfr_randseed is not a valid number");
  }
}

void Rmpfr_randseed_ui(pTHX_ SV * state, SV * seed) {
  gmp_randseed_ui(*(INT2PTR(gmp_randstate_t *, SvIVX(SvRV(state)))), (unsigned long)SvUV(seed));
}

SV * overload_pow_eq(pTHX_ SV * p, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif
  PERL_UNUSED_ARG(third);

  SvREFCNT_inc(p);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
#  if MPFR_VERSION >= 262656 /* have mpfr_pow_uj, mpfr_pow_sj */
   if(SV_IS_IOK(b)) {
     if(SvUOK(b)) {
       mpfr_pow_uj(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvUVX(b), __gmpfr_default_rounding_mode);
       return p;
     }

     mpfr_pow_sj(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvIVX(b), __gmpfr_default_rounding_mode);
     return p;
   }
#  else
    if(SV_IS_IOK(b)) {
      mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
      if(SvUOK(b)) mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
      else         mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);

      mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
      return p;
    }
#  endif
#else
  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) {
      mpfr_pow_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return p;
    }

    mpfr_pow_si(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), SvIVX(b), __gmpfr_default_rounding_mode);
    return p;
  }
#endif
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
         ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_pow_eq");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    mpfr_init(t);
    if(inf_or_nan) {
      if(inf_or_nan == 2) {
        mpfr_set_nan(t);
      }
      else mpfr_set_inf(t, inf_or_nan);
    }
    else {
      ret = mpfr_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
    }
#else
    ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif
    NON_NUMERIC_CHAR_CHECK(b), "overload_pow_eq subroutine");}

    mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return p;
  }

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_pow_eq");}
#endif
#if defined(USE_QUADMATH)
    mpfr_init2(t, FLT128_MANT_DIG);
    Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);
#elif defined(USE_LONG_DOUBLE)
    mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
    mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
#else
    mpfr_init2(t, DBL_MANT_DIG);
    mpfr_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);
#endif
    mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return p;
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return p;
    }
    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      mpfr_pow_z(*(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIV(SvRV(p)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return p;
    }
    if(strEQ(h, "Math::GMPf")) {
      mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
      mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
      return p;
    }
    if(strEQ(h, "Math::GMPq")) {
      mpfr_init(t);
      mpfr_set_q(t, *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      mpfr_pow(*(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(p)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
      return p;
    }
  }
  SvREFCNT_dec(p);
  croak("Invalid argument supplied to Math::MPFR::overload_pow_eq.");
}

SV * overload_div_eq(pTHX_ SV * a, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif
  PERL_UNUSED_ARG(third);

  SvREFCNT_inc(a);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  if(SV_IS_IOK(b)) {
    mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
    if(SvUOK(b)) mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
    else         mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);

    mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return a;
  }
#else
  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) {
      mpfr_div_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return a;
    }

    mpfr_div_si(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
    return a;
  }
#endif
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_div_eq");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    mpfr_init(t);
    if(inf_or_nan) {
      if(inf_or_nan == 2) {
        mpfr_set_nan(t);
      }
      else mpfr_set_inf(t, inf_or_nan);
    }
    else {
      ret = mpfr_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
    }
#else
    ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif
    NON_NUMERIC_CHAR_CHECK(b), "overload_div_eq subroutine");}

    mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return a;
  }

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_div_eq");}
#endif
#if defined(USE_QUADMATH)
    mpfr_init2(t, FLT128_MANT_DIG);
    Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);
#elif defined(USE_LONG_DOUBLE)
    mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
    mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
#else
    mpfr_init2(t, DBL_MANT_DIG);
    mpfr_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);
#endif
    mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return a;
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
    }
    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      mpfr_div_z(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
    }
    if(strEQ(h, "Math::GMPf")) {
      mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
      mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      mpfr_div(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
      return a;
    }
    if(strEQ(h, "Math::GMPq")) {
      mpfr_div_q(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
    }
  }
  SvREFCNT_dec(a);
  croak("Invalid argument supplied to Math::MPFR::overload_div_eq function");
}

SV * overload_sub_eq(pTHX_ SV * a, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif
  PERL_UNUSED_ARG(third);
  SvREFCNT_inc(a);
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  if(SV_IS_IOK(b)) {
    mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
    if(SvUOK(b)) mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
    else         mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);

    mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return a;
  }
#else
  DEAL_WITH_NANFLAG_BUG_OVERLOADED
  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) {
      mpfr_sub_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return a;
    }

    mpfr_sub_si(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
    return a;
    /*
    if(SvIV(b) >= 0) {
      mpfr_sub_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return a;
    }
    mpfr_add_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b) * -1, __gmpfr_default_rounding_mode);
    return a;
    */
  }
#endif
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_sub_eq");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    mpfr_init(t);
    if(inf_or_nan) {
      if(inf_or_nan == 2) {
        mpfr_set_nan(t);
      }
      else mpfr_set_inf(t, inf_or_nan);
    }
    else {
      ret = mpfr_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
    }
#else
    ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif
    NON_NUMERIC_CHAR_CHECK(b), "overload_sub_eq subroutine");}

    mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return a;
  }

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_sub_eq");}
#endif
#if defined(USE_QUADMATH)
    mpfr_init2(t, FLT128_MANT_DIG);
    Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);
#elif defined(USE_LONG_DOUBLE)
    mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
    mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
#else
    mpfr_init2(t, DBL_MANT_DIG);
    mpfr_init_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);
#endif
    mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return a;
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
    }
    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      mpfr_sub_z(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
    }
    if(strEQ(h, "Math::GMPf")) {
      mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
      mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      mpfr_sub(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
      return a;
    }
    if(strEQ(h, "Math::GMPq")) {
      mpfr_sub_q(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
    }
  }
  SvREFCNT_dec(a);
  croak("Invalid argument supplied to Math::MPFR::overload_sub_eq function");
}

SV * overload_add_eq(pTHX_ SV * a, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif
  PERL_UNUSED_ARG(third);

  SvREFCNT_inc(a);

#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  if(SV_IS_IOK(b)) {
    mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
    if(SvUOK(b)) mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
    else         mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);

    mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return a;
  }
#else
  DEAL_WITH_NANFLAG_BUG_OVERLOADED
  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) {
      mpfr_add_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return a;
    }

    mpfr_add_si(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
    return a;
  }
#endif
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
        ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_add_eq(aTHX_ +=)");}
#ifdef _WIN32_BIZARRE_INFNAN
    inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
    mpfr_init(t);
    if(inf_or_nan) {
      if(inf_or_nan == 2) {
        mpfr_set_nan(t);
      }
      else mpfr_set_inf(t, inf_or_nan);
    }
    else {
      ret = mpfr_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
    }
#else
    ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif
    NON_NUMERIC_CHAR_CHECK(b), "overload_add_eq subroutine");}

    mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return a;
  }

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
    NOK_POK_DUALVAR_CHECK , "overload_add_eq(aTHX_ +=)");}
#endif
#if defined(USE_QUADMATH)
    mpfr_init2(t, FLT128_MANT_DIG);
    Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);
#elif defined(USE_LONG_DOUBLE)
    mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
    mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
#else
    mpfr_init2(t, DBL_MANT_DIG);
    mpfr_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);
#endif
    mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return a;
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
    }
    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      mpfr_add_z(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
    }
    if(strEQ(h, "Math::GMPf")) {
      mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
      mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      mpfr_add(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
      return a;
    }
    if(strEQ(h, "Math::GMPq")) {
      mpfr_add_q(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
    }
  }
  SvREFCNT_dec(a);
  croak("Invalid argument supplied to Math::MPFR::overload_add_eq");
}

SV * overload_mul_eq(pTHX_ SV * a, SV * b, SV * third) {
  mpfr_t t;
  int ret;
#ifdef _WIN32_BIZARRE_INFNAN
  int inf_or_nan;
#endif
  PERL_UNUSED_ARG(third);

  SvREFCNT_inc(a);
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  if(SV_IS_IOK(b)) {
    mpfr_init2(t, (mpfr_prec_t)IVSIZE_BITS);
    if(SvUOK(b)) mpfr_set_uj(t, SvUVX(b), __gmpfr_default_rounding_mode);
    else         mpfr_set_sj(t, SvIVX(b), __gmpfr_default_rounding_mode);

    mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return a;
  }
#else
  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) {
      mpfr_mul_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvUVX(b), __gmpfr_default_rounding_mode);
      return a;
    }

    mpfr_mul_si(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), SvIVX(b), __gmpfr_default_rounding_mode);
    return a;
  }
#endif
#if defined(MPFR_PV_NV_BUG)
  if( (SV_IS_POK(b) && !SV_IS_NOK(b))
           ||
      (SV_IS_POK(b) && SV_IS_NOK(b) && SvIOKp(b)) ) {
#else
  if(SV_IS_POK(b)) {
#endif
    NOK_POK_DUALVAR_CHECK , "overload_mul_eq");}

#ifdef _WIN32_BIZARRE_INFNAN
   inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
   mpfr_init(t);
   if(inf_or_nan) {
     if(inf_or_nan == 2) {
       mpfr_set_nan(t);
     }
     else mpfr_set_inf(t, inf_or_nan);
   }
   else {
     ret = mpfr_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
   }
#else
   ret = mpfr_init_set_str(t, SvPV_nolen(b), 0, __gmpfr_default_rounding_mode);
#endif
   NON_NUMERIC_CHAR_CHECK(b), "overload_mul_eq subroutine");}

   mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
   mpfr_clear(t);
   return a;
 }

  if(SV_IS_NOK(b)) {
#if defined(MPFR_PV_NV_BUG)
       NOK_POK_DUALVAR_CHECK , "overload_mul_eq");}
#endif
#if defined(USE_QUADMATH)
    mpfr_init2(t, FLT128_MANT_DIG);
    Rmpfr_set_NV(aTHX_ &t, b, __gmpfr_default_rounding_mode);
#elif defined(USE_LONG_DOUBLE)
    mpfr_init2(t, REQUIRED_LDBL_MANT_DIG);
    mpfr_set_ld(t, (long double)SvNVX(b), __gmpfr_default_rounding_mode);
#else
    mpfr_init2(t, DBL_MANT_DIG);
    mpfr_init_set_d(t, (double)SvNVX(b), __gmpfr_default_rounding_mode);
#endif
    mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
    mpfr_clear(t);
    return a;
  }

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
    }
    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      mpfr_mul_z(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
    }
    if(strEQ(h, "Math::GMPf")) {
      mpfr_init2(t, (mpfr_prec_t)mpf_get_prec(*(INT2PTR(mpf_t *, SvIVX(SvRV(b))))));
      mpfr_set_f(t, *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      mpfr_mul(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), t, __gmpfr_default_rounding_mode);
      mpfr_clear(t);
       return a;
    }
    if(strEQ(h, "Math::GMPq")) {
      mpfr_mul_q(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))), __gmpfr_default_rounding_mode);
      return a;
     }
  }
  SvREFCNT_dec(a);
  croak("Invalid argument supplied to Math::MPFR::overload_mul_eq");
}

SV * _itsa(pTHX_ SV * a) {
  if(SV_IS_IOK(a)) {
    if(SvUOK(a)) return newSVuv(1);
    return newSVuv(2);
  }
  if(SV_IS_POK(a)) {
#if defined(MPFR_PV_NV_BUG)        /* perl can set the POK flag when it should not */
    if(SvNOK(a) && !SvIOKp(a))
      return newSVuv(3);        /* designate it as NV */
#endif
    return newSVuv(4);          /* designate it as PV */
  }
  if(SV_IS_NOK(a)) return newSVuv(3);
  if(sv_isobject(a)) {
    const char* h = HvNAME(SvSTASH(SvRV(a)));

    if(strEQ(h, "Math::MPFR")) return newSVuv(5);
    if(strEQ(h, "Math::GMPf")) return newSVuv(6);
    if(strEQ(h, "Math::GMPq")) return newSVuv(7);
    if(strEQ(h, "Math::GMPz")) return newSVuv(8);
    if(strEQ(h, "Math::GMP")) return newSVuv(9);
  }
  return newSVuv(0);
}

int _has_longlong(void) {
#ifdef MATH_MPFR_NEED_LONG_LONG_INT
  return 1;
#else
  return 0;
#endif
}

int _has_longdouble(void) {
#if defined(USE_LONG_DOUBLE) || defined(USE_QUADMATH)
  return 1;
#else
  return 0;
#endif
}

int _ivsize_bits(void) {
  int ret = 0;
#ifdef IVSIZE_BITS
  ret = IVSIZE_BITS;
#endif
  return ret;
}

SV * RMPFR_PREC_MAX(pTHX) {
  return newSViv(MPFR_PREC_MAX);
}

SV * RMPFR_PREC_MIN(pTHX) {
  return newSViv(MPFR_PREC_MIN);
}

SV * wrap_mpfr_printf(pTHX_ SV * a, SV * b) {
  int ret;
  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")){
      ret = mpfr_printf(SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
      fflush(stdout);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::MPFR::Prec")){
      ret = mpfr_printf(SvPV_nolen(a), *(INT2PTR(mpfr_prec_t *, SvIVX(SvRV(b)))));
      fflush(stdout);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMP") || strEQ(h, "Math::GMPz")){
      ret = mpfr_printf(SvPV_nolen(a), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
      fflush(stdout);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMPq")){
      ret = mpfr_printf(SvPV_nolen(a), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
      fflush(stdout);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMPf")){
      ret = mpfr_printf(SvPV_nolen(a), *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))));
      fflush(stdout);
      return newSViv(ret);
    }
    croak("Unrecognised object supplied as argument to Rmpfr_printf");
  }

  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) ret = mpfr_printf(SvPV_nolen(a), SvUVX(b));
    else         ret = mpfr_printf(SvPV_nolen(a), SvIVX(b));

    fflush(stdout);
    return newSViv(ret);
  }

  if(SV_IS_POK(b)) {

    NOK_POK_DUALVAR_CHECK , "wrap_mpfr_printf");}

    ret = mpfr_printf(SvPV_nolen(a), SvPV_nolen(b));
    fflush(stdout);
    return newSViv(ret);
  }

  if(SV_IS_NOK(b)) {
    ret = mpfr_printf(SvPV_nolen(a), SvNVX(b));
    fflush(stdout);
    return newSViv(ret);
  }
  croak("Unrecognised type supplied as argument to Rmpfr_printf");
}

SV * wrap_mpfr_fprintf(pTHX_ FILE * stream, SV * a, SV * b) {
  int ret;
  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      ret = mpfr_fprintf(stream, SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
      fflush(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::MPFR::Prec")) {
      ret = mpfr_fprintf(stream, SvPV_nolen(a), *(INT2PTR(mpfr_prec_t *, SvIVX(SvRV(b)))));
      fflush(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      ret = mpfr_fprintf(stream, SvPV_nolen(a), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
      fflush(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMPq")) {
      ret = mpfr_fprintf(stream, SvPV_nolen(a), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
      fflush(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMPf")) {
      ret = mpfr_fprintf(stream, SvPV_nolen(a), *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))));
      fflush(stream);
      return newSViv(ret);
    }
    croak("Unrecognised object supplied as argument to Rmpfr_fprintf");
  }

  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) ret = mpfr_fprintf(stream, SvPV_nolen(a), SvUVX(b));
    else         ret = mpfr_fprintf(stream, SvPV_nolen(a), SvIVX(b));

    fflush(stream);
    return newSViv(ret);
  }

  if(SV_IS_POK(b)) {

    NOK_POK_DUALVAR_CHECK , "wrap_mpfr_fprintf");}

    ret = mpfr_fprintf(stream, SvPV_nolen(a), SvPV_nolen(b));
    fflush(stream);
    return newSViv(ret);
  }

  if(SV_IS_NOK(b)) {
    ret = mpfr_fprintf(stream, SvPV_nolen(a), SvNVX(b));
    fflush(stream);
    return newSViv(ret);
  }
  croak("Unrecognised type supplied as argument to Rmpfr_fprintf");
}

SV * wrap_mpfr_sprintf(pTHX_ SV * s, SV * a, SV * b, int buflen) {
  int ret;
  char * stream;

  Newx(stream, buflen, char);

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      ret = mpfr_sprintf(stream, SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::MPFR::Prec")) {
      ret = mpfr_sprintf(stream, SvPV_nolen(a), *(INT2PTR(mpfr_prec_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      ret = mpfr_sprintf(stream, SvPV_nolen(a), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMPq")) {
      ret = mpfr_sprintf(stream, SvPV_nolen(a), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMPf")) {
      ret = mpfr_sprintf(stream, SvPV_nolen(a), *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }

    Safefree(stream); /* in case the ensuing croak() occurs inside eval{} */
    croak("Unrecognised object supplied as argument to Rmpfr_sprintf");
  }

  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) ret = mpfr_sprintf(stream, SvPV_nolen(a), SvUVX(b));
    else         ret = mpfr_sprintf(stream, SvPV_nolen(a), SvIVX(b));

    sv_setpv(s, stream);
    Safefree(stream);
    return newSViv(ret);
  }

  if(SV_IS_POK(b)) {
    NOK_POK_DUALVAR_CHECK , "wrap_mpfr_sprintf");}

    ret = mpfr_sprintf(stream, SvPV_nolen(a), SvPV_nolen(b));
    sv_setpv(s, stream);
    Safefree(stream);
    return newSViv(ret);
  }

  if(SV_IS_NOK(b)) {
    ret = mpfr_sprintf(stream, SvPV_nolen(a), SvNVX(b));
    sv_setpv(s, stream);
    Safefree(stream);
    return newSViv(ret);
  }
  Safefree(stream); /* in case the ensuing croak() occurs inside eval{} */
  croak("Unrecognised type supplied as argument to Rmpfr_sprintf");
}

SV * wrap_mpfr_snprintf(pTHX_ SV * s, SV * bytes, SV * a, SV * b, int buflen) {
  int ret;
  char * stream;

  Newx(stream, buflen, char);

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::MPFR::Prec")) {
      ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), *(INT2PTR(mpfr_prec_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMPz") || strEQ(h, "Math::GMP")) {
      ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), *(INT2PTR(mpz_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMPq")) {
      ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), *(INT2PTR(mpq_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::GMPf")) {
      ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), *(INT2PTR(mpf_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }
    Safefree(stream); /* in case the ensuing croak() occurs inside eval{} */
    croak("Unrecognised object supplied as argument to Rmpfr_snprintf");
  }

  if(SV_IS_IOK(b)) {
    if(SvUOK(b)) ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvUVX(b));
    else         ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvIVX(b));

    sv_setpv(s, stream);
    Safefree(stream);
    return newSViv(ret);
  }

  if(SV_IS_POK(b)) {
    NOK_POK_DUALVAR_CHECK , "wrap_mpfr_snprintf");}

    ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvPV_nolen(b));
    sv_setpv(s, stream);
    Safefree(stream);
    return newSViv(ret);
  }

  if(SV_IS_NOK(b)) {
    ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvNVX(b));
    sv_setpv(s, stream);
    Safefree(stream);
    return newSViv(ret);
  }
  Safefree(stream); /* in case the ensuing croak() occurs inside eval{} */
  croak("Unrecognised type supplied as argument to Rmpfr_snprintf");
}

SV * wrap_mpfr_printf_rnd(pTHX_ SV * a, SV * round, SV * b) {
  int ret;
  if((mpfr_rnd_t)SvUV(round) > 4) croak("Invalid 2nd argument (rounding value) of %u passed to Rmpfr_printf", (mpfr_rnd_t)SvUV(round));
  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")){
      ret = mpfr_printf(SvPV_nolen(a), (mpfr_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
      fflush(stdout);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::MPFR::Prec")){
      croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_printf");
    }
    croak("Unrecognised object supplied as argument to Rmpfr_printf");
  }
  croak("In Rmpfr_printf: The rounding argument is specific to Math::MPFR objects");
}

SV * wrap_mpfr_fprintf_rnd(pTHX_ FILE * stream, SV * a, SV * round, SV * b) {
  int ret;
  if((mpfr_rnd_t)SvUV(round) > 4) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_fprintf", (mpfr_rnd_t)SvUV(round));
  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      ret = mpfr_fprintf(stream, SvPV_nolen(a), (mpfr_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
      fflush(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::MPFR::Prec")) {
      croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_fprintf");
    }
    croak("Unrecognised object supplied as argument to Rmpfr_fprintf");
  }
  croak("In Rmpfr_fprintf: The rounding argument is specific to Math::MPFR objects");
}

SV * wrap_mpfr_sprintf_rnd(pTHX_ SV * s, SV * a, SV * round, SV * b, int buflen) {
  int ret;
  char * stream;

  Newx(stream, buflen, char);

  if((mpfr_rnd_t)SvUV(round) > 4) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_sprintf", (mpfr_rnd_t)SvUV(round));

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      ret = mpfr_sprintf(stream, SvPV_nolen(a), (mpfr_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::MPFR::Prec")) {
      croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_sprintf");
    }
    croak("Unrecognised object supplied as argument to Rmpfr_sprintf");
  }
  croak("In Rmpfr_sprintf: The rounding argument is specific to Math::MPFR objects");
}

SV * wrap_mpfr_snprintf_rnd(pTHX_ SV * s, SV * bytes, SV * a, SV * round, SV * b, int buflen) {
  int ret;
  char * stream;

  Newx(stream, buflen, char);

  if((mpfr_rnd_t)SvUV(round) > 4) croak("Invalid 3rd argument (rounding value) of %u passed to Rmpfr_snprintf", (mpfr_rnd_t)SvUV(round));

  if(sv_isobject(b)) {
    const char* h = HvNAME(SvSTASH(SvRV(b)));

    if(strEQ(h, "Math::MPFR")) {
      ret = mpfr_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), (mpfr_rnd_t)SvUV(round), *(INT2PTR(mpfr_t *, SvIVX(SvRV(b)))));
      sv_setpv(s, stream);
      Safefree(stream);
      return newSViv(ret);
    }

    if(strEQ(h, "Math::MPFR::Prec")) {
      croak("You've provided both a rounding arg and a Math::MPFR::Prec object to Rmpfr_snprintf");
    }
    croak("Unrecognised object supplied as argument to Rmpfr_snprintf");
  }
  croak("In Rmpfr_snprintf: The rounding argument is specific to Math::MPFR objects");
}


SV * Rmpfr_buildopt_tls_p(pTHX) {
  return newSViv(mpfr_buildopt_tls_p());
}

SV * Rmpfr_buildopt_float16_p(pTHX) {
#if MPFR_VERSION >= 262912
  return newSViv(mpfr_buildopt_float16_p());
#else
  croak("'mpfr_buildopt_float16_p' not implemented until MPFR-4.3.0");
#endif
}

SV * Rmpfr_buildopt_decimal_p(pTHX) {
  return newSViv(mpfr_buildopt_decimal_p());
}

SV * Rmpfr_regular_p(pTHX_ mpfr_t * a) {
  return newSViv(mpfr_regular_p(*a));
}

void Rmpfr_set_zero(pTHX_ mpfr_t * a, SV * sign) {
  mpfr_set_zero(*a, (int)SvIV(sign));
}

SV * Rmpfr_digamma(pTHX_ mpfr_t * rop, mpfr_t * op, SV * round) {
  return newSViv(mpfr_digamma(*rop, *op, (mpfr_rnd_t)SvIV(round)));
}

SV * Rmpfr_trigamma(pTHX_ mpfr_t * rop, mpfr_t * op, SV * round) {
#if MPFR_VERSION >= 262912
  return newSViv(mpfr_trigamma(*rop, *op, (mpfr_rnd_t)SvIV(round)));
#else
  PERL_UNUSED_ARG3(rop, op, round);
  croak("Rmpfr_trigamma function not implemented until mpfr-4.3.0. (You have only version %s) ", MPFR_VERSION_STRING);
#endif

}

SV * Rmpfr_ai(pTHX_ mpfr_t * rop, mpfr_t * op, SV * round) {
  return newSViv(mpfr_ai(*rop, *op, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_flt(pTHX_ mpfr_t * a, SV * round) {
  return newSVnv(mpfr_get_flt(*a, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_get_float16(pTHX_ mpfr_t * a, SV * round) {
#if MPFR_VERSION >= MPFR_VERSION_NUM(4,3,0)
#  if defined(HAVE_FLOAT16)      /* defined in Makefile.PL */
   return newSVnv(mpfr_get_float16(*a, (mpfr_rnd_t)SvUV(round)));
#  else
   PERL_UNUSED_ARG2(a, round);
   croak("Perl interface to Rmpfr_get_float16 not available. The '_Float16' type was not recognized");
#  endif
#else
  PERL_UNUSED_ARG2(a, round);
  croak("Perl interface to Rmpfr_get_float16 not available for this version (%s) of the mpfr library. We need at least version 4.3.0",
         MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_set_flt(pTHX_ mpfr_t * rop, SV * f, SV * round) {
  return newSViv(mpfr_set_flt(*rop, (float)SvNV(f), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_float16(pTHX_ mpfr_t * rop, SV * f, SV * round) {
#if MPFR_VERSION >= MPFR_VERSION_NUM(4,3,0)
#  if defined(HAVE_FLOAT16)      /* defined in Makefile.PL */
   return newSViv(mpfr_set_flt(*rop, (_Float16)SvNV(f), (mpfr_rnd_t)SvUV(round)));
#  else
   PERL_UNUSED_ARG3(rop, f, round);
   croak("Perl interface to Rmpfr_set_float16 not available. The '_Float16' type was not recognized");
#  endif
#else
  PERL_UNUSED_ARG3(rop, f, round);
  croak("Perl interface to Rmpfr_set_float16 not available for this version (%s) of the mpfr library. We need at least version 4.3.0",
         MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_urandom(pTHX_ mpfr_t * rop, gmp_randstate_t* state, SV * round) {
  return newSViv(mpfr_urandom(*rop, *state, (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_set_z_2exp(pTHX_ mpfr_t * rop, mpz_t * op, SV * exp, SV * round) {
  return newSViv(mpfr_set_z_2exp(*rop, *op, (mpfr_exp_t)SvIV(exp), (mpfr_rnd_t)SvUV(round)));
}

SV * Rmpfr_buildopt_tune_case(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
  return newSVpv(mpfr_buildopt_tune_case(), 0);
#else
  croak("Rmpfr_buildopt_tune_case not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_frexp(pTHX_ SV * exp, mpfr_t * rop, mpfr_t * op, SV * round) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
  mpfr_exp_t _exp;
  int ret;

  ret = mpfr_frexp(&_exp, *rop, *op, (mpfr_rnd_t)SvUV(round));
  sv_setiv(exp, _exp);
     return newSViv(ret);
#else
  croak("Rmpfr_frexp not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_z_sub(pTHX_ mpfr_t * rop, mpz_t * op1, mpfr_t * op2, SV * round) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
  return newSViv(mpfr_z_sub(*rop, *op1, *op2, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(rop,op1, op2, round);
  croak("Rmpfr_z_sub not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_grandom(pTHX_ mpfr_t * rop1, mpfr_t * rop2, gmp_randstate_t * state, SV * round) {
#if MPFR_VERSION_MAJOR >= 4
  PERL_UNUSED_ARG4(rop1, rop2, state, round);
  croak("Rmpfr_grandom is deprecated, and now removed - use Rmpfr_nrandom instead");
#elif (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
  return newSViv(mpfr_grandom(*rop1, *rop2, *state, (mpfr_rnd_t)SvUV(round)));
#else
  PERL_UNUSED_ARG4(rop1, rop2, state, round);
  croak("Rmpfr_grandom was not introduced until mpfr-3.1.0 and was then deprecated & replaced by Rmpfr_nrandom as of mpfr-4.0.0");
#endif
}

void Rmpfr_clear_divby0(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
  mpfr_clear_divby0();
#else
  croak("Rmpfr_clear_divby0 not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_set_divby0(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
  mpfr_set_divby0();
#else
  croak("Rmpfr_set_divby0 not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_divby0_p(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
  return newSViv(mpfr_divby0_p());
#else
  croak("Rmpfr_divby0_p not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_buildopt_gmpinternals_p(pTHX) {
#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3
  return newSViv(mpfr_buildopt_gmpinternals_p());
#else
  croak("Rmpfr_buildopt_gmpinternals_p not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

SV * _get_xs_version(pTHX) {
  return newSVpv(XS_VERSION, 0);
}

void overload_inc(pTHX_ SV * a, SV * b, SV * third) {
  PERL_UNUSED_ARG2(b, third);
  DEAL_WITH_NANFLAG_BUG_OVERLOADED
  mpfr_add_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), 1, __gmpfr_default_rounding_mode);
}

void overload_dec(pTHX_ SV * a, SV * b, SV * third) {
  PERL_UNUSED_ARG2(b, third);
  DEAL_WITH_NANFLAG_BUG_OVERLOADED
  mpfr_sub_ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), 1, __gmpfr_default_rounding_mode);
}

SV * _overload_lshift(pTHX_ mpfr_t * a, SV * b, SV * third) {
  /* b will be +ve ... otherwise overload_rshift would have been called. */
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;

#if IVSIZE > LONGSIZE
      if( SvUV(b) > (unsigned long)SvUV(b) ) croak ("In Math::MPFR overloading of '<<' operator, the 'shift' operand overflows 'long int'");
#endif

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_mul_2exp) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);
  PERL_UNUSED_ARG(third);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */

  mpfr_trunc(*mpfr_t_obj, *a);
  mpfr_mul_2ui(*mpfr_t_obj, *mpfr_t_obj, (unsigned long)SvUV(b), __gmpfr_default_rounding_mode);
  return obj_ref;

}

SV * _overload_rshift(pTHX_ mpfr_t * a, SV * b, SV * third) {
  /* b will be +ve ... otherwise overload_lshift would have been called. */
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  mpz_t z;

#if IVSIZE > LONGSIZE
      if( SvUV(b) > (mp_bitcnt_t)SvUV(b) ) croak ("In Math::MPFR overloading of '>>' operator, the 'shift' operand overflows 'long int'");
#endif

  NEW_MATH_MPFR_OBJECT("Math::MPFR",overload_mul_2exp) /* defined in math_mpfr_include.h */
  mpfr_init(*mpfr_t_obj);
  PERL_UNUSED_ARG(third);
  OBJ_READONLY_ON /*defined in math_mpfr_include.h */

  if(!mpfr_number_p(*a)) { /* Is either an Inf or NaN */
     if(mpfr_nan_p(*a)) return obj_ref;  /* return NaN */
     mpfr_set_inf(*mpfr_t_obj, mpfr_sgn(*a));
     return obj_ref; /* Return appropriately signed Inf */
  }
  mpz_init(z);
  mpfr_get_z(z, *a, GMP_RNDZ); /* Truncate *a */
  mpz_div_2exp(z, z, (mp_bitcnt_t)SvUV(b));
  mpfr_set_z(*mpfr_t_obj, z, __gmpfr_default_rounding_mode);
  mpz_clear(z);
  return obj_ref;
}

SV * _overload_lshift_eq(pTHX_ SV * a, SV * b, SV * third) {
  /* b will be +ve ... otherwise overload_rshift_eq would have been called. */

#if IVSIZE > LONGSIZE
      if( SvUV(b) > (unsigned long) SvUV(b) ) croak ("In Math::MPFR overloading of '<<=' operator, the 'shift' operand overflows 'long int'");
#endif

    SvREFCNT_inc(a);
    mpfr_trunc(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))));
    mpfr_mul_2ui(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), (unsigned long)SvUV(b), __gmpfr_default_rounding_mode);
    return a;
}

SV * _overload_rshift_eq(pTHX_ SV * a, SV * b, SV * third) {
  /* b will be +ve ... otherwise overload_lshift_eq would have been called. */
  mpz_t z;

#if IVSIZE > LONGSIZE
      if( SvUV(b) > (mp_bitcnt_t) SvUV(b) ) croak ("In Math::MPFR overloading of '>>=' operator, the 'shift' operand overflows 'long int'");
#endif

    SvREFCNT_inc(a);
    if(  mpfr_nan_p( *(INT2PTR(mpfr_t *, SvIVX(SvRV(a))))) ||
         mpfr_inf_p( *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))))   ) return a;
    mpz_init(z);
    mpfr_get_z(z, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), GMP_RNDZ); /* Truncate *a */
    mpz_div_2exp(z, z, (mp_bitcnt_t)SvUV(b));
    mpfr_set_z(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), z, __gmpfr_default_rounding_mode);
    mpz_clear(z);
    return a;
}

SV * _wrap_count(pTHX) {
  return newSVuv(PL_sv_count);
}

SV * Rmpfr_set_LD(pTHX_ mpfr_t * rop, SV * op, SV *rnd) {
  if(sv_isobject(op)) {
    const char* h = HvNAME(SvSTASH(SvRV(op)));

    if(strEQ(h, "Math::LongDouble")) {
      return newSViv(mpfr_set_ld(*rop, *(INT2PTR(long double *, SvIVX(SvRV(op)))), (mpfr_rnd_t)SvUV(rnd)));
    }
    croak("2nd arg (a %s object) supplied to Rmpfr_set_LD needs to be a Math::LongDouble object",
           HvNAME(SvSTASH(SvRV(op))));
  }
  else croak("2nd arg (which needs to be a Math::LongDouble object) supplied to Rmpfr_set_LD is not an object");
}

/*
int mpfr_set_decimal64 (mpfr_t rop, _Decimal64 op, mpfr_rnd_t rnd)
*/

SV * Rmpfr_set_DECIMAL64(pTHX_ mpfr_t * rop, SV * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION<MPFR_VERSION_NUM(3,1,0)))
  PERL_UNUSED_ARG3(rop, op, round);
  croak("Perl interface to Rmpfr_set_DECIMAL64 not available for this version (%s) of the mpfr library. We need at least version 3.1.0",
            MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_DECIMAL_FLOATS needs to have been defined prior to inclusion of mpfr.h.
 MPFR_WANT_DECIMAL164 also needs to be defined.
 See the Makefile.PL
*/

#if defined(MPFR_WANT_DECIMAL_FLOATS) && defined(MPFR_WANT_DECIMAL64)
  if(sv_isobject(op)) {
    const char* h = HvNAME(SvSTASH(SvRV(op)));

    if(strEQ(h, "Math::Decimal64"))
      return newSViv(mpfr_set_decimal64(*rop, *(INT2PTR(_Decimal64 *, SvIVX(SvRV(op)))), (mpfr_rnd_t)SvUV(rnd)));
    croak("2nd arg (a %s object) supplied to Rmpfr_set_DECIMAL64 needs to be a Math::Decimal64 object",
          HvNAME(SvSTASH(SvRV(op))));
  }
  else croak("2nd arg (which needs to be a Math::Decimal64 object) supplied to Rmpfr_set_DECIMAL64 is not an object");
#else
#  if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(3,1,0)
    if( mpfr_buildopt_decimal_p() ) {
      warn("To make Rmpfr_set_DECIMAL64 available, rebuild Math::MPFR and pass \"D64=1\" as an arg to the Makefile.PL\n");
      croak("See \"PASSING _Decimal64 & _Decimal128 VALUES\" in the Math::MPFR documentation");
    }
#  endif
  croak("Both MPFR_WANT_DECIMAL_FLOATS and MPFR_WANT_DECIMAL64 need to have been defined when building Math::MPFR - see \"PASSING _Decimal64 & _Decimal128 VALUES\" in the Math::MPFR documentation");
#endif
}

/**********************************************
 **********************************************/


SV * Rmpfr_set_DECIMAL128(pTHX_ mpfr_t * rop, SV * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION<MPFR_VERSION_NUM(4,1,0)))
  croak("Perl interface to Rmpfr_set_DECIMAL128 not available for this version (%s) of the mpfr library. We need at least version 4.1.0",
         MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_DECIMAL_FLOATS needs to have been defined prior to inclusion of mpfr.h.
 MPFR_WANT_DECIMAL1128 also needs to be defined.
 See the Makefile.PL
*/

#if defined(MPFR_WANT_DECIMAL_FLOATS) && defined(MPFR_WANT_DECIMAL128)
  if(sv_isobject(op)) {
    const char* h = HvNAME(SvSTASH(SvRV(op)));

    if(strEQ(h, "Math::Decimal128"))
      return newSViv(mpfr_set_decimal128(*rop, *(INT2PTR(D128 *, SvIVX(SvRV(op)))), (mpfr_rnd_t)SvUV(rnd)));
     croak("2nd arg (a %s object) supplied to Rmpfr_set_DECIMAL128 needs to be a Math::Decimal128 object",
             HvNAME(SvSTASH(SvRV(op))));
  }
  else croak("2nd arg (which needs to be a Math::Decimal128 object) supplied to Rmpfr_set_DECIMAL128 is not an object");
#else
#  if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,1,0)
    if( mpfr_buildopt_decimal_p() ) {
      warn("To make Rmpfr_set_DECIMAL128 available, rebuild Math::MPFR and pass \"D128=1\"  as separate args to the Makefile.PL\n");
      croak("See \"PASSING _Decimal64 & _Decimal128 VALUES\" in the Math::MPFR documentation");
    }
#  endif
  croak("Both MPFR_WANT_DECIMAL_FLOATS and MPFR_WANT_DECIMAL128 need to have been defined when building Math::MPFR");
#endif
}

/**********************************************
 **********************************************/

void Rmpfr_get_LD(pTHX_ SV * rop, mpfr_t * op, SV * rnd) {
  if(sv_isobject(rop)) {
    const char* h = HvNAME(SvSTASH(SvRV(rop)));

    if(strEQ(h, "Math::LongDouble")) {
      *(INT2PTR(long double *, SvIVX(SvRV(rop)))) = mpfr_get_ld(*op, (mpfr_rnd_t)SvUV(rnd));
    }
    else croak("1st arg (a %s object) supplied to Rmpfr_get_LD needs to be a Math::LongDouble object",
                HvNAME(SvSTASH(SvRV(rop))));
  }
  else {
    PERL_UNUSED_ARG2(op, rnd);
    croak("1st arg (which needs to be a Math::LongDouble object) supplied to Rmpfr_get_LD is not an object");
  }
}

/**********************************************
 **********************************************/

void Rmpfr_get_DECIMAL64(pTHX_ SV * rop, mpfr_t * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION<MPFR_VERSION_NUM(3,1,0)))
   croak("Perl interface to Rmpfr_get_DECIMAL64 not available for this version (%s) of the mpfr library. We need at least version 3.1.0",
            MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_DECIMAL_FLOATS needs to have been defined prior to inclusion of mpfr.h.
 MPFR_WANT_DECIMAL164 also needs to be defined.
 See the Makefile.PL
*/

#if defined(MPFR_WANT_DECIMAL_FLOATS) && defined(MPFR_WANT_DECIMAL64)
  if(sv_isobject(rop)) {
    const char* h = HvNAME(SvSTASH(SvRV(rop)));

    if(strEQ(h, "Math::Decimal64"))
      *(INT2PTR(_Decimal64 *, SvIVX(SvRV(rop)))) = mpfr_get_decimal64(*op, (mp_rnd_t)SvUV(rnd));

     else croak("1st arg (a %s object) supplied to Rmpfr_get_DECIMAL64 needs to be a Math::Decimal64 object",
                    HvNAME(SvSTASH(SvRV(rop))));
    }
  else croak("1st arg (which needs to be a Math::Decimal64 object) supplied to Rmpfr_get_DECIMAL64 is not an object");
#else
#  if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(3,1,0)
    if( mpfr_buildopt_decimal_p() ) {
      warn("To make Rmpfr_get_DECIMAL64 available, rebuild Math::MPFR and pass \"D64=1\" as an arg to the Makefile.PL\n");
      croak("See \"PASSING _Decimal64 & _Decimal128 VALUES\" in the Math::MPFR documentation");
    }
#  endif
  croak("Both MPFR_WANT_DECIMAL_FLOATS and MPFR_WANT_DECIMAL64 need to have been defined when building Math::MPFR");
#endif
}

/**********************************************
 **********************************************/

void Rmpfr_get_DECIMAL128(pTHX_ SV * rop, mpfr_t * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION<MPFR_VERSION_NUM(4,1,0)))
   croak("Perl interface to Rmpfr_get_DECIMAL128 not available for this version (%s) of the mpfr library. We need at least version 4.1.0",
            MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_DECIMAL_FLOATS needs to have been defined prior to inclusion of mpfr.h.
 MPFR_WANT_DECIMAL1128 also needs to be defined.
 See the Makefile.PL
*/

#if defined(MPFR_WANT_DECIMAL_FLOATS) && defined(MPFR_WANT_DECIMAL128)
  if(sv_isobject(rop)) {
    const char* h = HvNAME(SvSTASH(SvRV(rop)));

    if(strEQ(h, "Math::Decimal128"))
      *(INT2PTR(D128 *, SvIVX(SvRV(rop)))) = mpfr_get_decimal128(*op, (mp_rnd_t)SvUV(rnd));

     else croak("1st arg (a %s object) supplied to Rmpfr_get_DECIMAL128 needs to be a Math::Decimal128 object",
                    HvNAME(SvSTASH(SvRV(rop))));
  }
  else croak("1st arg (which needs to be a Math::Decimal128 object) supplied to Rmpfr_get_DECIMAL128 is not an object");
#else
#  if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,1,0)
    if( mpfr_buildopt_decimal_p() ) {
      warn("To make Rmpfr_get_DECIMAL128 available, rebuild Math::MPFR and pass \"D128=1\" as an arg to the Makefile.PL\n");
      croak("See \"PASSING _Decimal64 & _Decimal128 VALUES\" in the Math::MPFR documentation");
    }
#  endif
  croak("Both MPFR_WANT_DECIMAL_FLOATS and MPFR_WANT_DECIMAL128 need to have been defined when building Math::MPFR");
#endif
}


/**********************************************
 **********************************************/

int _MPFR_WANT_DECIMAL_FLOATS(void) {
#ifdef MPFR_WANT_DECIMAL_FLOATS
  return 1;
#else
  return 0;
#endif
}

int _MPFR_WANT_DECIMAL64(void) {
#ifdef MPFR_WANT_DECIMAL64
  return 1;
#else
  return 0;
#endif
}

int _MPFR_WANT_DECIMAL128(void) {
#ifdef MPFR_WANT_DECIMAL128
  return 1;
#else
  return 0;
#endif
}

int _MPFR_WANT_FLOAT128(void) {
#ifdef MPFR_WANT_FLOAT128
  return 1;
#else
  return 0;
#endif
}

SV * _max_base(pTHX) {
  return newSViv(62);
}

SV * _isobject(pTHX_ SV * x) {
  if(sv_isobject(x))return newSVuv(1);
  return newSVuv(0);
}

void _mp_sizes(void) {
  dTHX;
  dXSARGS;
  PERL_UNUSED_ARG(items);
  XPUSHs(sv_2mortal(newSVuv(sizeof(mpfr_exp_t))));
  XPUSHs(sv_2mortal(newSVuv(sizeof(mpfr_prec_t))));
  XPUSHs(sv_2mortal(newSVuv(sizeof(mpfr_rnd_t))));
  XSRETURN(3);
}

SV * _ivsize(pTHX) {
  return newSVuv(sizeof(IV));
}

SV * _nvsize(pTHX) {
  return newSVuv(sizeof(NV));
}

SV * _FLT128_DIG(pTHX) {
#ifdef FLT128_DIG
  return newSViv(FLT128_DIG);
#else
  return &PL_sv_undef;
#endif
}

SV * _LDBL_DIG(pTHX) {
#ifdef LDBL_DIG
  return newSViv(LDBL_DIG);
#else
  return &PL_sv_undef;
#endif
}

SV * _DBL_DIG(pTHX) {
#ifdef DBL_DIG
  return newSViv(DBL_DIG);
#else
  return &PL_sv_undef;
#endif
}

SV * _FLT128_MANT_DIG(pTHX) {
#ifdef FLT128_MANT_DIG
  return newSViv(FLT128_MANT_DIG);
#else
  return &PL_sv_undef;
#endif
}

SV * _LDBL_MANT_DIG(pTHX) {
#ifdef LDBL_MANT_DIG
  return newSViv(LDBL_MANT_DIG);
#else
  return &PL_sv_undef;
#endif
}

SV * _DBL_MANT_DIG(pTHX) {
#ifdef DBL_MANT_DIG
  return newSViv(DBL_MANT_DIG);
#else
  return &PL_sv_undef;
#endif
}


/*///////////////////////////////////////////
////////////////////////////////////////////*/
/* All randinit functions now moved to Math::MPFR::Random */
/*

*/
/***********************************************
************************************************/

SV * Rmpfr_get_float128(pTHX_ mpfr_t * op, SV * rnd) {

#ifdef CAN_PASS_FLOAT128
  return newSVnv(mpfr_get_float128(*op, (mpfr_rnd_t)SvUV(rnd)));
#else
#  if MPFR_VERSION_MAJOR >= 4
    if(mpfr_buildopt_float128_p()) {
      warn("To make Rmpfr_get_float128 available, rebuild Math::MPFR and pass \"F128=1\" as an arg to the Makefile.PL\n");
      croak("See \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
    }
#  endif
    PERL_UNUSED_ARG2(op, rnd);
    croak("Cannot use Rmpfr_get_float128 to return an NV - see \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
#endif
}

void Rmpfr_get_FLOAT128(pTHX_ SV * rop, mpfr_t * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION < MPFR_VERSION_NUM(4,0,0)))
  croak("Perl interface to Rmpfr_get_FLOAT128 not available for this version (%s) of the mpfr library. We need at least version 4.0.0",
           MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_FLOAT128 needs to have been defined prior to inclusion of mpfr.h - this is done by
 defining it at the 'Makefile.PL' step - see the Makefile.PL
*/

#ifdef MPFR_WANT_FLOAT128

  if(sv_isobject(rop)) {
    const char* h = HvNAME(SvSTASH(SvRV(rop)));

    if(strEQ(h, "Math::Float128"))
      *(INT2PTR(float128 *, SvIVX(SvRV(rop)))) = mpfr_get_float128(*op, (mpfr_rnd_t)SvUV(rnd));
    else croak("1st arg (a %s object) supplied to Rmpfr_get_FLOAT128 needs to be a Math::Float128 object",
                    HvNAME(SvSTASH(SvRV(rop))));
  }
  else croak("1st arg (which needs to be a Math::Float128 object) supplied to Rmpfr_get_FLOAT128 is not an object");
#else
#  if MPFR_VERSION_MAJOR >= 4
    if(mpfr_buildopt_float128_p()) {
      warn("To make Rmpfr_get_FLOAT128 available, rebuild Math::MPFR and pass \"F128=1\" as an arg to the Makefile.PL\n");
      croak("See \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
    }
#  endif
    croak("MPFR_WANT_FLOAT128 needs to have been defined when building Math::MPFR - - see \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
#endif
}

SV * Rmpfr_set_FLOAT128(pTHX_ mpfr_t * rop, SV * op, SV * rnd) {
#if (!defined(MPFR_VERSION) || (MPFR_VERSION < MPFR_VERSION_NUM(4,0,0)))
  PERL_UNUSED_ARG3(rop, op, rnd);
  croak("Perl interface to Rmpfr_set_FLOAT128 not available for this version (%s) of the mpfr library. We need at least version 4.0.0",
         MPFR_VERSION_STRING);
#endif

/*
 MPFR_WANT_FLOAT128 needs to have been defined prior to inclusion of mpfr.h - this is done by
 defining it at the 'Makefile.PL' step - see the Makefile.PL
*/

#ifdef MPFR_WANT_FLOAT128
  if(sv_isobject(op)) {
    const char* h = HvNAME(SvSTASH(SvRV(op)));

    if(strEQ(h, "Math::Float128"))
      return newSViv(mpfr_set_float128(*rop, *(INT2PTR(float128 *, SvIVX(SvRV(op)))), (mpfr_rnd_t)SvUV(rnd)));
     croak("2nd arg (a %s object) supplied to Rmpfr_set_FLOAT128 needs to be a Math::Float128 object",
             HvNAME(SvSTASH(SvRV(op))));
  }
  else croak("2nd arg (which needs to be a Math::Float128 object) supplied to Rmpfr_set_FLOAT128 is not an object");
#else
#  if MPFR_VERSION_MAJOR >= 4
    if(mpfr_buildopt_float128_p()) {
      warn("To make Rmpfr_set_FLOAT128 available, rebuild Math::MPFR and pass \"F128=1\" as an arg to the Makefile.PL\n");
      croak("See \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
    }
#  endif
  croak("MPFR_WANT_FLOAT128 needs to have been defined when building Math::MPFR - see \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
#endif
}

SV * Rmpfr_set_float128(pTHX_ mpfr_t * rop, SV * q, SV * rnd) {

#ifdef CAN_PASS_FLOAT128
  return newSViv(mpfr_set_float128(*rop, (float128)SvNV(q), (mpfr_rnd_t)SvUV(rnd)));
#else
#  if MPFR_VERSION_MAJOR >= 4
    if(mpfr_buildopt_float128_p()) {
      warn("To make Rmpfr_set_float128 available, rebuild Math::MPFR and pass \"F128=1\" as an arg to the Makefile.PL\n");
      croak("See \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
    }
#  endif
  PERL_UNUSED_ARG3(rop, q, rnd);
  croak("Cannot use Rmpfr_set_float128 to set an NV - see \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
#endif
}

void Rmpfr_init_set_float128(pTHX_ SV * q, SV * round) {

#ifdef CAN_PASS_FLOAT128
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("Math::MPFR",Rmpfr_init_set_float128) /* defined in math_mpfr_include.h */

  mpfr_init(*mpfr_t_obj);
  sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
  ret = mpfr_set_float128(*mpfr_t_obj, SvNV(q), (mpfr_rnd_t)SvUV(round));
  SvREADONLY_on(obj);
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
#else
  PERL_UNUSED_ARG2(q, round);
  croak("Cannot use Rmpfr_init_set_float128 to set an NV - see \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
#endif
}

void Rmpfr_init_set_float128_nobless(pTHX_ SV * q, SV * round) {

#ifdef CAN_PASS_FLOAT128
  dXSARGS;
  mpfr_t * mpfr_t_obj;
  SV * obj_ref, * obj;
  int ret;
  PERL_UNUSED_ARG(items);

  CHECK_ROUNDING_VALUE

  NEW_MATH_MPFR_OBJECT("NULL",Rmpfr_init_set_float128_nobless) /* defined in math_mpfr_include.h */

  mpfr_init(*mpfr_t_obj);
  sv_setiv(obj, INT2PTR(IV,mpfr_t_obj));
  ret = mpfr_set_float128(*mpfr_t_obj, SvNV(q), (mpfr_rnd_t)SvUV(round));
  SvREADONLY_on(obj);
  RETURN_STACK_2  /*defined in math_mpfr_include.h */
#else
  PERL_UNUSED_ARG2(q, round);
  croak("Cannot use Rmpfr_init_set_float128_nobless to set an NV - see \"PASSING __float128 VALUES\" in the Math::MPFR documentation");
#endif
}

SV * _is_readonly(pTHX_ SV * sv) {
  if SvREADONLY(sv) return newSVuv(1);
  return newSVuv(0);
}

void _readonly_on(pTHX_ SV * sv) {
  SvREADONLY_on(sv);
}

void _readonly_off(pTHX_ SV * sv) {
  SvREADONLY_off(sv);
}

/* Do not remove _can_pass_float128 - it's used by the Math::MPFI Makefile.PL */

int _can_pass_float128(void) {

#ifdef CAN_PASS_FLOAT128
  return 1;
#else
  return 0;
#endif
}

int _mpfr_want_float128(void) {

#ifdef MPFR_WANT_FLOAT128
  return 1;
#else
  return 0;
#endif
}

int nnumflag(void) {
  return nnum;
}

int nok_pokflag(void) {
  return nok_pok;
}

void clear_nnum(void) {
  nnum = 0;
}

void clear_nok_pok(void){
  nok_pok = 0;
}

void set_nnum(int x) {
  nnum = x;
}

void set_nok_pok(int x) {
  nok_pok = x;
}

SV * _d_bytes(pTHX_ SV * str) {

 /* Assumes 64-bit double (53-bit precision mantissa) *
  * Assumes also that the arg is a PV.                *
  * Assumptions are not checked because the function  *
  * is private.                                       *
  * Corrected to handle subnormal values in 4.02      */

  mpfr_t temp;
  double d;
  mpfr_prec_t emin;
  SV * sv;
#if !defined(MPFR_VERSION) || MPFR_VERSION <= 196869 /* avoid mpfr_subnormalize */
  int signbit;
  mpfr_t temp2, DENORM_MIN;
#else
  int inex;
  mpfr_prec_t emax;
#endif

  mpfr_init2(temp, DBL_MANT_DIG);

#if defined(MPFR_VERSION) && MPFR_VERSION > 196869 /* use mpfr_subnormalize */
  emin = mpfr_get_emin();
  emax = mpfr_get_emax();

  mpfr_set_emin(-1073);
  mpfr_set_emax(1024);

  inex = mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
  mpfr_subnormalize(temp, inex, GMP_RNDN);

  mpfr_set_emin(emin);
  mpfr_set_emax(emax);

  d = mpfr_get_d(temp, GMP_RNDN);

#else     /* mpfr_strtofr can return incorrect inex in 3.1.5 and  *
           * earlier - which renders mpfr_subnormalize unreliable */

  mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);

  emin = mpfr_get_exp(temp) + 1074;
  signbit = mpfr_signbit(temp) ? -1 : 1;

  if(emin <= 1) {
    if(emin < 0) {
      d = 0.0 *signbit;
    }
    else {
      if(emin == 0) {
        mpfr_init2(temp2, 2);
        mpfr_set_ui(temp2, 2, GMP_RNDN);
        mpfr_div_2ui(temp2, temp2, 1076, GMP_RNDN);
        mpfr_abs(temp, temp, GMP_RNDN);
        if(mpfr_cmp(temp, temp2) > 0) {
          mpfr_mul_2ui(temp2, temp2, 1, GMP_RNDN);
          d = mpfr_get_d(temp2, GMP_RNDN);
          mpfr_clear(temp2);
        }
        else {
          d = 0.0;
        }
        d *= signbit;
      }
      else {  /* emin == 1 *//* Can't set precision to 1 with older versions of mpfr */

        mpfr_abs(temp, temp, GMP_RNDN);
        mpfr_init2(temp2, 2);
        mpfr_init2(DENORM_MIN, 2);
        mpfr_set_ui(DENORM_MIN, 2, GMP_RNDN);
        mpfr_div_2ui(DENORM_MIN, DENORM_MIN, 1075, GMP_RNDN);
        mpfr_set(temp2, DENORM_MIN, GMP_RNDN);
        mpfr_div_ui(temp2, temp2, 2, GMP_RNDN);
        mpfr_add(temp2, temp2, DENORM_MIN, GMP_RNDN);
        if(mpfr_cmp(temp, temp2) >= 0) mpfr_mul_si(temp, DENORM_MIN, 2 * signbit, GMP_RNDN);
        else mpfr_mul_si(temp, temp, signbit, GMP_RNDN);
        mpfr_clear(temp2);
        mpfr_clear(DENORM_MIN);
        d = mpfr_get_d(temp, GMP_RNDN);
      }
    }
  }  /* close "if(emin <= 1)" */
  else {
    if(emin < 53) {
      mpfr_set_prec(temp, emin);
      mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    }
    d = mpfr_get_d(temp, GMP_RNDN);
  }   /* close "else" */
#endif

  mpfr_clear(temp);

  sv = NEWSV(0, 8);
  sv_setpvn(sv, (char *) &d, 8);
  return sv;
}

SV * _bytes_fr(pTHX_ mpfr_t * str, unsigned long bits) {

  /* Explicit Calls to mpfr_subnormalize() are unnecessary */

  SV * sv;
  double msd, lsd;
  long double ld;
  mpfr_t temp;

#ifdef MPFR_WANT_FLOAT128
  float128 f128;
#endif

  if(mpfr_get_prec(*str) != (mpfr_prec_t)bits)
    croak("Precision of 1st arg supplied to _bytes_fr != 2nd arg (%d)", (int)bits );

  if(bits == 53) {
    msd = mpfr_get_d(*str, GMP_RNDN);
    sv = NEWSV(0, 8);
    sv_setpvn(sv, (char *) &msd, 8);
    return sv;
  }

  if(bits == 64) {
#  if LDBL_MANT_DIG != 64
    croak("Byte structure of 10-byte long double not provided for this architecture");
#  endif
    ld = mpfr_get_ld(*str, GMP_RNDN);
    sv = NEWSV(0, 10);
    sv_setpvn(sv, (char *) &ld, 10);
    return sv;
  }

  if(bits == 2098) {

    mpfr_init2(temp, 2098);
    mpfr_set(temp, *str, GMP_RNDN); /* Avoid altering the value held by *str */

    msd = mpfr_get_d(temp, GMP_RNDN);
    if(msd == 0 || msd != msd || msd / msd != 1) { /* zero, nan or inf */
      lsd = 0.0;
    }
    else {
      mpfr_sub_d(temp, temp, msd, GMP_RNDN);
      lsd = mpfr_get_d(temp, GMP_RNDN);
    }

    mpfr_clear(temp);
    sv = NEWSV(0, 16);

   /* Work around sneaky DoubleDouble gotcha */
   if( (msd ==  DBL_MAX && lsd ==   pow(2.0, 970.0))
         ||
       (msd == -DBL_MAX && lsd == -(pow(2.0, 970.0))) ) {
     msd += lsd; /* set msd to infinity */
     lsd = 0.0;  /* set lsd to zero     */
   }

#  ifdef MPFR_HAVE_BENDIAN
    sv_setpvn(sv, (char *) &msd, 8);
    sv_catpvn(sv, (char *) &lsd, 8);
#  else
    sv_setpvn(sv, (char *) &lsd, 8);
    sv_catpvn(sv, (char *) &msd, 8);
#  endif

    return sv;
  }

  if(bits == 113) {
#  if !defined(MPFR_WANT_FLOAT128) && LDBL_MANT_DIG != 113
    croak("Byte structure of 113-bit NV types not provided for this architecture and mpfr configuration");
#endif

   sv = NEWSV(0, 16);

#  if defined(MPFR_WANT_FLOAT128)
    f128 = mpfr_get_float128(*str, GMP_RNDN);
    sv_setpvn(sv, (char *) &f128, 16);
    return sv;
#  endif
    ld = mpfr_get_ld(*str, GMP_RNDN);
    sv_setpvn(sv, (char *) &ld, 16);
    return sv;
  }
  croak("Invalid value (%u) provided as 2nd argument to internal _bytes_fr XSub", (int)bits);
}

SV * _dd_bytes(pTHX_ SV * str) {

 /* Assumes 128-bit long double (106-bit precision mantissa) *
  * Assumes also that the arg is a PV.                       *
  * Assumptions are not checked because the function         *
  * is private.                                              */

  mpfr_t temp;
  double msd, lsd;
  SV * sv;

  mpfr_init2(temp, 2098);

  mpfr_set_str(temp, SvPV_nolen(str), 0, GMP_RNDN);

  msd = mpfr_get_d(temp, GMP_RNDN);
  if(msd == 0 || msd != msd || msd / msd != 1) { /* zero, nan or inf */
    lsd = 0.0;
  }
  else {
    mpfr_sub_d(temp, temp, msd, GMP_RNDN);
    lsd = mpfr_get_d(temp, GMP_RNDN);
  }

  mpfr_clear(temp);

  sv = NEWSV(0, 16);

  /* Work around sneaky DoubleDouble gotcha */
  if( (msd ==  DBL_MAX && lsd ==   pow(2.0, 970.0))
        ||
      (msd == -DBL_MAX && lsd == -(pow(2.0, 970.0))) ) {
    msd += lsd; /* set msd to infinity */
    lsd = 0.0;  /* set lsd to zero     */
  }

#ifdef MPFR_HAVE_BENDIAN
  sv_setpvn(sv, (char *) &msd, 8);
  sv_catpvn(sv, (char *) &lsd, 8);
#else
  sv_setpvn(sv, (char *) &lsd, 8);
  sv_catpvn(sv, (char *) &msd, 8);
#endif
  return sv;
}

SV * _ld_bytes(pTHX_ SV * str) {

 /* Assumes 10-byte long double (64-bit precision mantissa)  *
  * 53-bit long doubles are handled by _d_bytes.             *
  * 113-bit long doubles are handled by _f128_bytes - but    *
  * only if LDBL_MANT_DIG == 113 or MPFR_WANT_FLOAT128 is    *
  * is defined.                                              *
  * Assumes also that the arg is a PV.                       *
  * Assumptions are not checked because the function         *
  * is private and should have already been checked.         *
  * Corrected to handle subnormal values in 4.02             */

#if LDBL_MANT_DIG != 64
    croak("Byte structure of 10-byte long double not provided for this architecture");
#else

    mpfr_t temp;
    long double ld;
    mpfr_prec_t emin, emax;
    SV * sv;

#  if !defined(MPFR_VERSION) || MPFR_VERSION <= 196869 /* avoid mpfr_subnormalize */
    int signbit;
    mpfr_t temp2, DENORM_MIN;
#  else
    int inex;
#  endif

    mpfr_init2(temp, 64);

#  if defined(MPFR_VERSION) && MPFR_VERSION > 196869 /* use mpfr_subnormalize */

    emin = mpfr_get_emin();
    emax = mpfr_get_emax();

    mpfr_set_emin(-16444);
    mpfr_set_emax(16384);

    inex = mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    mpfr_subnormalize(temp, inex, GMP_RNDN);

    mpfr_set_emin(emin);
    mpfr_set_emax(emax);

    ld = mpfr_get_ld(temp, GMP_RNDN);

#  else /* mpfr_strtofr can return incorrect inex in 3.1.5 and   *
       * earlier - which renders mpfr_subnormalize unreliable  */


    mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    emax = 16445;
    emin = mpfr_get_exp(temp) + 16445;

   /* mpfr_get_ld is buggy for extended precision subnormal    *
    * values with 3.1.4 and earlier. Hence, croak when this    *
    * condition exists (ie when LD_SUBNORMAL_BUG is dsefined.) */

#  ifdef LD_SUBNORMAL_BUG

         if(mpfr_regular_p(temp) && emin >= 0 && emin < 64) {
           warn("\n mpfr_get_ld is buggy (subnormal values only)\n for this version (%s) of the MPFR library\n", MPFR_VERSION_STRING);
           croak(" Version 3.1.5 or later is required");
         }

#  endif


    signbit = mpfr_signbit(temp) ? -1 : 1;

    if(emin <= 1) {
      if(emin < 0) {
        ld = 0.0L;
        ld *= signbit;
      }
      else {
        if(emin == 0) {
          mpfr_init2(temp2, 2);
          mpfr_set_ui(temp2, 2, GMP_RNDN);
          mpfr_div_2ui(temp2, temp2, emax + 2, GMP_RNDN);
          mpfr_abs(temp, temp, GMP_RNDN);
          if(mpfr_cmp(temp, temp2) > 0) {
            mpfr_mul_2ui(temp2, temp2, 1, GMP_RNDN);
            ld = mpfr_get_ld(temp2, GMP_RNDN);
            mpfr_clear(temp2);
          }
          else {
            ld = 0.0L;
          }
          ld *= signbit;
        }
        else {  /* emin == 1 *//* Can't set precision to 1 with older versions of mpfr */

          mpfr_abs(temp, temp, GMP_RNDN);
          mpfr_init2(temp2, 2);
          mpfr_init2(DENORM_MIN, 2);
          mpfr_set_ui(DENORM_MIN, 2, GMP_RNDN);
          mpfr_div_2ui(DENORM_MIN, DENORM_MIN, emax + 1, GMP_RNDN);
          mpfr_set(temp2, DENORM_MIN, GMP_RNDN);
          mpfr_div_ui(temp2, temp2, 2, GMP_RNDN);
          mpfr_add(temp2, temp2, DENORM_MIN, GMP_RNDN);
          if(mpfr_cmp(temp, temp2) >= 0) mpfr_mul_si(temp, DENORM_MIN, 2 * signbit, GMP_RNDN);
          else mpfr_mul_si(temp, temp, signbit, GMP_RNDN);
          mpfr_clear(temp2);
          mpfr_clear(DENORM_MIN);
          ld = mpfr_get_ld(temp, GMP_RNDN);
        }
      }
    }  /* close "if(emin <= 1)" */
    else {
      if(emin < 64) {
        mpfr_set_prec(temp, emin);
        mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
      }
    ld = mpfr_get_ld(temp, GMP_RNDN);
    }

#  endif

  mpfr_clear(temp);

  sv = NEWSV(0, 10);
  sv_setpvn(sv, (char *) &ld, 10);
  return sv;
#endif
}

SV * _f128_bytes(pTHX_ SV * str) {

 /* Assumes 113-bit NV (either long double or __float128).   *
  * Assumes also that the arg is a Math::MPFR object.        *
  * Assumptions are not checked because the function         *
  * is private and should have already been checked.         *
  * Corrected to handle subnormal values in 4.02             */


#if !defined(MPFR_WANT_FLOAT128) && LDBL_MANT_DIG != 113
  croak("Byte structure of 113-bit NV types not provided for this architecture and mpfr configuration");
#else

  mpfr_t temp;

#  if defined(MPFR_WANT_FLOAT128)
    float128 f128;
#  else
    long double f128;
#  endif

  mpfr_prec_t emin;
  SV * sv;

#  if !defined(MPFR_VERSION) || MPFR_VERSION <= 196869 /* avoid mpfr_subnormalize */
    int signbit;
  mpfr_t temp2, DENORM_MIN;
#  else
    int inex;
    mpfr_prec_t emax;
#  endif

  mpfr_init2(temp, 113);

#  if defined(MPFR_VERSION) && MPFR_VERSION > 196869 /* use mpfr_subnormalize */
    emin = mpfr_get_emin();
    emax = mpfr_get_emax();

    mpfr_set_emin(-16493);
    mpfr_set_emax(16384);

    inex = mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    mpfr_subnormalize(temp, inex, GMP_RNDN);

    mpfr_set_emin(emin);
    mpfr_set_emax(emax);

#    if defined(MPFR_WANT_FLOAT128)
      f128 = mpfr_get_float128(temp, GMP_RNDN);
#    else
      f128 = mpfr_get_ld(temp, GMP_RNDN);
#    endif

#  else   /* mpfr_strtofr can return incorrect inex in 3.1.5 and  *
           * earlier - which renders mpfr_subnormalize unreliable */

    mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);

    emin = mpfr_get_exp(temp) + 16494;
    signbit = mpfr_signbit(temp) ? -1 : 1;

    if(emin < 1) {
      if(emin < 0) {
        ld = 0.0Q;
        ld *= signbit;
      }
      else {
        if(emin == 0) {
          mpfr_init2(temp2, 2);
          mpfr_set_ui(temp2, 2, GMP_RNDN);
          mpfr_div_2ui(temp2, temp2, 16496, GMP_RNDN);
          mpfr_abs(temp, temp, GMP_RNDN);
          if(mpfr_cmp(temp, temp2) > 0) {
            mpfr_mul_2ui(temp2, temp2, 1, GMP_RNDN);
            ld = mpfr_get_float128(temp2, GMP_RNDN);
            mpfr_clear(temp2);
          }
          else {
            ld = 0.0Q;
          }
          ld *= signbit;
        }
        else {  /* emin == 1 *//* Can't set precision to 1 with older versions of mpfr */
          mpfr_abs(temp, temp, GMP_RNDN);
          mpfr_init2(temp2, 2);
          mpfr_init2(DENORM_MIN, 2);
          mpfr_set_ui(DENORM_MIN, 2, GMP_RNDN);
          mpfr_div_2ui(DENORM_MIN, DENORM_MIN, 16495, GMP_RNDN);
          mpfr_set(temp2, DENORM_MIN, GMP_RNDN);
          mpfr_div_ui(temp2, temp2, 2, GMP_RNDN);
          mpfr_add(temp2, temp2, DENORM_MIN, GMP_RNDN);
          if(mpfr_cmp(temp, temp2) >= 0) mpfr_mul_si(temp, DENORM_MIN, 2 * signbit, GMP_RNDN);
          else mpfr_mul_si(temp, temp, signbit, GMP_RNDN);
          mpfr_clear(temp2);
          mpfr_clear(DENORM_MIN);
          f128 = mpfr_get_float128(temp, GMP_RNDN);
        }
      }
    }  /* close "if(emin <= 1)" */
    else {
      if(emin < 113) {
        mpfr_set_prec(temp, emin);
        mpfr_strtofr(temp, SvPV_nolen(str), NULL, 0, GMP_RNDN);
      }

#    if defined(MPFR_WANT_FLOAT128)
        f128 = mpfr_get_float128(temp, GMP_RNDN);
#    else
        f128 = mpfr_get_ld(temp, GMP_RNDN);
#    endif

    }   /* close "else" */

#  endif

  mpfr_clear(temp);

  sv = NEWSV(0, 16);
  sv_setpvn(sv, (char *) &f128, 16);
  return sv;

#endif
}

int _required_ldbl_mant_dig(void) {
  return REQUIRED_LDBL_MANT_DIG;
}

SV * _GMP_LIMB_BITS(pTHX) {
#ifdef GMP_LIMB_BITS
  return newSVuv(GMP_LIMB_BITS);
#else
  return &PL_sv_undef;
#endif
}

SV * _GMP_NAIL_BITS(pTHX) {
#ifdef GMP_NAIL_BITS
  return newSVuv(GMP_NAIL_BITS);
#else
  return &PL_sv_undef;
#endif
}

/* New in 3.2.0 */

void Rmpfr_fmodquo(pTHX_ mpfr_t * a, mpfr_t * b, mpfr_t * c, SV * round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  dXSARGS;
  long ret, q;
  PERL_UNUSED_ARG(items);
  ret = mpfr_fmodquo(*a, &q, *b, *c, (mpfr_rnd_t)SvUV(round));
  ST(0) = sv_2mortal(newSViv(q));
  ST(1) = sv_2mortal(newSViv(ret));
  XSRETURN(2);
#else
  PERL_UNUSED_ARG4(a, b, c, round);
  croak("Rmpfr_fmodquo not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_fpif_export(pTHX_ FILE * stream, mpfr_t * op) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  int ret = mpfr_fpif_export(stream, *op);
  fflush(stream);
  return ret;
#else
  croak("Rmpfr_fpif_export not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_fpif_import(pTHX_ mpfr_t * op, FILE * stream) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  int ret = mpfr_fpif_import(*op, stream);
  fflush(stream);
  return ret;
#else
  PERL_UNUSED_ARG2(op, stream);
  croak("Rmpfr_fpif_import not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_flags_clear(unsigned int mask) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  mpfr_flags_clear((mpfr_flags_t) mask);
#else
  PERL_UNUSED_ARG(mask);
  croak("Rmpfr_flags_clear not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_flags_set(unsigned int mask) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  mpfr_flags_set((mpfr_flags_t) mask);
#else
  PERL_UNUSED_ARG(mask);
  croak("Rmpfr_flags_set not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

unsigned int Rmpfr_flags_test(unsigned int mask) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  mpfr_flags_t ret = mpfr_flags_test((mpfr_flags_t) mask);
  return (unsigned int)ret;
#else
  PERL_UNUSED_ARG(mask);
  croak("Rmpfr_flags_test not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

unsigned int Rmpfr_flags_save(void) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  mpfr_flags_t ret = mpfr_flags_save();
  return (unsigned int)ret;
#else
  croak("Rmpfr_flags_save not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

void Rmpfr_flags_restore(unsigned int flags, unsigned int mask) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  mpfr_flags_restore((mpfr_flags_t) flags, (mpfr_flags_t) mask);
#else
  PERL_UNUSED_ARG2(flags, mask);
  croak("Rmpfr_flags_restore not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_rint_roundeven(mpfr_t * rop, mpfr_t * op, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  return(mpfr_rint_roundeven(*rop, *op, (mpfr_rnd_t)round));
#else
  PERL_UNUSED_ARG3(rop, op, round);
  croak("Rmpfr_rint_roundeven not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_roundeven(mpfr_t * rop, mpfr_t * op) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  return(mpfr_roundeven(*rop, *op));
#else
  PERL_UNUSED_ARG2(rop, op);
  croak("Rmpfr_roundeven not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_nrandom(mpfr_t * rop, gmp_randstate_t * state, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  return(mpfr_nrandom(*rop, *state, (mpfr_rnd_t)round));
#else
  PERL_UNUSED_ARG3(rop, state, round);
  croak("Rmpfr_nrandom not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_erandom(mpfr_t * rop, gmp_randstate_t * state, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  return(mpfr_erandom(*rop, *state, (mpfr_rnd_t)round));
#else
  PERL_UNUSED_ARG3(rop, state, round);
  croak("Rmpfr_erandom not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_fmma(mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, mpfr_t * op3, mpfr_t * op4, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  return(mpfr_fmma(*rop, *op1, *op2, *op3, *op4, (mpfr_rnd_t)round));
#else
  PERL_UNUSED_ARG6(rop, op1, op2, op3, op4, round);
  croak("Rmpfr_fmma not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_fmms(mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, mpfr_t * op3, mpfr_t * op4, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  return(mpfr_fmms(*rop, *op1, *op2, *op3, *op4, (mpfr_rnd_t)round));
#else
  PERL_UNUSED_ARG6(rop, op1, op2, op3, op4, round);
  croak("Rmpfr_fmms not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_log_ui(mpfr_t * rop, unsigned long op, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  return(mpfr_log_ui(*rop, op, (mpfr_rnd_t)round));
#else
  PERL_UNUSED_ARG3(rop, op, round);
  croak("Rmpfr_log_ui not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_gamma_inc(mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  return(mpfr_gamma_inc(*rop, *op1, *op2, (mpfr_rnd_t)round));
#else
  PERL_UNUSED_ARG4(rop, op1, op2, round);
  croak("Rmpfr_gamma_inc not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int _have_IEEE_754_long_double(void) {
#if defined(HAVE_IEEE_754_LONG_DOUBLE)
  return 1;
#else
  return 0;
#endif
}

int _have_extended_precision_long_double(void) {
#if defined(HAVE_EXTENDED_PRECISION_LONG_DOUBLE)
  return 1;
#else
  return 0;
#endif
}

int nanflag_bug(void) {
#if !defined(MPFR_VERSION) || (defined(MPFR_VERSION) && MPFR_VERSION <= NANFLAG_BUG)
  return 1;
#else
  return 0;
#endif
}

SV * Rmpfr_buildopt_float128_p(pTHX) {
#if MPFR_VERSION_MAJOR >= 4
  return newSViv(mpfr_buildopt_float128_p());
#else
  croak("Rmpfr_buildopt_float128_p not implemented with this version of the mpfr library - we have %s but need at least 4.0.0", MPFR_VERSION_STRING);
#endif
}

SV * Rmpfr_buildopt_sharedcache_p(pTHX) {
#if MPFR_VERSION_MAJOR >= 4
  return newSViv(mpfr_buildopt_sharedcache_p());
#else
  croak("Rmpfr_buildopt_sharedcache_p not implemented with this version of the mpfr library - we have %s but need at least 4.0.0", MPFR_VERSION_STRING);
#endif
}

int _nv_is_float128(void) {
#if defined(USE_QUADMATH)
  return 1;
#else
  return 0;
#endif
}

int _SvNOK(pTHX_ SV * in) {
  if(SV_IS_NOK(in)) return 1;
  return 0;
}

int _SvPOK(pTHX_ SV * in) {
  if(SV_IS_POK(in)) return 1;
  return 0;
}

/*
Expects to return either 0 or 1:
*/

int _get_bit(pTHX_ char * s, mpfr_prec_t p) {

  if(s[p] == '1') return 1;
  if(s[p] != '0') croak ("Invalid bit value in Math::MPFR::_get_bit");
  return 0;

}

/*
 A function to return the least
 significant bit of the mantissa:
*/

SV * _lsb(pTHX_ mpfr_t * a) {

  char * buffer;
  mpfr_exp_t exponent;
  mpfr_prec_t p = mpfr_get_prec(*a);

  if(!mpfr_regular_p(*a)) {
    if(mpfr_nan_p(*a)) mpfr_set_nanflag();
    return newSVuv(0);
  }

  Newxz(buffer, p + 2, char);
  if(buffer == NULL) croak("Failed to allocate memory in _lsb function");

  mpfr_get_str(buffer, &exponent, 2, (size_t)p, *a, GMP_RNDN);

  if(!mpfr_signbit(*a)) p--;

  p = (mpfr_prec_t)_get_bit(aTHX_ buffer, p);

  Safefree(buffer);

  return newSVuv((UV)p);
}

int Rmpfr_rec_root(pTHX_ mpfr_t * rop, mpfr_t * op, unsigned long root, SV * round) {

  /*
    Originally supplied by Vincent Lefevre to mpfr mailing list.
    See https://sympa.inria.fr/sympa/arc/mpfr/2016-12/msg00032.html
    Sisyphus re-arranged it as an XSub and added handling of special
    cases (inf/nan/zero).
    Requires mpfr-3.1.0 or later.
  */

#if (MPFR_VERSION_MAJOR == 3 && MPFR_VERSION_MINOR >= 1) || MPFR_VERSION_MAJOR > 3

  mpfr_prec_t p;
  mpfr_t t, u;
  int inex1, inex2 = -1, inex3= 1;

  CHECK_ROUNDING_VALUE

  if(root == 0) {
    mpfr_set_nan(*rop);
    mpfr_set_nanflag();
    return 0;
  }

 /* At this point we know that "root" is greater than 0 */

  if(mpfr_zero_p(*op)) {
    mpfr_set_divby0();
    if(root % 2) {
      mpfr_set_inf(*rop, mpfr_signbit(*op) * -1);
      return 0;
    }
    mpfr_set_inf(*rop, 1);
    return 0;
  }

  /* and we now also know that op != 0 */

  if(mpfr_signbit(*op) && root % 2 == 0) {
      mpfr_set_nan(*rop);
      mpfr_set_nanflag();
      return 0;
  }

  /*
   All other special cases are handled correctly by the following code.
   This is all checked in t/Rmpfr_rec_root.t. (At least, that's the intention.)
  */

  p = mpfr_get_prec(*rop);
  mpfr_init2(t, p);
  mpfr_init2(u, p);

  while(
        (inex2 != inex3 && inex2 * inex3 <= 0)
        || mpfr_cmp(*rop, u)
       ) {
    mpfr_set_prec(t, mpfr_get_prec(t) + 8);
    inex1 = mpfr_ui_div(t, 1, *op, GMP_RNDZ);
#  if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
      inex2 = mpfr_rootn_ui(*rop, t, root, (mpfr_rnd_t)SvUV(round));
#  else
      inex2 = mpfr_root(*rop, t, root, (mpfr_rnd_t)SvUV(round));
#  endif
    if(!inex1) return inex2;
    mpfr_nextabove(t);
#  if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
      inex3 = mpfr_rootn_ui(u, t, root, (mpfr_rnd_t)SvUV(round));
#  else
      inex3 = mpfr_root(u, t, root, (mpfr_rnd_t)SvUV(round));
#  endif
  }
  return inex2;
#else
  PERL_UNUSED_ARG4(rop, op, root, round);
  croak("Rmpfr_set_divby0 not implemented with this version of the mpfr library - we have %s but need at least 3.1.0", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_beta(mpfr_t * rop, mpfr_t * op1, mpfr_t * op2, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  return(mpfr_beta(*rop, *op1, *op2, (mpfr_rnd_t)round));
#else
  PERL_UNUSED_ARG4(rop, op1, op2, round);
  croak("Rmpfr_beta not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int Rmpfr_rootn_ui (mpfr_t * rop, mpfr_t * op, unsigned long k, int round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= MPFR_VERSION_NUM(4,0,0)
  return(mpfr_rootn_ui(*rop, *op, k, (mpfr_rnd_t)round));
#else
  PERL_UNUSED_ARG4(rop, op, k, round);
  croak("Rmpfr_rec_root not implemented - need at least mpfr-4.0.0, have only %s", MPFR_VERSION_STRING);
#endif
}

int _ld_subnormal_bug(void) {

#if defined(LD_SUBNORMAL_BUG)
  return 1;
#else
  return 0;
#endif
}

/*
*  The atodouble function was written as a means to check that the atonv
*  function  handles subnormal double-doubles correctly.
*  But it is readily available for any other purpose, too.
*  On a perl whose nvtype is double it should return the same value as atonv,
*  though atodouble is not as efficient as atonv.
*/

double atodouble(char * str) {


#if defined(MPFR_VERSION) && MPFR_VERSION > 196869

  mpfr_t workspace;
  mpfr_prec_t emin, emax;
  int inex;
  double d;

  mpfr_init2(workspace, 53);

  emin = mpfr_get_emin();
  emax = mpfr_get_emax();

  mpfr_set_emin(-1073);
  mpfr_set_emax(1024);

  inex = mpfr_strtofr(workspace, str, NULL, 0, GMP_RNDN);
  mpfr_subnormalize(workspace, inex, GMP_RNDN);

  mpfr_set_emin(emin);
  mpfr_set_emax(emax);

  d = mpfr_get_d(workspace, GMP_RNDN);

  mpfr_clear(workspace);

  return d;
#else
  PERL_UNUSED_ARG(str);
  croak("The atodouble function requires mpfr-3.1.6 or later");

#endif
}

SV * atonv(pTHX_ SV * str) {

#if defined(MPFR_VERSION) && MPFR_VERSION > 196869
  mpfr_t workspace;
#  if NVSIZE == 8 || LDBL_MANT_DIG == 53        /* D */
    mpfr_prec_t emin, emax;
    int inex;
    double ret;

    mpfr_init2(workspace, 53);

    emin = mpfr_get_emin();
    emax = mpfr_get_emax();

    mpfr_set_emin(-1073);
    mpfr_set_emax(1024);

    inex = mpfr_strtofr(workspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
    mpfr_subnormalize(workspace, inex, GMP_RNDN);

    mpfr_set_emin(emin);
    mpfr_set_emax(emax);

    ret = mpfr_get_d(workspace, GMP_RNDN);
    mpfr_clear(workspace);

    return newSVnv(ret);

#  endif                                                  /* close D */

#  if defined(USE_LONG_DOUBLE) && LDBL_MANT_DIG != 53   /* LD */
#    if REQUIRED_LDBL_MANT_DIG == 64

      mpfr_prec_t emin, emax;
      int inex;
      long double ret;

      mpfr_init2(workspace, 64);

      emin = mpfr_get_emin();
      emax = mpfr_get_emax();

      mpfr_set_emin(-16444);
      mpfr_set_emax(16384);

      inex = mpfr_strtofr(workspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
      mpfr_subnormalize(workspace, inex, GMP_RNDN);

      mpfr_set_emin(emin);
      mpfr_set_emax(emax);

      ret = mpfr_get_ld(workspace, GMP_RNDN);
      mpfr_clear(workspace);

     return newSVnv(ret);
#    endif
#    if REQUIRED_LDBL_MANT_DIG == 113

      mpfr_prec_t emin, emax;
      int inex;
      long double ret;

      mpfr_init2(workspace, 113);

      emin = mpfr_get_emin();
      emax = mpfr_get_emax();

      mpfr_set_emin(-16493);
      mpfr_set_emax(16384);

      inex = mpfr_strtofr(workspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
      mpfr_subnormalize(workspace, inex, GMP_RNDN);

      mpfr_set_emin(emin);
      mpfr_set_emax(emax);

      ret = mpfr_get_ld(workspace, GMP_RNDN);
      mpfr_clear(workspace);

      return newSVnv(ret);

#    endif

#    if REQUIRED_LDBL_MANT_DIG == 2098

      mpfr_t dspace;
      double msd, lsd;        /* 'most' and 'least' significant doubles */
      mpfr_prec_t emin, emax;
      int inex;
      long double ret;

      mpfr_init2(workspace, 2098);
      mpfr_init2(dspace, 53);

      emin = mpfr_get_emin();
      emax = mpfr_get_emax();

      mpfr_set_emin(-1073);
      mpfr_set_emax(1024);

      inex = mpfr_strtofr(dspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
      mpfr_subnormalize(dspace, inex, GMP_RNDN);

      msd = mpfr_get_d(dspace, GMP_RNDN);

      if(!mpfr_regular_p(dspace)) {
        mpfr_clear(dspace);
        mpfr_set_emin(emin); /* restore to original value */
        mpfr_set_emax(emax); /* restore to original value */
        return newSVnv(msd);
      }

      mpfr_strtofr(workspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
      inex = mpfr_sub(dspace, workspace, dspace, GMP_RNDN);
      mpfr_subnormalize(dspace, inex, GMP_RNDN);
      lsd = mpfr_get_d(dspace, GMP_RNDN);

      mpfr_clear(dspace);
      mpfr_clear(workspace);

      mpfr_set_emin(emin); /* restore to original value */
      mpfr_set_emax(emax); /* restore to original value */

      return newSVnv((long double)msd + (long double)lsd);

#    endif
#  endif                                                  /* close LD */
#  if defined(USE_QUADMATH)                             /* F128 */
#    if defined(MPFR_WANT_FLOAT128)

      mpfr_prec_t emin, emax;
      int inex;
      __float128 ret;

      mpfr_init2(workspace, 113);

      emin = mpfr_get_emin();
      emax = mpfr_get_emax();

      mpfr_set_emin(-16493);
      mpfr_set_emax(16384);

      inex = mpfr_strtofr(workspace, SvPV_nolen(str), NULL, 0, GMP_RNDN);
      mpfr_subnormalize(workspace, inex, GMP_RNDN);

      mpfr_set_emin(emin);
      mpfr_set_emax(emax);

      ret = mpfr_get_float128(workspace, GMP_RNDN);
      mpfr_clear(workspace);
      return newSVnv(ret);

#    else
      croak("The atonv function is unavailable for this __float128 build of perl\n");
#    endif
#  endif                                                  /* close F128 */
  croak("The atonv function has encountered an unrecognized nvtype");
#else
  PERL_UNUSED_ARG(str);
  croak("The atonv function requires mpfr-3.1.6 or later");
#endif

} /* close atonv */

SV * Rmpfr_get_str_ndigits_alt(pTHX_ int base, UV prec) {

  /* Can use this if mpfr version is less than 4.1.0.    *
   * If mpfr version is at least 4.1.0, then the         *
   * Math::MPFR test suite checks that this function     *
   * produces the same results as Rmpfr_get_str_ndigits. */

  UV m = 1;
  int inexflag;
  mpfr_t temp1, temp2;

  inexflag = mpfr_inexflag_p();
  mpfr_init2(temp1, 128);
  mpfr_init2(temp2, 128);
  mpfr_set_ui(temp1, base, GMP_RNDN);
  mpfr_log2(temp2, temp1, GMP_RNDN);
  mpfr_trunc(temp1, temp2);

  if(mpfr_equal_p(temp1, temp2))
    mpfr_ui_div(temp1, (unsigned long)(prec - 1), temp2, GMP_RNDN);
  else
    mpfr_ui_div(temp1, (unsigned long)prec, temp2, GMP_RNDN);

  mpfr_ceil(temp1, temp1);
  m += mpfr_get_ui(temp1, GMP_RNDN);

  mpfr_clear(temp1);
  mpfr_clear(temp2);

  /* Clear the inex flag if it *
   * was unset to begin with   */

  if(!inexflag) mpfr_clear_inexflag();
  return newSVuv(m);
}

/* new in 4.1.0 (262400) */

SV * Rmpfr_get_str_ndigits(pTHX_ int base, SV * prec) {

  if(base < 2 || base > 62)
    croak("1st argument given to Rmpfr_get_str_ndigits must be in the range 2..62");

#if defined(MPFR_VERSION) && MPFR_VERSION >= 262400 /* version 4.1.0 */
#  if MPFR_VERSION == 262400
    int inexflag;
    size_t ret;

    inexflag = mpfr_inexflag_p();
    ret = mpfr_get_str_ndigits(base, (mpfr_prec_t)SvUV(prec));
    if(!inexflag) mpfr_clear_inexflag(); /* In case mpfr_get_str_ndigits changed it from *
                                          * unset to set. This was fixed after 4.1.0     */
    return newSVuv(ret);
#  else
    return newSVuv(mpfr_get_str_ndigits(base, (mpfr_prec_t)SvUV(prec)));
#  endif
#else
  return Rmpfr_get_str_ndigits_alt(aTHX_ base, SvUV(prec));
#endif
}

SV * Rmpfr_dot(pTHX_ mpfr_t * rop, SV * avref_A, SV * avref_B, SV * len, SV * round) {
#if defined(MPFR_VERSION) && MPFR_VERSION >= 262400 /* version 4.1.0 */
  mpfr_ptr *p_A, *p_B;
  SV ** elem;
  int ret;
  unsigned long i, s = (unsigned long)SvUV(len);

  if(s > av_len((AV*)SvRV(avref_A)) + 1 || s > av_len((AV*)SvRV(avref_B)) + 1)
    croak("2nd last arg to Rmpfr_dot is too large");

  Newx(p_A, s, mpfr_ptr);
  if(p_A == NULL) croak("Unable to allocate memory for first array in Rmpfr_dot");

  Newx(p_B, s, mpfr_ptr);
  if(p_B == NULL) croak("Unable to allocate memory for second array in Rmpfr_dot");

  for(i = 0; i < s; ++i) {
    elem = av_fetch((AV*)SvRV(avref_A), i, 0);
    p_A[i] = *(INT2PTR(mpfr_t *, SvIVX(SvRV(*elem))));
  }

  for(i = 0; i < s; ++i) {
    elem = av_fetch((AV*)SvRV(avref_B), i, 0);
    p_B[i] = *(INT2PTR(mpfr_t *, SvIVX(SvRV(*elem))));
  }

  ret = mpfr_dot(*rop, p_A, p_B, s, (mpfr_rnd_t)SvUV(round));

  Safefree(p_A);
  Safefree(p_B);
  return newSViv(ret);
#else
  PERL_UNUSED_ARG5(rop, avref_A, avref_B, len, round);
  croak("The Rmpfr_dot function requires mpfr-4.1.0 or later");
#endif
}

/********************************************************
 * Set exponent and precision for _nvtoa to utilize. *
 *******************************************************/

void _get_exp_and_bits(mpfr_exp_t * exp, int * bits, NV nv_in) {

  int subnormal_prec_adjustment = 0, tmp;
  void *nvptr = &nv_in;

#if defined(USE_QUADMATH) || (defined(USE_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 113)	/* 113 bit prec */

  int i = QIND_2;				/* big endian: 2, little endian: 13 */

  *exp = ((unsigned char *)nvptr)[QIND_0];	/* big endian: 0, little endian: 15 */
  *exp <<= 8;
  tmp = ((unsigned char *)nvptr)[QIND_1];	/* big endian: 1, little endian: 14 */
  *exp += tmp - 16382;

  if(*exp == -16382) {
    while(Q_CONDITION_1(i)) {	/* big endian:    (i <= 15) */
				/* little endian: (i >= 0 ) */
      tmp = ((unsigned char *)nvptr)[i];
      if(tmp) {
        BITSEARCH_8		/* defined in math_mpfr_include.h */
        break;
      }

      subnormal_prec_adjustment += 8;

      INC_OR_DEC(i);		/* big endian:    i++; */
				/* little endian: i--; */

    }			/* close while loop */
  }

  *exp  -= subnormal_prec_adjustment - 1;
  *bits =  113 - subnormal_prec_adjustment;

  if(!subnormal_prec_adjustment) (*exp)--;

#elif defined(USE_LONG_DOUBLE)	/* 64 bit prec. (DoubleDouble builds don't call this function.) */

  int i = LDIND_2;				/* big endian: 2, little endian: 7 */

  *exp = ((unsigned char *)nvptr)[LDIND_0];	/* big endian: 0, little endian: 9 */
  *exp <<= 8;
  tmp = ((unsigned char *)nvptr)[LDIND_1];	/* big endian: 1, little endian: 8 */
  *exp += tmp - 16382;

  if(*exp == -16382) {

    while(LD_CONDITION_1(i)) {			/* big endian:    (i <= 9) */
						/* little endian: (i >= 0) */
      tmp = ((unsigned char *)nvptr)[i];
      if(tmp) {
        BITSEARCH_8		/* defined in math_mpfr_include.h */
        break;
      }

      subnormal_prec_adjustment += 8;

      INC_OR_DEC(i);		/* big endian: i++; */
                                /* little endian: i--; */

    }			/* close while loop */
  }

  /* for both endians (64 bit) */
  if(subnormal_prec_adjustment) subnormal_prec_adjustment--;

  *exp  -= subnormal_prec_adjustment;
  *bits =  64 - subnormal_prec_adjustment;

  if(subnormal_prec_adjustment) (*exp)++;

#else									/* 53 bit prec */

  int i = DIND_1;				/* big endian: 1, little endian: 6 */

  *exp = ((unsigned char *)nvptr)[DIND_0];	/* big endian: 0, little endian: 7 */
  *exp <<= 4;
  tmp = ((unsigned char *)nvptr)[i];
  *exp += (tmp >> 4) - 1022;

  if(*exp == -1022) {

    while(D_CONDITION_1(i)) {	/* big endian:   (i <= 7) */
				/* little endan: (i >= 0) */
      tmp = ((unsigned char *)nvptr)[i];
      if(tmp) {
        if(i == 1) {
          BITSEARCH_4		/* defined in math_mpfr_include.h */
          break;
        }
        else {
          BITSEARCH_8		/* defined in math_mpfr_include.h */
          break;
        }
      }

      if(i == 1) subnormal_prec_adjustment += 4;
      else subnormal_prec_adjustment += 8;

      INC_OR_DEC(i);		/* big endian:    i++; */
				/* little endian: i--; */
    }
  }

  /* for both endians (53 bit) */
  *exp  -= subnormal_prec_adjustment - 1;
  *bits =  53 - subnormal_prec_adjustment;

  if(!subnormal_prec_adjustment) (*exp)--;
#endif
}

/* _nvtoa function is adapted from p120 of  "How to Print Floating-Point Numbers Accurately" */
/* by Guy L. Steele Jr and Jon L. White                                                     */

SV * _nvtoa(pTHX_ NV pnv) {
  int k = 0, k_index, lsb, skip = 0, sign = 0;
  int bits = NVSIZE_BITS, is_subnormal = 0, shift1, shift2, low, high, cmp, u;
  mpfr_exp_t e;    /* Change to 'int' when mpfr dependency for doubledouble is removed */
  NV nv;
  void *nvptr = &nv;
  SV * outsv; /* for returning inf/nan values */

#if NVSIZE == 8
  char f[] = {'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'};

#elif defined(USE_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 64
  char f[] = {'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0',
              '\0','\0','\0','\0'};

#else
  char f[] = {'\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0',
              '\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0','\0'};

#endif
  mpz_t R, S, M_minus, M_plus, LHS, TMP;
  char * c = "0123456789abcdef";
  char *out;

  nv = pnv; /* Don't fiddle with pnv - instead fiddle with a copy */

#if defined(USE_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 2098
  croak("_nvtoa function is unsuitable for DoubleDouble");

#else

#if defined(MPFR_HAVE_BENDIAN)

  if(((unsigned char *)nvptr)[0] >= 128) {
#  if defined(USE_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 2098
      nv = -nv;
#  else
      ((unsigned char *)nvptr)[0] &= 127;
#  endif

#elif NVSIZE == 8
  if(((unsigned char *)nvptr)[7] >= 128) {
    ((unsigned char *)nvptr)[7] &= 127;
#elif defined(USE_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 64
  if(((unsigned char *)nvptr)[9] >= 128) {
    ((unsigned char *)nvptr)[9] &= 127;
#elif defined(USE_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 2098
  if(((unsigned char *)nvptr)[15] >= 128) {
    nv = -nv;
#else
  if(((unsigned char *)nvptr)[15] >= 128) {
    ((unsigned char *)nvptr)[15] &= 127;
#endif
    sign = 1;
  }

  if(nv == 0) {
    if(sign) return newSVpv("-0.0", 0);
    return newSVpv("0.0", 0);
  }

  if(nv != nv) {
    if(SvIV(get_sv("Math::MPFR::PERL_INFNAN", 0))) {
      outsv = SvREFCNT_inc(get_sv("Math::MPFR::nanvstr", 0));
      return outsv;
    }
    return newSVpv("NaN", 0);
  }

  if(nv > MATH_MPFR_NV_MAX) {
    if(sign) {
      if(SvIV(get_sv("Math::MPFR::PERL_INFNAN", 0))) {
        outsv = SvREFCNT_inc(get_sv("Math::MPFR::ninfstr", 0));
        return outsv;
      }
      return newSVpv("-Inf", 0);
    }
    if(SvIV(get_sv("Math::MPFR::PERL_INFNAN", 0))) {
      outsv = SvREFCNT_inc(get_sv("Math::MPFR::pinfstr", 0));
      return outsv;
    }
    return newSVpv("Inf", 0);
  }

  mpz_init(R);
  mpz_init(S);
  mpz_init(M_plus);
  mpz_init(M_minus);
  mpz_init(LHS);
  mpz_init(TMP);

/***********************************************************************************
 * Set bits to the precision of the mantissa, including any implicit leading bit.  *
 * If the value is subnormal, then bits will be set to the actual precision of the *
 * subnormal value. See the examples given a couple of lines below.                *
 * Also set exp to the (binary) exponent.                                          *
 * eg (for nvtype of double):                                                      *
 *  if nv == 10000000000.0 (0x1.2a05f2p+33)         then e == 34    and bits == 53 *
 *  if nv == 1.125e-100    (0x1.f7f14c11fc5d6p-333) then e == -332  and bits == 53 *
 *  if nv == 2 ** -1073    (0x1p-1073)              then e == -1072 and bits == 2  *
 *  if nv == 2 ** -1074    (0x1p-1074)              then e == -1073 and bits == 1  *
 ***********************************************************************************/
  _get_exp_and_bits( &e, &bits, nv);

  if(bits < NVSIZE_BITS) is_subnormal = 1; /* NVSIZE_BITS == precision of NV's mantissa */

/***************
 * Assign to f *
 ***************/

  if(bits == 1) {
    f[0] = c[1];
  }
  else {

#if defined(USE_QUADMATH) || (defined(USE_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 113)	/* 113 bit prec */

    f[0] = is_subnormal ? c[0] : c[1];
    k++;

    for(skip = QIND_2; Q_CONDITION_1(skip); INC_OR_DEC(skip)) { /* big endian:
                                                                *   skip=2;skip<=15;skip++ */
                                                               /* little endian:
                                                                *   skip=13;skip>=0;skip-- */
      low = ((unsigned char *)nvptr)[skip];
      f[k] = c[low >> 4];
      f[k + 1] = c[low & 15];
      k += 2;
    }

#elif defined(USE_LONG_DOUBLE)	/* 64 bit prec. This function not called forDoubleDoubles. */

    for(skip = LDIND_2; LD_CONDITION_1(skip); INC_OR_DEC(skip)) { /* big endian:             *
                                                                   *   skip=2;skip<=9;skip++ */
                                                                  /* little endian:          *
                                                                   *   skip=7;skip>=0;skip-- */

      low = ((unsigned char *)nvptr)[skip];
      f[k] = c[low >> 4];
      f[k + 1] = c[low & 15];
      k += 2;
    }

#else									/* 53 bit prec */

    for(skip = DIND_1; D_CONDITION_1(skip); INC_OR_DEC(skip)) { /* big endian:             *
                                                                 *   skip=1;skip<=7;skip++ */
                                                                /* little endian:          *
                                                                 *   skip=6;skip>=0;skip-- */
      low = ((unsigned char *)nvptr)[skip];
      if(!k) {
        f[0] = is_subnormal ? c[0] : c[1];
        f[1] = c[low & 15];
      }
      else {
        f[k] = c[low >> 4];
        f[k + 1] = c[low & 15];
      }
      k += 2;
    }
#endif
  }

/********************************
 * assignment to f is completed *
 ********************************/

#ifdef NVTOA_DEBUG
  warn(" f is %s\n exponent is %d\n precision is %d\n", f, (int)e, bits);

/******************************************************************************
 * eg (for nvtype of double):                                                 *
 *  if nv == 10000000000.0 (0x1.2a05f2p+33) then f is 12a05f20000000 and      *
 *           e == 34, bits == 53. (Note that nv == 0x0.12a05f20000000p34)     *
 *  if nv == 1.125e-100 (0x1.f7f14c11fc5d6p-333) then f is 1f7f14c11fc5d6 and *
 *           e == -332, bits == 53. (Note that nv == 0x0.1f7f14c11fc5d6p-333) *
 *  if nv == 2 **-1073 (0x2p-1073) then f is 2 and e == -1072, bits == 2.     *
 *           (Note that nv == 0x0.2p-1072)                                    *
 *  if nv == 2 **-1074 (0x1p-1074) then f is 1 and e == -1073, bits == 1.     *
 *           (Note that nv == 0x0.1p-1073)                                    *
 ******************************************************************************/

#endif

  mpz_set_str(R, f, 16);

  lsb = mpz_tstbit(R, 0); /* Set lsb to the value of R's least significant bit */
  mpz_set(TMP, R);

  if(mpz_sgn(R) < 1) croak("Negative value in _nvtoa XSub is not allowed");
  mpz_set_ui(S, 1);

  shift2 = e - bits;

  shift1 = shift2 > 0 ? shift2 : 0;
  mpz_mul_2exp(R, R, shift1);

  shift2 = shift1       ? 0 : -shift2;
  mpz_mul_2exp(S, S, shift2);

  mpz_set_ui(M_minus, 1);
  mpz_mul_2exp(M_minus, M_minus, shift1);
  mpz_set(M_plus, M_minus);

  /*************** start simple fixup **************/

  if(!is_subnormal) {
    mpz_set_ui(LHS, 1);
    mpz_mul_2exp(LHS, LHS, bits - 1);
    if(!mpz_cmp(LHS, TMP)) {
      mpz_mul_2exp(M_plus, M_plus, 1);
      mpz_mul_2exp(R,      R,      1);
      mpz_mul_2exp(S,      S,      1);
    }
  }

  k = 0;	/* used above, so we reset to zero */
  skip = 0;	/* used above, so we reset to zero */

  mpz_cdiv_q_ui(LHS, S, 10); /* LHS = ceil(S / 10) */

  if(mpz_cmp(LHS, R) > 0) {

    /* Set k to be close to, but not greater than, the number of     *
     * decimal digits needed to represent the value of LHS. This     *
     * reduces the number of times that we need to loop through the  *
     * the next while{} loop.                                        *
     * Note that 0x1.34413509f79ffp-2 is slightly less than log2(10). */

    k = (int)floor(mpz_sizeinbase(LHS, 2) * 0x1.34413509f79ffp-2);
    if(k) k--;    /* Do not decrement if k is zero */
    mpz_ui_pow_ui(TMP, 10, k);
    k *= -1;

#ifdef NVTOA_DEBUG
    warn(" k init: %d\n", k);
#endif

    mpz_mul(R, R, TMP);
    mpz_mul(M_minus, M_minus, TMP);
    mpz_mul(M_plus, M_plus, TMP);
  }
  else {
    skip = 1; /* No need to enter the following while() loop */
  }

  if(!skip) {
    while(1) {

#ifdef NVTOA_DEBUG
      warn("In first loop\n");
#endif

      if(mpz_cmp(LHS, R) <= 0) break;
      k--;
      mpz_mul_ui(R, R, 10);
      mpz_mul_ui(M_minus, M_minus, 10);
      mpz_mul_ui(M_plus, M_plus, 10);
    }                                   /* close first while loop */

#ifdef NVTOA_DEBUG
    warn(" k post 1st loop: %d\n", k);
#endif

  }

  mpz_mul_2exp(LHS, R, 1);
  mpz_add(LHS, LHS, M_plus);
  mpz_mul_2exp(TMP, S, 1);

  if(mpz_cmp(LHS, TMP) >= 0) {

#ifdef NVTOA_DEBUG
    gmp_printf("LHS: %Zd\nTMP: %Zd\n", LHS, TMP);
#endif

    skip = 0;
    mpz_div(TMP, LHS, TMP);

#ifdef NVTOA_DEBUG
    gmp_printf("TMP (= LHS / TMP): %Zd\n", TMP);
#endif

    /* Set u to be close to, but not greater than, the number of     *
     * decimal digits needed to represent the value of TMP. This     *
     * reduces the number of times that we need to loop through the  *
     * the next while{} loop.                                        *
     * Note that 0x1.34413509f79ffp-2 is slightly less than log2(10). */

    u = (int)floor(mpz_sizeinbase(TMP, 2) * 0x1.34413509f79ffp-2);
    /* if(u) u--; *//* Decrement not needed here, AFAIK. */
    mpz_ui_pow_ui(TMP, 10, u);
    k += u;

#ifdef NVTOA_DEBUG
    gmp_printf("TMP (= 10 ** %d): %Zd\n", u, TMP);
    warn(" u init: %d\n k set to: %d\n", u, k);
#endif

    mpz_mul(S, S, TMP);
  }
  else {
    skip = 1; /* No need to enter the following while() loop */
  }

  if(!skip) {
    while(1) {

#ifdef NVTOA_DEBUG
      warn("In second loop\n");
#endif

      mpz_mul_2exp(TMP, S, 1);

      if(mpz_cmp(LHS, TMP) < 0) break;

      mpz_mul_ui(S, S, 10);
      k++;
    }                                 /* close second while loop */

#ifdef NVTOA_DEBUG
    warn(" k post 2nd loop: %d\n", k);
#endif

  }

  /*********************** finish simple fixup **********************/

  k_index = -1;

  Newxz(out, (int)(12 + ceil(0.30103 * bits)), char); /* 1 + ceil(log(2) / log(10) * bits), but allow a few extra for
                                                       exponent and sign */

  if(out == NULL) croak("Failed to allocate memory for output string in _nvtoa XSub");

  /* Each iteration of the following while() loop outputs, one at a time, the *
   * digits of the final mantissa - except for the final (least significant)  *
   * digit Which is set following the termination of the loop.                */

  while(1) {

    k_index++;

    mpz_mul_ui(TMP, R, 10);
    mpz_fdiv_qr(LHS, R, TMP, S);
    u = mpz_get_ui(LHS);

    mpz_mul_ui(M_minus, M_minus, 10);
    mpz_mul_ui(M_plus, M_plus, 10);

    mpz_mul_2exp(LHS, R, 1);

    cmp = mpz_cmp(LHS, M_minus);

    if(!cmp && !lsb && !is_subnormal) { /* !lsb implies that f is even */
      low = 1;
    }
    else {
      low = cmp < 0 ? 1 : 0;
    }

    mpz_mul_2exp(TMP, S, 1);
    mpz_sub(TMP, TMP, M_plus);

    cmp = mpz_cmp(LHS, TMP);

    if(!cmp && !lsb && !is_subnormal) { /* !lsb implies that f is even */
      high = 1;
    }
    else {
      high = cmp > 0 ? 1 : 0;
    }

    if(low | high) break;

    out[k_index] = 48 + u;

  }                                   /* close while loop */

  /* Next we set the final digit, rounding up where appropriate */

  if(low & high) {                                  /* ( low &&  high) */
    mpz_mul_2exp(LHS, R, 1);
    cmp = mpz_cmp(LHS, S);
    if        (cmp >  0) out[k_index] = 49 + u;
    else if   (cmp <  0) out[k_index] = 48 + u;
    else { /* (cmp == 0) */
      if(u & 1)          out[k_index] = 49 + u;
      else               out[k_index] = 48 + u;
    }
  }
  else if(high)          out[k_index] = 49 + u; /* (!low &&  high) */
  else                   out[k_index] = 48 + u; /* ( low && !high) */

  mpz_clear(R);
  mpz_clear(S);
  mpz_clear(M_plus);
  mpz_clear(M_minus);
  mpz_clear(LHS);
  mpz_clear(TMP);

#ifdef NVTOA_DEBUG
  warn("nvtoa: %s %d %d\n", out, k, bits);
#endif

/*******************************************************************************************
 * eg (for nvtype of double):                                                              *
 *  if nv == 10000000000.0, final string is set to 1, k == 11.  Note that nv == 0.1e11     *
 *  if nv == 1.125e-100, final string is set to 1125, k == -99. Note that nv == 0.1125e-99 *
 *  if nv == 2 ** -1073, final string is set to 1, k == -322.   Note that nv == 0.1e-322   *
 *  if nv == 2 ** -1074, final string is set to 5, k == -323.   Note that nv == 0.5e-323   *
 *******************************************************************************************/

  /*******************************
   * Return the formatted result *
   *******************************/

  /* printf("# nvtoa: %s %d\n", out, k); */

  return _fmt_flt(aTHX_ out, k, sign, MATH_MPFR_MAX_DIG, 1);

#endif /* defined(USE_LONG_DOUBLE) && REQUIRED_LDBL_MANT_DIG == 2098 ... from near the start */
}

/****************************
 * END nvtoa                *
 ****************************/

/****************************
 * BEGIN _mpfrtoa            *
 ****************************/

/* _mpfrtoa is, like _nvtoa, adapted from p120 of    *
 * "How to Print Floating-Point Numbers Accurately"  *
 * by Guy L. Steele Jr and Jon L. White              */

SV * _mpfrtoa(pTHX_ mpfr_t * pnv, int min_normal_prec) {

  int k = 0, k_index, lsb, skip = 0, sign = 0;
  int bits, shift1, shift2, low, high, cmp, u;
  mpfr_exp_t e;
  mpz_t R, S, M_plus, M_minus, LHS, TMP;

  char * f, *out;

  sign = mpfr_signbit(*pnv);

  if(!mpfr_regular_p(*pnv)) {
    if(mpfr_zero_p(*pnv)) {
      if(sign) return newSVpv("-0.0", 0);
      return newSVpv("0.0", 0);
    }

    if(mpfr_nan_p(*pnv)) {
      return newSVpv("NaN", 0);
    }

    /* Must be Inf */

    if(sign) return newSVpv("-Inf", 0);
    return newSVpv("Inf", 0);
  }

  mpz_init(R);
  mpz_init(S);
  mpz_init(M_plus);
  mpz_init(M_minus);
  mpz_init(LHS);
  mpz_init(TMP);

/***************
 * Assign to f *
 ***************/

  bits = mpfr_get_prec(*pnv);

  Newxz(f, bits + 8, char);
  if(f == NULL) croak("Failed to allocate memory for string buffer in _mpfrtoa XSub");

  mpfr_get_str(f, &e, 2, bits, *pnv, GMP_RNDN);


/********************************
 * assignment to f is completed *
 ********************************/

#ifdef NVTOA_DEBUG
   warn(" f is %s\n exponent is %d\n precision is %d\n", f, (int)e, bits);
#endif

  if(sign) f++;

  mpz_set_str(R, f, 2);

  if(sign) f--;
  Safefree(f);

  lsb = mpz_tstbit(R, 0); /* Set lsb to the value of R's least significant bit */
  mpz_set(TMP, R);

  if(mpz_sgn(R) < 1) croak("Negative value in _mpfrtoa XSub is not allowed");
  mpz_set_ui(S, 1);

  shift2 = e - bits;

  shift1 = shift2 > 0 ? shift2 : 0;
  mpz_mul_2exp(R, R, shift1);

  shift2 = shift1       ? 0 : -shift2;
  mpz_mul_2exp(S, S, shift2);

  mpz_set_ui(M_minus, 1);
  mpz_mul_2exp(M_minus, M_minus, shift1);
  mpz_set(M_plus, M_minus);

  /*************** start simple fixup **************/

  if(bits >= min_normal_prec) {
    /***********************************************
     AFAIK, the only time this block is entered is in
     Math::FakeDD:dd_repro(). If I can recollect why
     it's needed and/or work around it in dd_repro()
     then this block of code && the min_normal_prec
     argument will be removed. Math::MPFR::mpfrtoa()
     will thus revert to accepting only one argument.
    ***********************************************/
    mpz_set_ui(LHS, 1);
    mpz_mul_2exp(LHS, LHS, bits - 1);
    if(!mpz_cmp(LHS, TMP)) {
      mpz_mul_2exp(M_plus, M_plus, 1);
      mpz_mul_2exp(R,      R,      1);
      mpz_mul_2exp(S,      S,      1);
    }
  }

  k = 0;	/* used above, so we reset to zero */
  skip = 0;	/* used above, so we reset to zero */

  mpz_cdiv_q_ui(LHS, S, 10); /* LHS = ceil(S / 10) */

  if(mpz_cmp(LHS, R) > 0) {

    /* Set k to be close to, but not greater than, the number of     *
     * decimal digits needed to represent the value of LHS. This     *
     * reduces the number of times that we need to loop through the  *
     * the next while{} loop.                                        *
     * Note that 0x1.34413509f79ffp-2 is slightly less than log2(10). */

    k = (int)floor(mpz_sizeinbase(LHS, 2) * 0x1.34413509f79ffp-2);
    if(k) k--;    /* Do not decrement if k is zero */
    mpz_ui_pow_ui(TMP, 10, k);
    k *= -1;
#ifdef NVTOA_DEBUG
    warn(" k init: %d\n", k);
#endif
    mpz_mul(R, R, TMP);
    mpz_mul(M_minus, M_minus, TMP);
    mpz_mul(M_plus, M_plus, TMP);
  }
  else {
    skip = 1; /* No need to enter the following while() loop */
  }

  if(!skip) {
    while(1) {
      if(mpz_cmp(LHS, R) <= 0) break;
      k--;
      mpz_mul_ui(R, R, 10);
      mpz_mul_ui(M_minus, M_minus, 10);
      mpz_mul_ui(M_plus, M_plus, 10);
    }                                   /* close first while loop */
#ifdef NVTOA_DEBUG
    warn(" k post 1st loop: %d\n", k);
#endif
  }

  mpz_mul_2exp(LHS, R, 1);
  mpz_add(LHS, LHS, M_plus);
  mpz_mul_2exp(TMP, S, 1);

  if(mpz_cmp(LHS, TMP) >= 0) {
    skip = 0;
    mpz_div(TMP, LHS, TMP);

    /* Set u to be close to, but not greater than, the number of     *
     * decimal digits needed to represent the value of TMP. This     *
     * reduces the number of times that we need to loop through the  *
     * the next while{} loop.                                        *
     * Note that 0x1.34413509f79ffp-2 is slightly less than log2(10). */

    u = (int)floor(mpz_sizeinbase(TMP, 2) * 0x1.34413509f79ffp-2);
    /* if(u) u--; *//* Decrement not needed here, AFAIK. */
    mpz_ui_pow_ui(TMP, 10, u);
    k += u;
#ifdef NVTOA_DEBUG
    warn(" u init: %d\n k set to: %d\n", u, k);
#endif
    mpz_mul(S, S, TMP);
  }
  else {
    skip = 1; /* No need to enter the following while() loop */
  }

  if(!skip) {
    while(1) {
      mpz_mul_2exp(TMP, S, 1);

      if(mpz_cmp(LHS, TMP) < 0) break;

      mpz_mul_ui(S, S, 10);
      k++;
    }                                 /* close second while loop */
#ifdef NVTOA_DEBUG
    warn(" k post 2nd loop: %d\n", k);
#endif
  }

  /*********************** finish simple fixup **********************/

  k_index = -1;

  Newxz(out, (int)(12 + ceil(0.30103 * bits)), char); /* 1 + ceil(log(2) / log(10) * bits), but  *
                                                       * allow a few extra for exponent and sign */

  if(out == NULL) croak("Failed to allocate memory for output string in _mpfrtoa XSub");

  /* Each iteration of the following while() loop outputs, one at a time, the *
   * digits of the final mantissa - except for the final (least significant)  *
   * digit Which is set following the termination of the loop.                */

  while(1) {

    k_index++;

    mpz_mul_ui(TMP, R, 10);
    mpz_fdiv_qr(LHS, R, TMP, S);
    u = mpz_get_ui(LHS);

    mpz_mul_ui(M_minus, M_minus, 10);
    mpz_mul_ui(M_plus, M_plus, 10);

    mpz_mul_2exp(LHS, R, 1);

    cmp = mpz_cmp(LHS, M_minus);

    if(!cmp && !lsb) { /* !lsb implies that f is even */
      low = 1;
    }
    else {
      low = cmp < 0 ? 1 : 0;
    }

    mpz_mul_2exp(TMP, S, 1);
    mpz_sub(TMP, TMP, M_plus);

    cmp = mpz_cmp(LHS, TMP);

    if(!cmp && !lsb) { /* !lsb implies that f is even */
      high = 1;
    }
    else {
      high = cmp > 0 ? 1 : 0;
    }

    if(low | high) break;

    out[k_index] = 48 + u;

  }                                   /* close while loop */

  /* Next we set the final digit, rounding up where appropriate */

  if(low & high) {                                  /* ( low &&  high) */
    mpz_mul_2exp(LHS, R, 1);
    cmp = mpz_cmp(LHS, S);
    if        (cmp >  0) out[k_index] = 49 + u;
    else if   (cmp <  0) out[k_index] = 48 + u;
    else { /* (cmp == 0) */
      if(u & 1)          out[k_index] = 49 + u;
      else               out[k_index] = 48 + u;
    }
  }
  else if(high)          out[k_index] = 49 + u; /* (!low &&  high) */
  else                   out[k_index] = 48 + u; /* ( low && !high) */

  mpz_clear(R);
  mpz_clear(S);
  mpz_clear(M_plus);
  mpz_clear(M_minus);
  mpz_clear(LHS);
  mpz_clear(TMP);

#ifdef NVTOA_DEBUG
  warn(" final string: %s\n k = %d\n", out, k);
#endif

  /*********************
   * Return the formatted the result *
   *********************/

  return _fmt_flt(aTHX_ out, k, sign, (int)ceil(0x1.34413509f79ffp-2 * mpfr_get_prec(*pnv)) + 1, 1);
}

/****************************
 * END _mpfrtoa             *
 ****************************/

/****************************
 * BEGIN doubletoa          *
 ****************************/

void set_fallback_flag(pTHX) {
  dSP;

  PUSHMARK(SP);
  call_pv("Math::MPFR::perl_set_fallback_flag", G_DISCARD|G_NOARGS);
}

SV * doubletoa(pTHX_ SV * sv, ...) {

  /* calls functions contained in grisu3.c */

#if NVSIZE == 8

  dXSARGS;

  double v = SvNV(sv);
  int d_exp, len, success, sign = 1;
  uint64_t u64;

  char dst [] = {'\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0',
                 '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0'};

  char *s2 = dst;

  int fallback = items > 1 ? 0 : 1; /* A true value for sign implies that nvtoa() will be used  *
                                 * if grisu3() fails to produce a result. Else sprintf()    *
                                 * will be used when grisu3() fails. See pod documentation. */
#ifdef DTOA_ASSERT
  if(!dst) croak("dst does not hold a true value");
  /* assert(dst); */
#endif

  if(v < 0) {
    v = -v;
    sign = -1;
  }

  u64 = CAST_U64(v);

  /* Prehandle NaNs */
  if((u64 << 1) > 0xFFE0000000000000ULL) {
    sprintf(dst, "NaN");
    return newSVpv(dst, 0);
  }

  /* Prehandle zero. */
  if(v == 0) {
    if(u64) *s2++ = '-';
    *s2++ = '0';
    *s2++ = '.';
    *s2++ = '0';
    *s2 = '\0';
    return newSVpv(dst, 0);
  }

  /* Prehandle infinity. */
  if(u64 == D64_EXP_MASK) {
    if(sign < 0) *s2++ = '-';
    *s2++ = 'I';
    *s2++ = 'n';
    *s2++ = 'f';
    *s2 = '\0';
    return newSVpv(dst, 0);
  }

  success = grisu3(v, s2, &len, &d_exp);

  /* If grisu3 was not able to convert the number to a string, then use either nvtoa or sprintf. */
  /* Both are accurate - and sprintf is quicker than nvtoa. However, unlike nvtoa, sprintf will  */
  /* sometimes deliver more digits than are necessary.                                           */

  if(!success) {
#if defined FALLBACK_NOTIFY
    set_fallback_flag(aTHX);
#endif

    if(fallback) {
      return _nvtoa(aTHX_ v * sign);
    }

    sprintf(s2, "%.16e", (v * sign));
    return newSVpv(dst, 0);
  }

  /* We have an integer string of form "151324135" and a base-10 exponent for that number. */
  /* Now, we just need to format it ...                                                    */

  /* printf("# doubletoa: %s %d\n", dst, d_exp + strlen(dst)); */
  return _fmt_flt(aTHX_ dst, (int)(d_exp + strlen(dst)), sign < 0 ? 1 : 0, MATH_MPFR_MAX_DIG, 0);

#else
  PERL_UNUSED_ARG(sv);
  croak("The doubletoa function is unavailable - it requires that $Config{nvsize} == 8");
#endif
}


/****************************
 *  END doubletoa           *
 ****************************/

int _fallback_notify(void) {
#if defined(FALLBACK_NOTIFY)
  return 1;
#else
  return 0;
#endif
}

SV * _numtoa(pTHX_ SV * in) {
  char buffer[IVSIZE * 3];

  if(!SvOK(in) || SvUOK(in)) {
    sprintf(buffer, "%" UVuf, SvUV(in));
    return newSVpv(buffer, 0);
  }

  if(SV_IS_IOK(in)) {
    sprintf(buffer, "%" IVdf, SvIV(in));
    return newSVpv(buffer, 0);
  }

  if(SV_IS_NOK(in)) {
    return _nvtoa(aTHX_ SvNV(in));
  }

  croak("Not a numeric argument given to _numtoa function");
}

void decimalize(pTHX_ SV * a, ...) {
  dXSARGS;
  mpfr_prec_t prec, i;
  mpfr_exp_t exp, high_exp, low_exp = 0;
  char * buff;
  char * dec_buff;
  int is_neg = 0;
  double digits = 0;
  double div = 0x1.a934f0979a371p+1;	/* log2(10) */
  double mul = 0x1.65df657b04301p-1;	/* log10(5) */

  if(!mpfr_regular_p(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))))) {
    if(items > 1) {
      ST(0) = sv_2mortal(newSViv(0));
      XSRETURN(1);
    }
    Newxz(buff, 8, char);
    mpfr_sprintf(buff, "%Rg", *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))));
    ST(0) = MORTALIZED_PV(buff);    /* defined in math_mpfr_include.h */
    Safefree(buff);
    XSRETURN(1);
  }

  prec = mpfr_get_prec(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))));

#if 262146 > MPFR_VERSION
  if(prec < 2) croak("Precision of 1 not allowed in decimalize function until mpfr-4.0.2");
#endif

  Newxz(buff, prec + 2, char);

  mpfr_get_str(buff, &exp, 2, prec, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), GMP_RNDN);

  /* The decimal point is implicitly located at the very *
   * beginning of the string. Therefore, the power of 2  *
   * to which the highest set bit is raised is exp - 1   */

  high_exp = exp - 1;

  if(high_exp >= prec - 1) low_exp = 0; /* No need to locate the lowest set bit */

  else {

    /* We do need to locate the lowest set bit */

    if(buff[0] == '-') {
      buff++;
      is_neg = -1;
    }

    /* The power to which the lowest set bit is raised is  *
     * calculated in the following for{} loop:             */

    for(i = prec - 1; i >= 0; i--) {
      if(buff[i] == '1') {
        low_exp = high_exp - i;
        break;
      }
    }

    if(is_neg) buff--;
  }

  Safefree(buff);

  /* Next determine the number of decimal digits that are needed to   *
   * exactly express the function's argument in base 10               */

  if(low_exp >= 0) {
    /* Both low_exp and high_exp are >= 0.                            *
     * The number of digits is calculated solely from high_exp.       *
     * We add on "1" to allow for cases where the value of high_exp   *
     * does not alone determine how many siginificant digits are      *
     * required - eg the value 2 ** 13 (8192) requires 4 decimal      *
     * digits, but if the second highest bit is also set, then 5      *
     * decimal digits are needed because (2**13) + (2**12) == 12288   */

    digits = 1 + ceil( high_exp / div );
  }

  else if(high_exp < 0) {
    /* Both low_exp and high_exp are < 0 */

    digits = ceil( -low_exp * mul ) + ceil( -low_exp / div ) - floor( -high_exp / div );
  }

  else {
    /* low_exp < 0, high_exp >= 0        *
     * Add 1, as in the above if{} block */

    digits = 1 + ceil( high_exp / div ) + ceil( -low_exp * mul ) + floor( -low_exp / div );
  }

  if(digits > INT_MAX - 30)
    croak("Too many digits (%.0f) requested in decimalize function", digits);

  if(items > 1) {
    ST(0) = sv_2mortal(newSViv((IV)digits));
    XSRETURN(1);
  }

  Newxz(dec_buff, (int)digits + 30, char); /* allow for a 20-digit exponent, a radix point, *
                                            * a leading '-', an 'e-', a terminating NULL,   *
                                            * and a saftety net of 5 bytes (== 30, total)   */
  if(dec_buff == NULL)
    croak("Unable to allocate %.0f bytes of memory in decimalize function",
          digits + 30.0);

  mpfr_sprintf(dec_buff, "%.*Rg", (int)digits, *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))));
  ST(0) = MORTALIZED_PV(dec_buff);    /* defined in math_mpfr_include.h */
  Safefree(dec_buff);
  XSRETURN(1);

}

int IOK_flag(SV * sv) {
  if(SvUOK(sv)) return 2;
  if(SvIOK(sv)) return 1;
  return 0;
}

int POK_flag(SV * sv) {
  if(SvPOK(sv)) return 1;
  return 0;
}

int NOK_flag(SV * sv) {
  if(SvNOK(sv)) return 1;
  return 0;
}

int _sis_perl_version(void) {
  return SIS_PERL_VERSION;
}

int _has_pv_nv_bug(void) {
#if defined(MPFR_PV_NV_BUG)
  return 1;
#else
  return 0;
#endif
}

int _sizeof_exp(void) {
  return sizeof(mpfr_exp_t);
}

int _sizeof_prec(void) {
  return sizeof(mpfr_prec_t);
}

int _has_bizarre_infnan(void) {
#if defined(_WIN32_BIZARRE_INFNAN)
  return 1;
#else
  return 0;
#endif
}

SV * _gmp_cflags(pTHX) {
#if defined(__GMP_CFLAGS)
  return newSVpv(__GMP_CFLAGS, 0);
#else
  return &PL_sv_undef;
#endif
}

SV * _gmp_cc(pTHX) {
#if defined(__GMP_CC)
  return newSVpv(__GMP_CC, 0);
#else
  return &PL_sv_undef;
#endif
}

int _have_float16(void) {
#if defined(HAVE_FLOAT16)      /* defined in Makefile.PL */
  return 1;
#else
  return 0;
#endif
}

/********************************************/
/********************************************/

SV * _gmp_printf_nv(pTHX_ SV * a, SV * b) {
     int ret;

     if(SV_IS_NOK(b)) {
       ret = gmp_printf(SvPV_nolen(a), SvNVX(b));
       fflush(stdout);
       return newSViv(ret);
     }

     croak("Unrecognised type supplied as argument to _gmp_printf_nv");
}

SV * _gmp_fprintf_nv(pTHX_ FILE * stream, SV * a, SV * b) {
     int ret;

     if(SV_IS_NOK(b)) {
       ret = gmp_fprintf(stream, SvPV_nolen(a), SvNVX(b));
       fflush(stream);
       return newSViv(ret);
     }

     croak("Unrecognised type supplied as argument to _gmp_fprintf_nv");
}

SV * _gmp_sprintf_nv(pTHX_ SV * s, SV * a, SV * b, int buflen) {
     int ret;
     char * stream;

     Newx(stream, buflen, char);

     if(SV_IS_NOK(b)) {
       ret = gmp_sprintf(stream, SvPV_nolen(a), SvNVX(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     Safefree(stream); /* In case the ensuing croak() is encased in an eval{} block */
     croak("Unrecognised type supplied as argument to _gmp_sprintf_nv");
}

SV * _gmp_snprintf_nv(pTHX_ SV * s, SV * bytes, SV * a, SV * b, int buflen) {
     int ret;
     char * stream;

     Newx(stream, buflen, char);

     if(SV_IS_NOK(b)) {
       ret = gmp_snprintf(stream, (size_t)SvUV(bytes), SvPV_nolen(a), SvNVX(b));
       sv_setpv(s, stream);
       Safefree(stream);
       return newSViv(ret);
     }

     Safefree(stream); /* In case the ensuing croak() is encased in an eval{} block */
     croak("Unrecognised type supplied as argument to _gmp_snprintf_nv");
}

int _looks_like_number(pTHX_ SV * in) {
     if(looks_like_number(in)) return 1;
     return 0;
}

SV * _overload_fmod (pTHX_ mpfr_t * a, mpfr_t *b, SV * third) {
     mpfr_t * mpfr_t_obj;
     SV * obj_ref, * obj;

     NEW_MATH_MPFR_OBJECT("Math::MPFR", _overload_fmod) /* defined in math_mpfr_include.h */
     mpfr_init(*mpfr_t_obj);
     OBJ_READONLY_ON /*defined in math_mpfr_include.h */

     if(SWITCH_ARGS) mpfr_fmod(*mpfr_t_obj, *b, *a, __gmpfr_default_rounding_mode);
     else mpfr_fmod(*mpfr_t_obj, *a, *b, __gmpfr_default_rounding_mode);
     return obj_ref;
}

SV * _overload_fmod_eq (pTHX_ SV * a, mpfr_t *b, SV * third) {

     PERL_UNUSED_ARG(third);
     SvREFCNT_inc(a);
     mpfr_fmod(*(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *(INT2PTR(mpfr_t *, SvIVX(SvRV(a)))), *b, __gmpfr_default_rounding_mode);
     return a;
}


#line 9225 "MPFR.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 9369 "MPFR.c"

XS_EUPXS(XS_Math__MPFR__has_inttypes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__has_inttypes)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_inttypes();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_NNW_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_NNW_val)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 9227 "MPFR.xs"
  RETVAL = NNW_val (aTHX);
#line 9400 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_NOK_POK_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_NOK_POK_val)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 9234 "MPFR.xs"
  RETVAL = NOK_POK_val (aTHX);
#line 9419 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__win32_infnanstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__win32_infnanstring)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	char *	s = (char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _win32_infnanstring(s);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__fmt_flt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__fmt_flt)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "out, k, sign, max_decimal_prec, sf");
    {
	char *	out = (char *)SvPV_nolen(ST(0))
;
	int	k = (int)SvIV(ST(1))
;
	int	sign = (int)SvIV(ST(2))
;
	int	max_decimal_prec = (int)SvIV(ST(3))
;
	int	sf = (int)SvIV(ST(4))
;
	SV *	RETVAL;
#line 9250 "MPFR.xs"
  RETVAL = _fmt_flt (aTHX_ out, k, sign, max_decimal_prec, sf);
#line 9467 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_rounding_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_rounding_mode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	round = ST(0)
;
#line 9257 "MPFR.xs"
        Rmpfr_set_default_rounding_mode(aTHX_ round);
        XSRETURN_EMPTY; /* return empty stack */
#line 9489 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_rounding_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_rounding_mode)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned long	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_get_default_rounding_mode();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_prec_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_prec_round)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, prec, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9270 "MPFR.xs"
  RETVAL = Rmpfr_prec_round (aTHX_ p, prec, round);
#line 9530 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 9277 "MPFR.xs"
        DESTROY(aTHX_ p);
        XSRETURN_EMPTY; /* return empty stack */
#line 9552 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 9284 "MPFR.xs"
        Rmpfr_clear(aTHX_ p);
        XSRETURN_EMPTY; /* return empty stack */
#line 9573 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_mpfr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_mpfr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 9291 "MPFR.xs"
        Rmpfr_clear_mpfr(p);
        XSRETURN_EMPTY; /* return empty stack */
#line 9594 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_ptr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_ptr)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 9298 "MPFR.xs"
        Rmpfr_clear_ptr(aTHX_ p);
        XSRETURN_EMPTY; /* return empty stack */
#line 9615 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clears); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clears)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "p, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	p = ST(0)
;
#line 9305 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_clears(aTHX_ p);
        XSRETURN_EMPTY; /* return empty stack */
#line 9637 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9312 "MPFR.xs"
  RETVAL = Rmpfr_init (aTHX);
#line 9654 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    {
	SV *	prec = ST(0)
;
	SV *	RETVAL;
#line 9320 "MPFR.xs"
  RETVAL = Rmpfr_init2 (aTHX_ prec);
#line 9674 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_nobless)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9326 "MPFR.xs"
  RETVAL = Rmpfr_init_nobless (aTHX);
#line 9692 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init2_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init2_nobless)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    {
	SV *	prec = ST(0)
;
	SV *	RETVAL;
#line 9334 "MPFR.xs"
  RETVAL = Rmpfr_init2_nobless (aTHX_ prec);
#line 9712 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9342 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set(aTHX_ q, round);
        return;
#line 9737 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9351 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_ui(aTHX_ q, round);
        return;
#line 9761 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9360 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_si(aTHX_ q, round);
        return;
#line 9785 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9369 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_d(aTHX_ q, round);
        return;
#line 9809 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9378 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_ld(aTHX_ q, round);
        return;
#line 9833 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpf_t *            q = INT2PTR(mpf_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9387 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_f(aTHX_ q, round);
        return;
#line 9857 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *            q = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9396 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_z(aTHX_ q, round);
        return;
#line 9881 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            q = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9405 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_q(aTHX_ q, round);
        return;
#line 9905 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "q, base, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	base = ST(1)
;
	SV *	round = ST(2)
;
#line 9415 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_str(aTHX_ q, base, round);
        return;
#line 9931 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9424 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_nobless(aTHX_ q, round);
        return;
#line 9955 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ui_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9433 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_ui_nobless(aTHX_ q, round);
        return;
#line 9979 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_si_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9442 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_si_nobless(aTHX_ q, round);
        return;
#line 10003 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_d_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9451 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_d_nobless(aTHX_ q, round);
        return;
#line 10027 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_ld_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9460 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_ld_nobless(aTHX_ q, round);
        return;
#line 10051 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_f_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpf_t *            q = INT2PTR(mpf_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9469 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_f_nobless(aTHX_ q, round);
        return;
#line 10075 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_z_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpz_t *            q = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9478 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_z_nobless(aTHX_ q, round);
        return;
#line 10099 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_q_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            q = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
#line 9487 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_q_nobless(aTHX_ q, round);
        return;
#line 10123 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_str_nobless)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "q, base, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	base = ST(1)
;
	SV *	round = ST(2)
;
#line 9497 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_str_nobless(aTHX_ q, base, round);
        return;
#line 10149 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_deref2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_deref2)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, base, n_digits, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	n_digits = ST(2)
;
	SV *	round = ST(3)
;
#line 9508 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_deref2(aTHX_ p, base, n_digits, round);
        return;
#line 10177 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_default_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	prec = ST(0)
;
#line 9516 "MPFR.xs"
        Rmpfr_set_default_prec(aTHX_ prec);
        XSRETURN_EMPTY; /* return empty stack */
#line 10198 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_default_prec)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 9522 "MPFR.xs"
  RETVAL = Rmpfr_get_default_prec (aTHX);
#line 10215 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_min_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_min_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 9530 "MPFR.xs"
  RETVAL = Rmpfr_min_prec (aTHX_ x);
#line 10235 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
#line 9538 "MPFR.xs"
        Rmpfr_set_prec(aTHX_ p, prec);
        XSRETURN_EMPTY; /* return empty stack */
#line 10259 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec_raw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_prec_raw)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	prec = ST(1)
;
#line 9546 "MPFR.xs"
        Rmpfr_set_prec_raw(aTHX_ p, prec);
        XSRETURN_EMPTY; /* return empty stack */
#line 10282 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 9553 "MPFR.xs"
  RETVAL = Rmpfr_get_prec (aTHX_ p);
#line 10301 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9562 "MPFR.xs"
  RETVAL = Rmpfr_set (aTHX_ p, q, round);
#line 10325 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9571 "MPFR.xs"
  RETVAL = Rmpfr_set_ui (aTHX_ p, q, round);
#line 10349 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9580 "MPFR.xs"
  RETVAL = Rmpfr_set_si (aTHX_ p, q, round);
#line 10373 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9589 "MPFR.xs"
  RETVAL = Rmpfr_set_uj (aTHX_ p, q, round);
#line 10397 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9598 "MPFR.xs"
  RETVAL = Rmpfr_set_sj (aTHX_ p, q, round);
#line 10421 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_NV)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	unsigned int	round = (unsigned int)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;
#line 9607 "MPFR.xs"
  RETVAL = Rmpfr_set_NV (aTHX_ p, q, round);
#line 10446 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_NV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9615 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_NV(aTHX_ q, round);
        return;
#line 10471 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_NV_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_NV_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 9624 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_NV_nobless(aTHX_ q, round);
        return;
#line 10495 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_float128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	int	RETVAL;
	dXSTARG;
#line 9633 "MPFR.xs"
  RETVAL = Rmpfr_cmp_float128 (aTHX_ a, b);
#line 10517 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_NV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	int	RETVAL;
	dXSTARG;
#line 9641 "MPFR.xs"
  RETVAL = Rmpfr_cmp_NV (aTHX_ a, b);
#line 10540 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ld)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9650 "MPFR.xs"
  RETVAL = Rmpfr_set_ld (aTHX_ p, q, round);
#line 10564 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_d)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9659 "MPFR.xs"
  RETVAL = Rmpfr_set_d (aTHX_ p, q, round);
#line 10588 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            q = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9668 "MPFR.xs"
  RETVAL = Rmpfr_set_z (aTHX_ p, q, round);
#line 10612 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_q)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            q = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9677 "MPFR.xs"
  RETVAL = Rmpfr_set_q (aTHX_ p, q, round);
#line 10636 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_f)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, q, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            q = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9686 "MPFR.xs"
  RETVAL = Rmpfr_set_f (aTHX_ p, q, round);
#line 10660 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, num, base, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	num = ST(1)
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	int	RETVAL;
	dXSTARG;
#line 9696 "MPFR.xs"
  RETVAL = Rmpfr_set_str (aTHX_ p, num, base, round);
#line 10687 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inf)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, sign");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	sign = (int)SvIV(ST(1))
;
#line 9704 "MPFR.xs"
        Rmpfr_set_inf(p, sign);
        XSRETURN_EMPTY; /* return empty stack */
#line 10711 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nan)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 9711 "MPFR.xs"
        Rmpfr_set_nan(p);
        XSRETURN_EMPTY; /* return empty stack */
#line 10732 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_swap); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_swap)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, q");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            q = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
#line 9719 "MPFR.xs"
        Rmpfr_swap(p, q);
        XSRETURN_EMPTY; /* return empty stack */
#line 10755 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 9727 "MPFR.xs"
  RETVAL = Rmpfr_get_d (aTHX_ p, round);
#line 10776 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "exp, p, round");
    {
	SV *	exp = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9736 "MPFR.xs"
  RETVAL = Rmpfr_get_d_2exp (aTHX_ exp, p, round);
#line 10800 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "exp, p, round");
    {
	SV *	exp = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 9745 "MPFR.xs"
  RETVAL = Rmpfr_get_ld_2exp (aTHX_ exp, p, round);
#line 10824 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ld)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 9753 "MPFR.xs"
  RETVAL = Rmpfr_get_ld (aTHX_ p, round);
#line 10846 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_d1)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_get_d1(p);
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z_2exp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "z, p");
    {
	mpz_t *            z = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	RETVAL;
#line 9765 "MPFR.xs"
  RETVAL = Rmpfr_get_z_2exp (aTHX_ z, p);
#line 10888 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9775 "MPFR.xs"
  RETVAL = Rmpfr_add (aTHX_ a, b, c, round);
#line 10914 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9785 "MPFR.xs"
  RETVAL = Rmpfr_add_ui (aTHX_ a, b, c, round);
#line 10940 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9795 "MPFR.xs"
  RETVAL = Rmpfr_add_d (aTHX_ a, b, c, round);
#line 10966 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9805 "MPFR.xs"
  RETVAL = Rmpfr_add_si (aTHX_ a, b, c, round);
#line 10992 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9815 "MPFR.xs"
  RETVAL = Rmpfr_add_z (aTHX_ a, b, c, round);
#line 11018 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_q)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            a = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
#line 9823 "MPFR.xs"
        Rmpfr_get_q(a, b);
        XSRETURN_EMPTY; /* return empty stack */
#line 11042 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_add_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_add_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9833 "MPFR.xs"
  RETVAL = Rmpfr_add_q (aTHX_ a, b, c, round);
#line 11067 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_q_add_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_q_add_fr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            a = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            b = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
#line 9842 "MPFR.xs"
        q_add_fr(a, b, c);
        XSRETURN_EMPTY; /* return empty stack */
#line 11093 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9852 "MPFR.xs"
  RETVAL = Rmpfr_sub (aTHX_ a, b, c, round);
#line 11118 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9862 "MPFR.xs"
  RETVAL = Rmpfr_sub_ui (aTHX_ a, b, c, round);
#line 11144 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9872 "MPFR.xs"
  RETVAL = Rmpfr_sub_d (aTHX_ a, b, c, round);
#line 11170 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9882 "MPFR.xs"
  RETVAL = Rmpfr_sub_z (aTHX_ a, b, c, round);
#line 11196 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9892 "MPFR.xs"
  RETVAL = Rmpfr_sub_q (aTHX_ a, b, c, round);
#line 11222 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_q_sub_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_q_sub_fr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            a = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            b = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
#line 9901 "MPFR.xs"
        q_sub_fr(a, b, c);
        XSRETURN_EMPTY; /* return empty stack */
#line 11248 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9911 "MPFR.xs"
  RETVAL = Rmpfr_ui_sub (aTHX_ a, b, c, round);
#line 11273 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_d_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_d_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9921 "MPFR.xs"
  RETVAL = Rmpfr_d_sub (aTHX_ a, b, c, round);
#line 11299 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9931 "MPFR.xs"
  RETVAL = Rmpfr_mul (aTHX_ a, b, c, round);
#line 11325 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9941 "MPFR.xs"
  RETVAL = Rmpfr_mul_ui (aTHX_ a, b, c, round);
#line 11351 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9951 "MPFR.xs"
  RETVAL = Rmpfr_mul_d (aTHX_ a, b, c, round);
#line 11377 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9961 "MPFR.xs"
  RETVAL = Rmpfr_mul_z (aTHX_ a, b, c, round);
#line 11403 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9971 "MPFR.xs"
  RETVAL = Rmpfr_mul_q (aTHX_ a, b, c, round);
#line 11429 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_q_mul_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_q_mul_fr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            a = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            b = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
#line 9980 "MPFR.xs"
        q_mul_fr(a, b, c);
        XSRETURN_EMPTY; /* return empty stack */
#line 11455 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_dim); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_dim)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 9990 "MPFR.xs"
  RETVAL = Rmpfr_dim (aTHX_ rop, op1, op2, round);
#line 11480 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10000 "MPFR.xs"
  RETVAL = Rmpfr_div (aTHX_ a, b, c, round);
#line 11506 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10010 "MPFR.xs"
  RETVAL = Rmpfr_div_ui (aTHX_ a, b, c, round);
#line 11532 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_d)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10020 "MPFR.xs"
  RETVAL = Rmpfr_div_d (aTHX_ a, b, c, round);
#line 11558 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10030 "MPFR.xs"
  RETVAL = Rmpfr_div_z (aTHX_ a, b, c, round);
#line 11584 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_q)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpq_t *            c = INT2PTR(mpq_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10040 "MPFR.xs"
  RETVAL = Rmpfr_div_q (aTHX_ a, b, c, round);
#line 11610 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_q_div_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_q_div_fr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            a = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            b = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
#line 10049 "MPFR.xs"
        q_div_fr(a, b, c);
        XSRETURN_EMPTY; /* return empty stack */
#line 11636 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_q_fmod_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_q_fmod_fr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            a = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            b = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
#line 10058 "MPFR.xs"
        I32* temp;
#line 11660 "MPFR.c"
#line 10060 "MPFR.xs"
        temp = PL_markstack_ptr++;
        q_fmod_fr(a, b, c);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return;
#line 11671 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10077 "MPFR.xs"
  RETVAL = Rmpfr_ui_div (aTHX_ a, b, c, round);
#line 11696 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_d_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_d_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10087 "MPFR.xs"
  RETVAL = Rmpfr_d_div (aTHX_ a, b, c, round);
#line 11722 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10096 "MPFR.xs"
  RETVAL = Rmpfr_sqrt (aTHX_ a, b, round);
#line 11746 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rec_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rec_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10105 "MPFR.xs"
  RETVAL = Rmpfr_rec_sqrt (aTHX_ a, b, round);
#line 11770 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cbrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cbrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10114 "MPFR.xs"
  RETVAL = Rmpfr_cbrt (aTHX_ a, b, round);
#line 11794 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sqrt_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10123 "MPFR.xs"
  RETVAL = Rmpfr_sqrt_ui (aTHX_ a, b, round);
#line 11818 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10133 "MPFR.xs"
  RETVAL = Rmpfr_pow_ui (aTHX_ a, b, c, round);
#line 11844 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_uj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10143 "MPFR.xs"
  RETVAL = Rmpfr_pow_uj (aTHX_ a, b, c, round);
#line 11870 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_IV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_IV)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10153 "MPFR.xs"
  RETVAL = Rmpfr_pow_IV (aTHX_ a, b, c, round);
#line 11896 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10163 "MPFR.xs"
  RETVAL = Rmpfr_ui_pow_ui (aTHX_ a, b, c, round);
#line 11922 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ui_pow)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10173 "MPFR.xs"
  RETVAL = Rmpfr_ui_pow (aTHX_ a, b, c, round);
#line 11948 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10183 "MPFR.xs"
  RETVAL = Rmpfr_pow_si (aTHX_ a, b, c, round);
#line 11974 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_sj)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10193 "MPFR.xs"
  RETVAL = Rmpfr_pow_sj (aTHX_ a, b, c, round);
#line 12000 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10203 "MPFR.xs"
  RETVAL = Rmpfr_pow (aTHX_ a, b, c, round);
#line 12026 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_powr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_powr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10213 "MPFR.xs"
  RETVAL = Rmpfr_powr (aTHX_ a, b, c, round);
#line 12052 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pown)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10223 "MPFR.xs"
  RETVAL = Rmpfr_pown (aTHX_ a, b, c, round);
#line 12078 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_compound_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_compound_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10233 "MPFR.xs"
  RETVAL = Rmpfr_compound_si (aTHX_ a, b, c, round);
#line 12104 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_compound); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_compound)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10243 "MPFR.xs"
  RETVAL = Rmpfr_compound (aTHX_ a, b, c, round);
#line 12130 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_neg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_neg)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10252 "MPFR.xs"
  RETVAL = Rmpfr_neg (aTHX_ a, b, round);
#line 12154 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_abs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_abs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10261 "MPFR.xs"
  RETVAL = Rmpfr_abs (aTHX_ a, b, round);
#line 12178 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10271 "MPFR.xs"
  RETVAL = Rmpfr_mul_2exp (aTHX_ a, b, c, round);
#line 12204 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10281 "MPFR.xs"
  RETVAL = Rmpfr_mul_2ui (aTHX_ a, b, c, round);
#line 12230 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_2si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10291 "MPFR.xs"
  RETVAL = Rmpfr_mul_2si (aTHX_ a, b, c, round);
#line 12256 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10301 "MPFR.xs"
  RETVAL = Rmpfr_div_2exp (aTHX_ a, b, c, round);
#line 12282 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10311 "MPFR.xs"
  RETVAL = Rmpfr_div_2ui (aTHX_ a, b, c, round);
#line 12308 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_2si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10321 "MPFR.xs"
  RETVAL = Rmpfr_div_2si (aTHX_ a, b, c, round);
#line 12334 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_total_order_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_total_order_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_total_order_p(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmpabs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmpabs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmpabs(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmpabs_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmpabs_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	unsigned long	b = (unsigned long)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmpabs_ui(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	unsigned long	b = (unsigned long)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_ui(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	long	b = (long)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_si(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_uj)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	UV	b = (UV)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 10359 "MPFR.xs"
  RETVAL = Rmpfr_cmp_uj (aTHX_ a, b);
#line 12489 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_sj)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	IV	b = (IV)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;
#line 10367 "MPFR.xs"
  RETVAL = Rmpfr_cmp_sj (aTHX_ a, b);
#line 12512 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_IV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_IV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	int	RETVAL;
	dXSTARG;
#line 10375 "MPFR.xs"
  RETVAL = Rmpfr_cmp_IV (aTHX_ a, b);
#line 12535 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_d); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_d)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	double	b = (double)SvNV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_d(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ld); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ld)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	int	RETVAL;
	dXSTARG;
#line 10388 "MPFR.xs"
  RETVAL = Rmpfr_cmp_ld (aTHX_ a, b);
#line 12580 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_ui_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	int	RETVAL;
	dXSTARG;
#line 10397 "MPFR.xs"
  RETVAL = Rmpfr_cmp_ui_2exp (aTHX_ a, b, c);
#line 12605 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_si_2exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	int	RETVAL;
	dXSTARG;
#line 10406 "MPFR.xs"
  RETVAL = Rmpfr_cmp_si_2exp (aTHX_ a, b, c);
#line 12630 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	c = (unsigned long)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_eq(a, b, c);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nan_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nan_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_nan_p(p);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_inf_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_inf_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_inf_p(p);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_number_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_number_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_number_p(p);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_reldiff); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_reldiff)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
#line 10434 "MPFR.xs"
        Rmpfr_reldiff(aTHX_ a, b, c, round);
        XSRETURN_EMPTY; /* return empty stack */
#line 12742 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sgn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sgn)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_sgn(p);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_greater_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_greater_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_greater_p(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_greaterequal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_greaterequal_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_greaterequal_p(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_less_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_less_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_less_p(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lessequal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lessequal_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_lessequal_p(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lessgreater_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lessgreater_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_lessgreater_p(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_equal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_equal_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_equal_p(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_unordered_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_unordered_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_unordered_p(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sin_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sin_cos)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10483 "MPFR.xs"
  RETVAL = Rmpfr_sin_cos (aTHX_ a, b, c, round);
#line 12941 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh_cosh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh_cosh)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10493 "MPFR.xs"
  RETVAL = Rmpfr_sinh_cosh (aTHX_ a, b, c, round);
#line 12967 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10502 "MPFR.xs"
  RETVAL = Rmpfr_sin (aTHX_ a, b, round);
#line 12991 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sinu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sinu)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	c = (unsigned long)SvUV(ST(2))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10512 "MPFR.xs"
  RETVAL = Rmpfr_sinu (aTHX_ a, b, c, round);
#line 13017 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sinpi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sinpi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10521 "MPFR.xs"
  RETVAL = Rmpfr_sinpi (aTHX_ a, b, round);
#line 13041 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10530 "MPFR.xs"
  RETVAL = Rmpfr_cos (aTHX_ a, b, round);
#line 13065 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cosu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cosu)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	c = (unsigned long)SvUV(ST(2))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10540 "MPFR.xs"
  RETVAL = Rmpfr_cosu (aTHX_ a, b, c, round);
#line 13091 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cospi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cospi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10549 "MPFR.xs"
  RETVAL = Rmpfr_cospi (aTHX_ a, b, round);
#line 13115 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_tan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_tan)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10558 "MPFR.xs"
  RETVAL = Rmpfr_tan (aTHX_ a, b, round);
#line 13139 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_tanu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_tanu)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	c = (unsigned long)SvUV(ST(2))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10568 "MPFR.xs"
  RETVAL = Rmpfr_tanu (aTHX_ a, b, c, round);
#line 13165 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_tanpi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_tanpi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10577 "MPFR.xs"
  RETVAL = Rmpfr_tanpi (aTHX_ a, b, round);
#line 13189 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_asin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_asin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10586 "MPFR.xs"
  RETVAL = Rmpfr_asin (aTHX_ a, b, round);
#line 13213 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_asinu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_asinu)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	c = (unsigned long)SvUV(ST(2))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10596 "MPFR.xs"
  RETVAL = Rmpfr_asinu (aTHX_ a, b, c, round);
#line 13239 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_asinpi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_asinpi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10605 "MPFR.xs"
  RETVAL = Rmpfr_asinpi (aTHX_ a, b, round);
#line 13263 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_acos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_acos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10614 "MPFR.xs"
  RETVAL = Rmpfr_acos (aTHX_ a, b, round);
#line 13287 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_acosu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_acosu)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	c = (unsigned long)SvUV(ST(2))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10624 "MPFR.xs"
  RETVAL = Rmpfr_acosu (aTHX_ a, b, c, round);
#line 13313 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_acospi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_acospi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10633 "MPFR.xs"
  RETVAL = Rmpfr_acospi (aTHX_ a, b, round);
#line 13337 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atan)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10642 "MPFR.xs"
  RETVAL = Rmpfr_atan (aTHX_ a, b, round);
#line 13361 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atanu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atanu)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	c = (unsigned long)SvUV(ST(2))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10652 "MPFR.xs"
  RETVAL = Rmpfr_atanu (aTHX_ a, b, c, round);
#line 13387 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atanpi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atanpi)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10661 "MPFR.xs"
  RETVAL = Rmpfr_atanpi (aTHX_ a, b, round);
#line 13411 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sinh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10670 "MPFR.xs"
  RETVAL = Rmpfr_sinh (aTHX_ a, b, round);
#line 13435 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cosh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cosh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10679 "MPFR.xs"
  RETVAL = Rmpfr_cosh (aTHX_ a, b, round);
#line 13459 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_tanh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_tanh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10688 "MPFR.xs"
  RETVAL = Rmpfr_tanh (aTHX_ a, b, round);
#line 13483 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_asinh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_asinh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10697 "MPFR.xs"
  RETVAL = Rmpfr_asinh (aTHX_ a, b, round);
#line 13507 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_acosh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_acosh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10706 "MPFR.xs"
  RETVAL = Rmpfr_acosh (aTHX_ a, b, round);
#line 13531 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atanh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atanh)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10715 "MPFR.xs"
  RETVAL = Rmpfr_atanh (aTHX_ a, b, round);
#line 13555 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fac_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fac_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10724 "MPFR.xs"
  RETVAL = Rmpfr_fac_ui (aTHX_ a, b, round);
#line 13579 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log1p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log1p)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10733 "MPFR.xs"
  RETVAL = Rmpfr_log1p (aTHX_ a, b, round);
#line 13603 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_expm1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_expm1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10742 "MPFR.xs"
  RETVAL = Rmpfr_expm1 (aTHX_ a, b, round);
#line 13627 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_exp2m1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_exp2m1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10751 "MPFR.xs"
  RETVAL = Rmpfr_exp2m1 (aTHX_ a, b, round);
#line 13651 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_exp10m1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_exp10m1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10760 "MPFR.xs"
  RETVAL = Rmpfr_exp10m1 (aTHX_ a, b, round);
#line 13675 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10769 "MPFR.xs"
  RETVAL = Rmpfr_log2 (aTHX_ a, b, round);
#line 13699 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log2p1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log2p1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10778 "MPFR.xs"
  RETVAL = Rmpfr_log2p1 (aTHX_ a, b, round);
#line 13723 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log10); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log10)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10787 "MPFR.xs"
  RETVAL = Rmpfr_log10 (aTHX_ a, b, round);
#line 13747 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log10p1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log10p1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10796 "MPFR.xs"
  RETVAL = Rmpfr_log10p1 (aTHX_ a, b, round);
#line 13771 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fma)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "a, b, c, d, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	mpfr_t *            d = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 10807 "MPFR.xs"
  RETVAL = Rmpfr_fma (aTHX_ a, b, c, d, round);
#line 13799 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fms); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fms)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "a, b, c, d, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	mpfr_t *            d = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 10818 "MPFR.xs"
  RETVAL = Rmpfr_fms (aTHX_ a, b, c, d, round);
#line 13827 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_agm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_agm)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10828 "MPFR.xs"
  RETVAL = Rmpfr_agm (aTHX_ a, b, c, round);
#line 13853 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_hypot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_hypot)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 10838 "MPFR.xs"
  RETVAL = Rmpfr_hypot (aTHX_ a, b, c, round);
#line 13879 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_log2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_log2)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 10846 "MPFR.xs"
  RETVAL = Rmpfr_const_log2 (aTHX_ p, round);
#line 13901 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_pi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_pi)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 10854 "MPFR.xs"
  RETVAL = Rmpfr_const_pi (aTHX_ p, round);
#line 13923 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_euler); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_euler)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 10862 "MPFR.xs"
  RETVAL = Rmpfr_const_euler (aTHX_ p, round);
#line 13945 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10871 "MPFR.xs"
  RETVAL = Rmpfr_rint (aTHX_ a, b, round);
#line 13969 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ceil); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ceil)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_ceil(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_floor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_floor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_floor(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_round)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_round(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_trunc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_trunc)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_trunc(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_can_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_can_round)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "p, err, round1, round2, prec");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	err = ST(1)
;
	SV *	round1 = ST(2)
;
	SV *	round2 = ST(3)
;
	SV *	prec = ST(4)
;
	SV *	RETVAL;
#line 10902 "MPFR.xs"
  RETVAL = Rmpfr_can_round (aTHX_ p, err, round1, round2, prec);
#line 14085 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_print_rnd_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_print_rnd_mode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "rnd");
    {
	SV *	rnd = ST(0)
;
	SV *	RETVAL;
#line 10909 "MPFR.xs"
  RETVAL = Rmpfr_print_rnd_mode (aTHX_ rnd);
#line 14105 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 10915 "MPFR.xs"
  RETVAL = Rmpfr_get_emin (aTHX);
#line 14123 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 10922 "MPFR.xs"
  RETVAL = Rmpfr_get_emax (aTHX);
#line 14141 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "e");
    {
	SV *	e = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 10930 "MPFR.xs"
  RETVAL = Rmpfr_set_emin (aTHX_ e);
#line 14162 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emax); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_emax)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "e");
    {
	SV *	e = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 10937 "MPFR.xs"
  RETVAL = Rmpfr_set_emax (aTHX_ e);
#line 14183 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_check_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_check_range)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, t, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	t = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 10946 "MPFR.xs"
  RETVAL = Rmpfr_check_range (aTHX_ p, t, round);
#line 14207 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_underflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_underflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 10953 "MPFR.xs"
        Rmpfr_clear_underflow();
        XSRETURN_EMPTY; /* return empty stack */
#line 14227 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_overflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_overflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 10960 "MPFR.xs"
        Rmpfr_clear_overflow();
        XSRETURN_EMPTY; /* return empty stack */
#line 14246 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_nanflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_nanflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 10967 "MPFR.xs"
        Rmpfr_clear_nanflag();
        XSRETURN_EMPTY; /* return empty stack */
#line 14265 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_inexflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_inexflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 10974 "MPFR.xs"
        Rmpfr_clear_inexflag();
        XSRETURN_EMPTY; /* return empty stack */
#line 14284 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_flags)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 10981 "MPFR.xs"
        Rmpfr_clear_flags();
        XSRETURN_EMPTY; /* return empty stack */
#line 14303 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_underflow_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_underflow_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_underflow_p();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_overflow_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_overflow_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_overflow_p();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nanflag_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nanflag_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_nanflag_p();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_inexflag_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_inexflag_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_inexflag_p();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11006 "MPFR.xs"
  RETVAL = Rmpfr_log (aTHX_ a, b, round);
#line 14398 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11015 "MPFR.xs"
  RETVAL = Rmpfr_exp (aTHX_ a, b, round);
#line 14422 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_exp2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_exp2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11024 "MPFR.xs"
  RETVAL = Rmpfr_exp2 (aTHX_ a, b, round);
#line 14446 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_exp10); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_exp10)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11033 "MPFR.xs"
  RETVAL = Rmpfr_exp10 (aTHX_ a, b, round);
#line 14470 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_urandomb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_urandomb)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "x, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	x = ST(0)
;
#line 11040 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_urandomb(aTHX_ x);
        XSRETURN_EMPTY; /* return empty stack */
#line 14493 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_random2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_random2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, s, exp");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	s = ST(1)
;
	SV *	exp = ST(2)
;
#line 11050 "MPFR.xs"
        Rmpfr_random2(aTHX_ p, s, exp);
        XSRETURN_EMPTY; /* return empty stack */
#line 14518 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_str)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "stream, base, dig, p, round");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 11061 "MPFR.xs"
  RETVAL = _TRmpfr_out_str (aTHX_ stream, base, dig, p, round);
#line 14545 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, base, dig, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11071 "MPFR.xs"
  RETVAL = _Rmpfr_out_str (aTHX_ p, base, dig, round);
#line 14571 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strS)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "stream, base, dig, p, round, suff");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	SV *	round = ST(4)
;
	SV *	suff = ST(5)
;
	SV *	RETVAL;
#line 11083 "MPFR.xs"
  RETVAL = _TRmpfr_out_strS (aTHX_ stream, base, dig, p, round, suff);
#line 14601 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strP)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "pre, stream, base, dig, p, round");
    {
	SV *	pre = ST(0)
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(4))))
;
	SV *	round = ST(5)
;
	SV *	RETVAL;
#line 11095 "MPFR.xs"
  RETVAL = _TRmpfr_out_strP (aTHX_ pre, stream, base, dig, p, round);
#line 14631 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strPS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__TRmpfr_out_strPS)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "pre, stream, base, dig, p, round, suff");
    {
	SV *	pre = ST(0)
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(4))))
;
	SV *	round = ST(5)
;
	SV *	suff = ST(6)
;
	SV *	RETVAL;
#line 11108 "MPFR.xs"
  RETVAL = _TRmpfr_out_strPS (aTHX_ pre, stream, base, dig, p, round, suff);
#line 14663 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strS)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "p, base, dig, round, suff");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	dig = ST(2)
;
	SV *	round = ST(3)
;
	SV *	suff = ST(4)
;
	SV *	RETVAL;
#line 11119 "MPFR.xs"
  RETVAL = _Rmpfr_out_strS (aTHX_ p, base, dig, round, suff);
#line 14691 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strP)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "pre, p, base, dig, round");
    {
	SV *	pre = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 11130 "MPFR.xs"
  RETVAL = _Rmpfr_out_strP (aTHX_ pre, p, base, dig, round);
#line 14719 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strPS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__Rmpfr_out_strPS)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "pre, p, base, dig, round, suff");
    {
	SV *	pre = ST(0)
;
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	dig = ST(3)
;
	SV *	round = ST(4)
;
	SV *	suff = ST(5)
;
	SV *	RETVAL;
#line 11142 "MPFR.xs"
  RETVAL = _Rmpfr_out_strPS (aTHX_ pre, p, base, dig, round, suff);
#line 14749 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_TRmpfr_inp_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_TRmpfr_inp_str)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "p, stream, base, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11152 "MPFR.xs"
  RETVAL = TRmpfr_inp_str (aTHX_ p, stream, base, round);
#line 14775 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_inp_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_inp_str)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, base, round");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	base = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11161 "MPFR.xs"
  RETVAL = Rmpfr_inp_str (aTHX_ p, base, round);
#line 14799 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_gamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_gamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11170 "MPFR.xs"
  RETVAL = Rmpfr_gamma (aTHX_ a, b, round);
#line 14823 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11179 "MPFR.xs"
  RETVAL = Rmpfr_zeta (aTHX_ a, b, round);
#line 14847 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_zeta_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11188 "MPFR.xs"
  RETVAL = Rmpfr_zeta_ui (aTHX_ a, b, round);
#line 14871 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_erf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_erf)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11197 "MPFR.xs"
  RETVAL = Rmpfr_erf (aTHX_ a, b, round);
#line 14895 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_frac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_frac)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11206 "MPFR.xs"
  RETVAL = Rmpfr_frac (aTHX_ a, b, round);
#line 14919 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_remainder); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_remainder)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11216 "MPFR.xs"
  RETVAL = Rmpfr_remainder (aTHX_ a, b, c, round);
#line 14945 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_modf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_modf)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11226 "MPFR.xs"
  RETVAL = Rmpfr_modf (aTHX_ a, b, c, round);
#line 14971 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fmod)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11236 "MPFR.xs"
  RETVAL = Rmpfr_fmod (aTHX_ a, b, c, round);
#line 14997 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fmod_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fmod_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	c = (unsigned long)SvUV(ST(2))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11246 "MPFR.xs"
  RETVAL = Rmpfr_fmod_ui (aTHX_ a, b, c, round);
#line 15023 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_remquo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_remquo)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
#line 11256 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_remquo(aTHX_ a, b, c, round);
        return;
#line 15052 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_integer_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_integer_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_integer_p(p);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nexttoward); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nexttoward)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
#line 11269 "MPFR.xs"
        Rmpfr_nexttoward(a, b);
        XSRETURN_EMPTY; /* return empty stack */
#line 15095 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nextabove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nextabove)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 11276 "MPFR.xs"
        Rmpfr_nextabove(p);
        XSRETURN_EMPTY; /* return empty stack */
#line 15116 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nextbelow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nextbelow)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 11283 "MPFR.xs"
        Rmpfr_nextbelow(p);
        XSRETURN_EMPTY; /* return empty stack */
#line 15137 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_min)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11293 "MPFR.xs"
  RETVAL = Rmpfr_min (aTHX_ a, b, c, round);
#line 15162 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_max)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11303 "MPFR.xs"
  RETVAL = Rmpfr_max (aTHX_ a, b, c, round);
#line 15188 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_exp)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 11310 "MPFR.xs"
  RETVAL = Rmpfr_get_exp (aTHX_ p);
#line 15208 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_exp)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "p, exp");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	exp = ST(1)
;
	SV *	RETVAL;
#line 11318 "MPFR.xs"
  RETVAL = Rmpfr_set_exp (aTHX_ p, exp);
#line 15230 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_signbit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_signbit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_signbit(op);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_setsign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_setsign)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, sign, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	sign = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11332 "MPFR.xs"
  RETVAL = Rmpfr_setsign (aTHX_ rop, op, sign, round);
#line 15276 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_copysign); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_copysign)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11342 "MPFR.xs"
  RETVAL = Rmpfr_copysign (aTHX_ rop, op1, op2, round);
#line 15302 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_get_refcnt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_get_refcnt)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	SV *	s = ST(0)
;
	SV *	RETVAL;
#line 11349 "MPFR.xs"
  RETVAL = get_refcnt (aTHX_ s);
#line 15322 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_get_package_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_get_package_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	SV *	x = ST(0)
;
	SV *	RETVAL;
#line 11356 "MPFR.xs"
  RETVAL = get_package_name (aTHX_ x);
#line 15342 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_dump)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
#line 11363 "MPFR.xs"
        Rmpfr_dump(a);
        XSRETURN_EMPTY; /* return empty stack */
#line 15364 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_gmp_v); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_gmp_v)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11369 "MPFR.xs"
  RETVAL = gmp_v (aTHX);
#line 15381 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_ui_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11380 "MPFR.xs"
  RETVAL = Rmpfr_set_ui_2exp (aTHX_ a, b, c, round);
#line 15407 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_si_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11390 "MPFR.xs"
  RETVAL = Rmpfr_set_si_2exp (aTHX_ a, b, c, round);
#line 15433 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_uj_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11400 "MPFR.xs"
  RETVAL = Rmpfr_set_uj_2exp (aTHX_ a, b, c, round);
#line 15459 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_sj_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11410 "MPFR.xs"
  RETVAL = Rmpfr_set_sj_2exp (aTHX_ a, b, c, round);
#line 15485 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_z)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpz_t *            a = INT2PTR(mpz_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11419 "MPFR.xs"
  RETVAL = Rmpfr_get_z (aTHX_ a, b, round);
#line 15509 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_si_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_si_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, c, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	c = ST(1)
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11429 "MPFR.xs"
  RETVAL = Rmpfr_si_sub (aTHX_ a, c, b, round);
#line 15535 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sub_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11439 "MPFR.xs"
  RETVAL = Rmpfr_sub_si (aTHX_ a, b, c, round);
#line 15561 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_mul_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11449 "MPFR.xs"
  RETVAL = Rmpfr_mul_si (aTHX_ a, b, c, round);
#line 15587 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_si_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_si_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11459 "MPFR.xs"
  RETVAL = Rmpfr_si_div (aTHX_ a, b, c, round);
#line 15613 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_div_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_div_si)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11469 "MPFR.xs"
  RETVAL = Rmpfr_div_si (aTHX_ a, b, c, round);
#line 15639 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sqr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sqr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11478 "MPFR.xs"
  RETVAL = Rmpfr_sqr (aTHX_ a, b, round);
#line 15663 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_z)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            b = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_z(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_q)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            b = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_q(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_fr_cmp_q_rounded); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_fr_cmp_q_rounded)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            b = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	int	RETVAL;
	dXSTARG;
#line 11497 "MPFR.xs"
  RETVAL = fr_cmp_q_rounded (aTHX_ a, b, round);
#line 15732 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cmp_f)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpf_t *            b = INT2PTR(mpf_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_cmp_f(a, b);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_zero_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_zero_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_zero_p(a);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_free_cache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_free_cache)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11513 "MPFR.xs"
        Rmpfr_free_cache();
        XSRETURN_EMPTY; /* return empty stack */
#line 15794 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_free_cache2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_free_cache2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "way");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	unsigned int	way = (unsigned int)SvUV(ST(0))
;
#line 11520 "MPFR.xs"
        Rmpfr_free_cache2(way);
        XSRETURN_EMPTY; /* return empty stack */
#line 15815 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_free_pool); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_free_pool)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11527 "MPFR.xs"
        Rmpfr_free_pool();
        XSRETURN_EMPTY; /* return empty stack */
#line 15834 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11533 "MPFR.xs"
  RETVAL = Rmpfr_get_version (aTHX);
#line 15851 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_patches); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_patches)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11540 "MPFR.xs"
  RETVAL = Rmpfr_get_patches (aTHX);
#line 15869 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_min)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11547 "MPFR.xs"
  RETVAL = Rmpfr_get_emin_min (aTHX);
#line 15887 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emin_max)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11554 "MPFR.xs"
  RETVAL = Rmpfr_get_emin_max (aTHX);
#line 15905 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_min); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_min)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11561 "MPFR.xs"
  RETVAL = Rmpfr_get_emax_min (aTHX);
#line 15923 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_emax_max)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 11568 "MPFR.xs"
  RETVAL = Rmpfr_get_emax_max (aTHX);
#line 15941 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_erangeflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_erangeflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11576 "MPFR.xs"
        Rmpfr_clear_erangeflag();
        XSRETURN_EMPTY; /* return empty stack */
#line 15961 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_erangeflag_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_erangeflag_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_erangeflag_p();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_round); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_round)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11589 "MPFR.xs"
  RETVAL = Rmpfr_rint_round (aTHX_ a, b, round);
#line 16002 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_trunc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_trunc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11598 "MPFR.xs"
  RETVAL = Rmpfr_rint_trunc (aTHX_ a, b, round);
#line 16026 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_ceil); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_ceil)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11607 "MPFR.xs"
  RETVAL = Rmpfr_rint_ceil (aTHX_ a, b, round);
#line 16050 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_floor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_floor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11616 "MPFR.xs"
  RETVAL = Rmpfr_rint_floor (aTHX_ a, b, round);
#line 16074 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11624 "MPFR.xs"
  RETVAL = Rmpfr_get_ui (aTHX_ a, round);
#line 16096 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_si); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_si)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11632 "MPFR.xs"
  RETVAL = Rmpfr_get_si (aTHX_ a, round);
#line 16118 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_uj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_uj)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11640 "MPFR.xs"
  RETVAL = Rmpfr_get_uj (aTHX_ a, round);
#line 16140 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_sj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_sj)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11648 "MPFR.xs"
  RETVAL = Rmpfr_get_sj (aTHX_ a, round);
#line 16162 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_IV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_IV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11656 "MPFR.xs"
  RETVAL = Rmpfr_get_IV (aTHX_ x, round);
#line 16184 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_IV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_IV)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "x, sv, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	sv = ST(1)
;
	SV *	round = ST(2)
;
	int	RETVAL;
	dXSTARG;
#line 11665 "MPFR.xs"
  RETVAL = Rmpfr_set_IV (aTHX_ x, sv, round);
#line 16209 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_IV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_IV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 11673 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_IV(aTHX_ q, round);
        return;
#line 16234 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_IV_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_IV_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 11682 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_IV_nobless(aTHX_ q, round);
        return;
#line 16258 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_NV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11691 "MPFR.xs"
  RETVAL = Rmpfr_get_NV (aTHX_ x, round);
#line 16279 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ulong_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ulong_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11699 "MPFR.xs"
  RETVAL = Rmpfr_fits_ulong_p (aTHX_ a, round);
#line 16301 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_slong_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_slong_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11707 "MPFR.xs"
  RETVAL = Rmpfr_fits_slong_p (aTHX_ a, round);
#line 16323 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ushort_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_ushort_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11715 "MPFR.xs"
  RETVAL = Rmpfr_fits_ushort_p (aTHX_ a, round);
#line 16345 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sshort_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sshort_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11723 "MPFR.xs"
  RETVAL = Rmpfr_fits_sshort_p (aTHX_ a, round);
#line 16367 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uint_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uint_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11731 "MPFR.xs"
  RETVAL = Rmpfr_fits_uint_p (aTHX_ a, round);
#line 16389 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sint_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_sint_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11739 "MPFR.xs"
  RETVAL = Rmpfr_fits_sint_p (aTHX_ a, round);
#line 16411 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uintmax_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_uintmax_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11747 "MPFR.xs"
  RETVAL = Rmpfr_fits_uintmax_p (aTHX_ a, round);
#line 16433 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_intmax_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_intmax_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11755 "MPFR.xs"
  RETVAL = Rmpfr_fits_intmax_p (aTHX_ a, round);
#line 16455 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_IV_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fits_IV_p)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, round");
    {
	mpfr_t *            x = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11763 "MPFR.xs"
  RETVAL = Rmpfr_fits_IV_p (aTHX_ x, round);
#line 16477 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_strtofr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_strtofr)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, str, base, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	str = ST(1)
;
	SV *	base = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11773 "MPFR.xs"
  RETVAL = Rmpfr_strtofr (aTHX_ a, str, base, round);
#line 16503 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_erangeflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_erangeflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11780 "MPFR.xs"
        Rmpfr_set_erangeflag();
        XSRETURN_EMPTY; /* return empty stack */
#line 16523 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_underflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_underflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11787 "MPFR.xs"
        Rmpfr_set_underflow();
        XSRETURN_EMPTY; /* return empty stack */
#line 16542 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_overflow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_overflow)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11794 "MPFR.xs"
        Rmpfr_set_overflow();
        XSRETURN_EMPTY; /* return empty stack */
#line 16561 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nanflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_nanflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11801 "MPFR.xs"
        Rmpfr_set_nanflag();
        XSRETURN_EMPTY; /* return empty stack */
#line 16580 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inexflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_inexflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 11808 "MPFR.xs"
        Rmpfr_set_inexflag();
        XSRETURN_EMPTY; /* return empty stack */
#line 16599 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_erfc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_erfc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11817 "MPFR.xs"
  RETVAL = Rmpfr_erfc (aTHX_ a, b, round);
#line 16622 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_j0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_j0)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11826 "MPFR.xs"
  RETVAL = Rmpfr_j0 (aTHX_ a, b, round);
#line 16646 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_j1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_j1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11835 "MPFR.xs"
  RETVAL = Rmpfr_j1 (aTHX_ a, b, round);
#line 16670 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_jn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_jn)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, n, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	n = ST(1)
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11845 "MPFR.xs"
  RETVAL = Rmpfr_jn (aTHX_ a, n, b, round);
#line 16696 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_y0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_y0)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11854 "MPFR.xs"
  RETVAL = Rmpfr_y0 (aTHX_ a, b, round);
#line 16720 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_y1); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_y1)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11863 "MPFR.xs"
  RETVAL = Rmpfr_y1 (aTHX_ a, b, round);
#line 16744 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_yn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_yn)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, n, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	n = ST(1)
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11873 "MPFR.xs"
  RETVAL = Rmpfr_yn (aTHX_ a, n, b, round);
#line 16770 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atan2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atan2)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11883 "MPFR.xs"
  RETVAL = Rmpfr_atan2 (aTHX_ a, b, c, round);
#line 16796 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atan2u); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atan2u)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "a, b, c, d, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	unsigned long	d = (unsigned long)SvUV(ST(3))
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 11894 "MPFR.xs"
  RETVAL = Rmpfr_atan2u (aTHX_ a, b, c, d, round);
#line 16824 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_atan2pi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_atan2pi)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11904 "MPFR.xs"
  RETVAL = Rmpfr_atan2pi (aTHX_ a, b, c, round);
#line 16850 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_z); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_pow_z)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpz_t *            c = INT2PTR(mpz_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11914 "MPFR.xs"
  RETVAL = Rmpfr_pow_z (aTHX_ a, b, c, round);
#line 16876 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_subnormalize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_subnormalize)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11923 "MPFR.xs"
  RETVAL = Rmpfr_subnormalize (aTHX_ a, b, round);
#line 16900 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_const_catalan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_const_catalan)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 11931 "MPFR.xs"
  RETVAL = Rmpfr_const_catalan (aTHX_ a, round);
#line 16922 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sec)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11940 "MPFR.xs"
  RETVAL = Rmpfr_sec (aTHX_ a, b, round);
#line 16946 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_csc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_csc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11949 "MPFR.xs"
  RETVAL = Rmpfr_csc (aTHX_ a, b, round);
#line 16970 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_cot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_cot)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11958 "MPFR.xs"
  RETVAL = Rmpfr_cot (aTHX_ a, b, round);
#line 16994 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_root); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_root)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	c = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 11968 "MPFR.xs"
  RETVAL = Rmpfr_root (aTHX_ a, b, c, round);
#line 17020 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_eint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_eint)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11977 "MPFR.xs"
  RETVAL = Rmpfr_eint (aTHX_ a, b, round);
#line 17044 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_li2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_li2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11986 "MPFR.xs"
  RETVAL = Rmpfr_li2 (aTHX_ a, b, round);
#line 17068 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_f); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_f)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpf_t *            a = INT2PTR(mpf_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 11995 "MPFR.xs"
  RETVAL = Rmpfr_get_f (aTHX_ a, b, round);
#line 17092 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sech); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sech)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12004 "MPFR.xs"
  RETVAL = Rmpfr_sech (aTHX_ a, b, round);
#line 17116 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_csch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_csch)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12013 "MPFR.xs"
  RETVAL = Rmpfr_csch (aTHX_ a, b, round);
#line 17140 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_coth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_coth)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12022 "MPFR.xs"
  RETVAL = Rmpfr_coth (aTHX_ a, b, round);
#line 17164 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lngamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lngamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12031 "MPFR.xs"
  RETVAL = Rmpfr_lngamma (aTHX_ a, b, round);
#line 17188 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_lgamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_lgamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
#line 12040 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_lgamma(aTHX_ a, b, round);
        return;
#line 17215 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12047 "MPFR.xs"
  RETVAL = _MPFR_VERSION (aTHX);
#line 17232 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MAJOR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MAJOR)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12054 "MPFR.xs"
  RETVAL = _MPFR_VERSION_MAJOR (aTHX);
#line 17250 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MINOR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_MINOR)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12061 "MPFR.xs"
  RETVAL = _MPFR_VERSION_MINOR (aTHX);
#line 17268 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_PATCHLEVEL); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_PATCHLEVEL)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12068 "MPFR.xs"
  RETVAL = _MPFR_VERSION_PATCHLEVEL (aTHX);
#line 17286 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_STRING); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_VERSION_STRING)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12075 "MPFR.xs"
  RETVAL = _MPFR_VERSION_STRING (aTHX);
#line 17304 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_RMPFR_VERSION_NUM); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_RMPFR_VERSION_NUM)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, c");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	c = ST(2)
;
	SV *	RETVAL;
#line 12085 "MPFR.xs"
  RETVAL = RMPFR_VERSION_NUM (aTHX_ a, b, c);
#line 17328 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_sum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_sum)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, avref, len, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	avref = ST(1)
;
	SV *	len = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 12095 "MPFR.xs"
  RETVAL = Rmpfr_sum (aTHX_ rop, avref, len, round);
#line 17354 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__fr_to_q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__fr_to_q)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, fr");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpq_t *            q = INT2PTR(mpq_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            fr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
#line 12103 "MPFR.xs"
        _fr_to_q(q, fr);
        XSRETURN_EMPTY; /* return empty stack */
#line 17378 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_q_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_q_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, q, fr, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpq_t *            q = INT2PTR(mpq_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            fr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	int	round = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_q_div(rop, q, fr, round);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_z_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_z_div)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, z, fr, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            z = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            fr = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	int	round = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_z_div(rop, z, fr, round);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12126 "MPFR.xs"
  RETVAL = overload_mul (aTHX_ a, b, third);
#line 17453 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12135 "MPFR.xs"
  RETVAL = overload_add (aTHX_ a, b, third);
#line 17477 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12144 "MPFR.xs"
  RETVAL = overload_sub (aTHX_ a, b, third);
#line 17501 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12153 "MPFR.xs"
  RETVAL = overload_div (aTHX_ a, b, third);
#line 17525 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_copy)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12162 "MPFR.xs"
  RETVAL = overload_copy (aTHX_ p, b, third);
#line 17549 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_abs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_abs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12171 "MPFR.xs"
  RETVAL = overload_abs (aTHX_ p, b, third);
#line 17573 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_gt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_gt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12180 "MPFR.xs"
  RETVAL = overload_gt (aTHX_ a, b, third);
#line 17597 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_gte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_gte)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12189 "MPFR.xs"
  RETVAL = overload_gte (aTHX_ a, b, third);
#line 17621 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_lt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_lt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12198 "MPFR.xs"
  RETVAL = overload_lt (aTHX_ a, b, third);
#line 17645 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_lte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_lte)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12207 "MPFR.xs"
  RETVAL = overload_lte (aTHX_ a, b, third);
#line 17669 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_spaceship); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_spaceship)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12216 "MPFR.xs"
  RETVAL = overload_spaceship (aTHX_ a, b, third);
#line 17693 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_equiv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_equiv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12225 "MPFR.xs"
  RETVAL = overload_equiv (aTHX_ a, b, third);
#line 17717 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_not_equiv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_not_equiv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12234 "MPFR.xs"
  RETVAL = overload_not_equiv (aTHX_ a, b, third);
#line 17741 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_true); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_true)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12243 "MPFR.xs"
  RETVAL = overload_true (aTHX_ a, b, third);
#line 17765 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_not); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_not)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12252 "MPFR.xs"
  RETVAL = overload_not (aTHX_ a, b, third);
#line 17789 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12261 "MPFR.xs"
  RETVAL = overload_sqrt (aTHX_ p, b, third);
#line 17813 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_pow)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	SV *	p = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12270 "MPFR.xs"
  RETVAL = overload_pow (aTHX_ p, b, third);
#line 17837 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_log)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12279 "MPFR.xs"
  RETVAL = overload_log (aTHX_ p, b, third);
#line 17861 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_log_2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_log_2)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 12286 "MPFR.xs"
  RETVAL = log_2 (aTHX_ p);
#line 17881 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_log_10); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_log_10)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 12293 "MPFR.xs"
  RETVAL = log_10 (aTHX_ p);
#line 17901 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12302 "MPFR.xs"
  RETVAL = overload_exp (aTHX_ p, b, third);
#line 17925 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12311 "MPFR.xs"
  RETVAL = overload_sin (aTHX_ p, b, third);
#line 17949 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_sind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_sind)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 12318 "MPFR.xs"
  RETVAL = sind (aTHX_ p);
#line 17969 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_cos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12327 "MPFR.xs"
  RETVAL = overload_cos (aTHX_ p, b, third);
#line 17993 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_cosd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_cosd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 12334 "MPFR.xs"
  RETVAL = cosd (aTHX_ p);
#line 18013 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_tangent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_tangent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 12341 "MPFR.xs"
  RETVAL = tangent (aTHX_ p);
#line 18033 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_tand); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_tand)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 12348 "MPFR.xs"
  RETVAL = tand (aTHX_ p);
#line 18053 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_int)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	mpfr_t *            p = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12357 "MPFR.xs"
  RETVAL = overload_int (aTHX_ p, b, third);
#line 18077 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_atan2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_atan2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12366 "MPFR.xs"
  RETVAL = overload_atan2 (aTHX_ a, b, third);
#line 18101 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_default_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_default_nobless)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12372 "MPFR.xs"
  RETVAL = Rmpfr_randinit_default_nobless (aTHX);
#line 18119 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_mt_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_mt_nobless)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12379 "MPFR.xs"
  RETVAL = Rmpfr_randinit_mt_nobless (aTHX);
#line 18137 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_nobless)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, c, m2exp");
    {
	SV *	a = ST(0)
;
	SV *	c = ST(1)
;
	SV *	m2exp = ST(2)
;
	SV *	RETVAL;
#line 12389 "MPFR.xs"
  RETVAL = Rmpfr_randinit_lc_2exp_nobless (aTHX_ a, c, m2exp);
#line 18161 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_size_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randinit_lc_2exp_size_nobless)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "size");
    {
	SV *	size = ST(0)
;
	SV *	RETVAL;
#line 12396 "MPFR.xs"
  RETVAL = Rmpfr_randinit_lc_2exp_size_nobless (aTHX_ size);
#line 18181 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randclear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randclear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	p = ST(0)
;
#line 12403 "MPFR.xs"
        Rmpfr_randclear(aTHX_ p);
        XSRETURN_EMPTY; /* return empty stack */
#line 18203 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, seed");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	state = ST(0)
;
	SV *	seed = ST(1)
;
#line 12411 "MPFR.xs"
        Rmpfr_randseed(aTHX_ state, seed);
        XSRETURN_EMPTY; /* return empty stack */
#line 18226 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_randseed_ui)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "state, seed");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	state = ST(0)
;
	SV *	seed = ST(1)
;
#line 12419 "MPFR.xs"
        Rmpfr_randseed_ui(aTHX_ state, seed);
        XSRETURN_EMPTY; /* return empty stack */
#line 18249 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_overload_pow_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_pow_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "p, b, third");
    {
	SV *	p = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12428 "MPFR.xs"
  RETVAL = overload_pow_eq (aTHX_ p, b, third);
#line 18272 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_div_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_div_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12437 "MPFR.xs"
  RETVAL = overload_div_eq (aTHX_ a, b, third);
#line 18296 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_sub_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_sub_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12446 "MPFR.xs"
  RETVAL = overload_sub_eq (aTHX_ a, b, third);
#line 18320 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_add_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_add_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12455 "MPFR.xs"
  RETVAL = overload_add_eq (aTHX_ a, b, third);
#line 18344 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_mul_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_mul_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12464 "MPFR.xs"
  RETVAL = overload_mul_eq (aTHX_ a, b, third);
#line 18368 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__itsa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__itsa)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	SV *	a = ST(0)
;
	SV *	RETVAL;
#line 12471 "MPFR.xs"
  RETVAL = _itsa (aTHX_ a);
#line 18388 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__has_longlong); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__has_longlong)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_longlong();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__has_longdouble); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__has_longdouble)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_longdouble();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__ivsize_bits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ivsize_bits)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _ivsize_bits();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MAX); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MAX)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12492 "MPFR.xs"
  RETVAL = RMPFR_PREC_MAX (aTHX);
#line 18460 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MIN); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_RMPFR_PREC_MIN)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12499 "MPFR.xs"
  RETVAL = RMPFR_PREC_MIN (aTHX);
#line 18478 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	RETVAL;
#line 12511 "MPFR.xs"
  RETVAL = wrap_mpfr_printf (aTHX_ a, b);
#line 18500 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "stream, a, b");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	a = ST(1)
;
	SV *	b = ST(2)
;
	SV *	RETVAL;
#line 12520 "MPFR.xs"
  RETVAL = wrap_mpfr_fprintf (aTHX_ stream, a, b);
#line 18524 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "s, a, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	a = ST(1)
;
	SV *	b = ST(2)
;
	int	buflen = (int)SvIV(ST(3))
;
	SV *	RETVAL;
#line 12530 "MPFR.xs"
  RETVAL = wrap_mpfr_sprintf (aTHX_ s, a, b, buflen);
#line 18550 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "s, bytes, a, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	bytes = ST(1)
;
	SV *	a = ST(2)
;
	SV *	b = ST(3)
;
	int	buflen = (int)SvIV(ST(4))
;
	SV *	RETVAL;
#line 12541 "MPFR.xs"
  RETVAL = wrap_mpfr_snprintf (aTHX_ s, bytes, a, b, buflen);
#line 18578 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_printf_rnd)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, round, b");
    {
	SV *	a = ST(0)
;
	SV *	round = ST(1)
;
	SV *	b = ST(2)
;
	SV *	RETVAL;
#line 12550 "MPFR.xs"
  RETVAL = wrap_mpfr_printf_rnd (aTHX_ a, round, b);
#line 18602 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_fprintf_rnd)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "stream, a, round, b");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	a = ST(1)
;
	SV *	round = ST(2)
;
	SV *	b = ST(3)
;
	SV *	RETVAL;
#line 12560 "MPFR.xs"
  RETVAL = wrap_mpfr_fprintf_rnd (aTHX_ stream, a, round, b);
#line 18628 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_sprintf_rnd)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "s, a, round, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	a = ST(1)
;
	SV *	round = ST(2)
;
	SV *	b = ST(3)
;
	int	buflen = (int)SvIV(ST(4))
;
	SV *	RETVAL;
#line 12571 "MPFR.xs"
  RETVAL = wrap_mpfr_sprintf_rnd (aTHX_ s, a, round, b, buflen);
#line 18656 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf_rnd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_wrap_mpfr_snprintf_rnd)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "s, bytes, a, round, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	bytes = ST(1)
;
	SV *	a = ST(2)
;
	SV *	round = ST(3)
;
	SV *	b = ST(4)
;
	int	buflen = (int)SvIV(ST(5))
;
	SV *	RETVAL;
#line 12583 "MPFR.xs"
  RETVAL = wrap_mpfr_snprintf_rnd (aTHX_ s, bytes, a, round, b, buflen);
#line 18686 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tls_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tls_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12589 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_tls_p (aTHX);
#line 18704 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_float16_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_float16_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12596 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_float16_p (aTHX);
#line 18722 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_decimal_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_decimal_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12603 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_decimal_p (aTHX);
#line 18740 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_regular_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_regular_p)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 12611 "MPFR.xs"
  RETVAL = Rmpfr_regular_p (aTHX_ a);
#line 18760 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_zero); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_zero)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, sign");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	sign = ST(1)
;
#line 12619 "MPFR.xs"
        Rmpfr_set_zero(aTHX_ a, sign);
        XSRETURN_EMPTY; /* return empty stack */
#line 18784 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_digamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_digamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12628 "MPFR.xs"
  RETVAL = Rmpfr_digamma (aTHX_ rop, op, round);
#line 18807 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_trigamma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_trigamma)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12637 "MPFR.xs"
  RETVAL = Rmpfr_trigamma (aTHX_ rop, op, round);
#line 18831 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_ai); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_ai)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12646 "MPFR.xs"
  RETVAL = Rmpfr_ai (aTHX_ rop, op, round);
#line 18855 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_flt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_flt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 12654 "MPFR.xs"
  RETVAL = Rmpfr_get_flt (aTHX_ a, round);
#line 18877 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_float16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_float16)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, round");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	round = ST(1)
;
	SV *	RETVAL;
#line 12662 "MPFR.xs"
  RETVAL = Rmpfr_get_float16 (aTHX_ a, round);
#line 18899 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_flt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_flt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, f, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	f = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12671 "MPFR.xs"
  RETVAL = Rmpfr_set_flt (aTHX_ rop, f, round);
#line 18923 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_float16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_float16)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, f, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	f = ST(1)
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12680 "MPFR.xs"
  RETVAL = Rmpfr_set_float16 (aTHX_ rop, f, round);
#line 18947 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_urandom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_urandom)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, state, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	gmp_randstate_t *            state = INT2PTR(gmp_randstate_t *, SvIVX(SvRV(ST(1))))
;
	SV *	round = ST(2)
;
	SV *	RETVAL;
#line 12689 "MPFR.xs"
  RETVAL = Rmpfr_urandom (aTHX_ rop, state, round);
#line 18971 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z_2exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_z_2exp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, exp, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            op = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	SV *	exp = ST(2)
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 12699 "MPFR.xs"
  RETVAL = Rmpfr_set_z_2exp (aTHX_ rop, op, exp, round);
#line 18997 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tune_case); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_tune_case)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12705 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_tune_case (aTHX);
#line 19015 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_frexp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_frexp)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "exp, rop, op, round");
    {
	SV *	exp = ST(0)
;
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 12716 "MPFR.xs"
  RETVAL = Rmpfr_frexp (aTHX_ exp, rop, op, round);
#line 19041 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_z_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_z_sub)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpz_t *            op1 = INT2PTR(mpz_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 12726 "MPFR.xs"
  RETVAL = Rmpfr_z_sub (aTHX_ rop, op1, op2, round);
#line 19067 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_grandom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_grandom)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop1, rop2, state, round");
    {
	mpfr_t *            rop1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            rop2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	gmp_randstate_t *            state = INT2PTR(gmp_randstate_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
	SV *	RETVAL;
#line 12736 "MPFR.xs"
  RETVAL = Rmpfr_grandom (aTHX_ rop1, rop2, state, round);
#line 19093 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_divby0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_clear_divby0)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 12743 "MPFR.xs"
        Rmpfr_clear_divby0(aTHX);
        XSRETURN_EMPTY; /* return empty stack */
#line 19113 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_divby0); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_divby0)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 12750 "MPFR.xs"
        Rmpfr_set_divby0(aTHX);
        XSRETURN_EMPTY; /* return empty stack */
#line 19132 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_divby0_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_divby0_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12756 "MPFR.xs"
  RETVAL = Rmpfr_divby0_p (aTHX);
#line 19149 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_gmpinternals_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_gmpinternals_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12763 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_gmpinternals_p (aTHX);
#line 19167 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__get_xs_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__get_xs_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12770 "MPFR.xs"
  RETVAL = _get_xs_version (aTHX);
#line 19185 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_overload_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_inc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
#line 12780 "MPFR.xs"
        overload_inc(aTHX_ a, b, third);
        XSRETURN_EMPTY; /* return empty stack */
#line 19211 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_overload_dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_overload_dec)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
#line 12789 "MPFR.xs"
        overload_dec(aTHX_ a, b, third);
        XSRETURN_EMPTY; /* return empty stack */
#line 19236 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__overload_lshift); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__overload_lshift)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12798 "MPFR.xs"
  RETVAL = _overload_lshift (aTHX_ a, b, third);
#line 19259 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__overload_rshift); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__overload_rshift)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12807 "MPFR.xs"
  RETVAL = _overload_rshift (aTHX_ a, b, third);
#line 19283 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__overload_lshift_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__overload_lshift_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12816 "MPFR.xs"
  RETVAL = _overload_lshift_eq (aTHX_ a, b, third);
#line 19307 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__overload_rshift_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__overload_rshift_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 12825 "MPFR.xs"
  RETVAL = _overload_rshift_eq (aTHX_ a, b, third);
#line 19331 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__wrap_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__wrap_count)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12831 "MPFR.xs"
  RETVAL = _wrap_count (aTHX);
#line 19349 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_LD); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_LD)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 12841 "MPFR.xs"
  RETVAL = Rmpfr_set_LD (aTHX_ rop, op, rnd);
#line 19373 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_DECIMAL64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_DECIMAL64)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 12850 "MPFR.xs"
  RETVAL = Rmpfr_set_DECIMAL64 (aTHX_ rop, op, rnd);
#line 19397 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_DECIMAL128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_DECIMAL128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 12859 "MPFR.xs"
  RETVAL = Rmpfr_set_DECIMAL128 (aTHX_ rop, op, rnd);
#line 19421 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_LD); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_LD)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	rop = ST(0)
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	rnd = ST(2)
;
#line 12868 "MPFR.xs"
        Rmpfr_get_LD(aTHX_ rop, op, rnd);
        XSRETURN_EMPTY; /* return empty stack */
#line 19447 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_DECIMAL64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_DECIMAL64)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	rop = ST(0)
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	rnd = ST(2)
;
#line 12877 "MPFR.xs"
        Rmpfr_get_DECIMAL64(aTHX_ rop, op, rnd);
        XSRETURN_EMPTY; /* return empty stack */
#line 19472 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_DECIMAL128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_DECIMAL128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	rop = ST(0)
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	rnd = ST(2)
;
#line 12886 "MPFR.xs"
        Rmpfr_get_DECIMAL128(aTHX_ rop, op, rnd);
        XSRETURN_EMPTY; /* return empty stack */
#line 19497 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL_FLOATS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL_FLOATS)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _MPFR_WANT_DECIMAL_FLOATS();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL64)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _MPFR_WANT_DECIMAL64();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_WANT_DECIMAL128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _MPFR_WANT_DECIMAL128();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__MPFR_WANT_FLOAT128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__MPFR_WANT_FLOAT128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _MPFR_WANT_FLOAT128();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__max_base); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__max_base)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12908 "MPFR.xs"
  RETVAL = _max_base (aTHX);
#line 19586 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__isobject); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__isobject)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	SV *	x = ST(0)
;
	SV *	RETVAL;
#line 12916 "MPFR.xs"
  RETVAL = _isobject (aTHX_ x);
#line 19606 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__mp_sizes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__mp_sizes)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 12923 "MPFR.xs"
        PL_markstack_ptr++;
        _mp_sizes();
        return;
#line 19627 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__ivsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ivsize)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12930 "MPFR.xs"
  RETVAL = _ivsize (aTHX);
#line 19644 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__nvsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__nvsize)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12937 "MPFR.xs"
  RETVAL = _nvsize (aTHX);
#line 19662 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__FLT128_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__FLT128_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12944 "MPFR.xs"
  RETVAL = _FLT128_DIG (aTHX);
#line 19680 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__LDBL_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__LDBL_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12951 "MPFR.xs"
  RETVAL = _LDBL_DIG (aTHX);
#line 19698 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__DBL_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__DBL_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12958 "MPFR.xs"
  RETVAL = _DBL_DIG (aTHX);
#line 19716 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__FLT128_MANT_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__FLT128_MANT_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12965 "MPFR.xs"
  RETVAL = _FLT128_MANT_DIG (aTHX);
#line 19734 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__LDBL_MANT_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__LDBL_MANT_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12972 "MPFR.xs"
  RETVAL = _LDBL_MANT_DIG (aTHX);
#line 19752 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__DBL_MANT_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__DBL_MANT_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 12979 "MPFR.xs"
  RETVAL = _DBL_MANT_DIG (aTHX);
#line 19770 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_float128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "op, rnd");
    {
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	rnd = ST(1)
;
	SV *	RETVAL;
#line 12988 "MPFR.xs"
  RETVAL = Rmpfr_get_float128 (aTHX_ op, rnd);
#line 19792 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_FLOAT128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_FLOAT128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	rop = ST(0)
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	rnd = ST(2)
;
#line 12997 "MPFR.xs"
        Rmpfr_get_FLOAT128(aTHX_ rop, op, rnd);
        XSRETURN_EMPTY; /* return empty stack */
#line 19818 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_FLOAT128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_FLOAT128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 13006 "MPFR.xs"
  RETVAL = Rmpfr_set_FLOAT128 (aTHX_ rop, op, rnd);
#line 19841 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_set_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_set_float128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, q, rnd");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	q = ST(1)
;
	SV *	rnd = ST(2)
;
	SV *	RETVAL;
#line 13015 "MPFR.xs"
  RETVAL = Rmpfr_set_float128 (aTHX_ rop, q, rnd);
#line 19865 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_float128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 13023 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_float128(aTHX_ q, round);
        return;
#line 19890 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_float128_nobless); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_init_set_float128_nobless)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "q, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	q = ST(0)
;
	SV *	round = ST(1)
;
#line 13032 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_init_set_float128_nobless(aTHX_ q, round);
        return;
#line 19914 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__is_readonly); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__is_readonly)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	SV *	RETVAL;
#line 13040 "MPFR.xs"
  RETVAL = _is_readonly (aTHX_ sv);
#line 19933 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__readonly_on); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__readonly_on)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0)
;
#line 13047 "MPFR.xs"
        _readonly_on(aTHX_ sv);
        XSRETURN_EMPTY; /* return empty stack */
#line 19955 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__readonly_off); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__readonly_off)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0)
;
#line 13054 "MPFR.xs"
        _readonly_off(aTHX_ sv);
        XSRETURN_EMPTY; /* return empty stack */
#line 19976 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__can_pass_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__can_pass_float128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _can_pass_float128();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__mpfr_want_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__mpfr_want_float128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _mpfr_want_float128();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_nnumflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_nnumflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = nnumflag();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_nok_pokflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_nok_pokflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = nok_pokflag();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_clear_nnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_clear_nnum)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 13077 "MPFR.xs"
        clear_nnum();
        XSRETURN_EMPTY; /* return empty stack */
#line 20067 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_clear_nok_pok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_clear_nok_pok)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 13084 "MPFR.xs"
        clear_nok_pok();
        XSRETURN_EMPTY; /* return empty stack */
#line 20086 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_set_nnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_set_nnum)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	x = (int)SvIV(ST(0))
;
#line 13091 "MPFR.xs"
        set_nnum(x);
        XSRETURN_EMPTY; /* return empty stack */
#line 20107 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_set_nok_pok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_set_nok_pok)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	x = (int)SvIV(ST(0))
;
#line 13098 "MPFR.xs"
        set_nok_pok(x);
        XSRETURN_EMPTY; /* return empty stack */
#line 20128 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR__d_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__d_bytes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	SV *	str = ST(0)
;
	SV *	RETVAL;
#line 13105 "MPFR.xs"
  RETVAL = _d_bytes (aTHX_ str);
#line 20147 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__bytes_fr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__bytes_fr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "str, bits");
    {
	mpfr_t *            str = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	unsigned long	bits = (unsigned long)SvUV(ST(1))
;
	SV *	RETVAL;
#line 13113 "MPFR.xs"
  RETVAL = _bytes_fr (aTHX_ str, bits);
#line 20169 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__dd_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__dd_bytes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	SV *	str = ST(0)
;
	SV *	RETVAL;
#line 13120 "MPFR.xs"
  RETVAL = _dd_bytes (aTHX_ str);
#line 20189 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__ld_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ld_bytes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	SV *	str = ST(0)
;
	SV *	RETVAL;
#line 13127 "MPFR.xs"
  RETVAL = _ld_bytes (aTHX_ str);
#line 20209 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__f128_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__f128_bytes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	SV *	str = ST(0)
;
	SV *	RETVAL;
#line 13134 "MPFR.xs"
  RETVAL = _f128_bytes (aTHX_ str);
#line 20229 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__required_ldbl_mant_dig); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__required_ldbl_mant_dig)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _required_ldbl_mant_dig();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__GMP_LIMB_BITS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__GMP_LIMB_BITS)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 13144 "MPFR.xs"
  RETVAL = _GMP_LIMB_BITS (aTHX);
#line 20265 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__GMP_NAIL_BITS); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__GMP_NAIL_BITS)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 13151 "MPFR.xs"
  RETVAL = _GMP_NAIL_BITS (aTHX);
#line 20283 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fmodquo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fmodquo)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "a, b, c, round");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            c = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	SV *	round = ST(3)
;
#line 13162 "MPFR.xs"
        PL_markstack_ptr++;
        Rmpfr_fmodquo(aTHX_ a, b, c, round);
        return;
#line 20312 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fpif_export); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fpif_export)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "stream, op");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;
#line 13171 "MPFR.xs"
  RETVAL = Rmpfr_fpif_export (aTHX_ stream, op);
#line 20334 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fpif_import); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fpif_import)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "op, stream");
    {
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	int	RETVAL;
	dXSTARG;
#line 13179 "MPFR.xs"
  RETVAL = Rmpfr_fpif_import (aTHX_ op, stream);
#line 20357 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "mask");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	unsigned int	mask = (unsigned int)SvUV(ST(0))
;
#line 13186 "MPFR.xs"
        Rmpfr_flags_clear(mask);
        XSRETURN_EMPTY; /* return empty stack */
#line 20379 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_set)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "mask");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	unsigned int	mask = (unsigned int)SvUV(ST(0))
;
#line 13193 "MPFR.xs"
        Rmpfr_flags_set(mask);
        XSRETURN_EMPTY; /* return empty stack */
#line 20400 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_test); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_test)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "mask");
    {
	unsigned int	mask = (unsigned int)SvUV(ST(0))
;
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_flags_test(mask);
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_save)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	unsigned int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_flags_save();
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_restore); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_flags_restore)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "flags, mask");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	unsigned int	flags = (unsigned int)SvUV(ST(0))
;
	unsigned int	mask = (unsigned int)SvUV(ST(1))
;
#line 13209 "MPFR.xs"
        Rmpfr_flags_restore(flags, mask);
        XSRETURN_EMPTY; /* return empty stack */
#line 20461 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_roundeven); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rint_roundeven)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	round = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_rint_roundeven(rop, op, round);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_roundeven); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_roundeven)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_roundeven(rop, op);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_nrandom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_nrandom)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, state, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	gmp_randstate_t *            state = INT2PTR(gmp_randstate_t *, SvIVX(SvRV(ST(1))))
;
	int	round = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_nrandom(rop, state, round);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_erandom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_erandom)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, state, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	gmp_randstate_t *            state = INT2PTR(gmp_randstate_t *, SvIVX(SvRV(ST(1))))
;
	int	round = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_erandom(rop, state, round);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fmma); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fmma)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "rop, op1, op2, op3, op4, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	mpfr_t *            op3 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	mpfr_t *            op4 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(4))))
;
	int	round = (int)SvIV(ST(5))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_fmma(rop, op1, op2, op3, op4, round);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_fmms); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_fmms)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "rop, op1, op2, op3, op4, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	mpfr_t *            op3 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(3))))
;
	mpfr_t *            op4 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(4))))
;
	int	round = (int)SvIV(ST(5))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_fmms(rop, op1, op2, op3, op4, round);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_log_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_log_ui)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	unsigned long	op = (unsigned long)SvUV(ST(1))
;
	int	round = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_log_ui(rop, op, round);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_gamma_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_gamma_inc)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	int	round = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_gamma_inc(rop, op1, op2, round);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__have_IEEE_754_long_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__have_IEEE_754_long_double)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _have_IEEE_754_long_double();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__have_extended_precision_long_double); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__have_extended_precision_long_double)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _have_extended_precision_long_double();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_nanflag_bug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_nanflag_bug)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = nanflag_bug();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_float128_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_float128_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 13281 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_float128_p (aTHX);
#line 20736 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_sharedcache_p); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_buildopt_sharedcache_p)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 13288 "MPFR.xs"
  RETVAL = Rmpfr_buildopt_sharedcache_p (aTHX);
#line 20754 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__nv_is_float128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__nv_is_float128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _nv_is_float128();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__SvNOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__SvNOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 13300 "MPFR.xs"
  RETVAL = _SvNOK (aTHX_ in);
#line 20793 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__SvPOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__SvPOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 13307 "MPFR.xs"
  RETVAL = _SvPOK (aTHX_ in);
#line 20814 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__lsb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__lsb)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 13314 "MPFR.xs"
  RETVAL = _lsb (aTHX_ a);
#line 20834 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rec_root); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rec_root)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, root, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	root = (unsigned long)SvUV(ST(2))
;
	SV *	round = ST(3)
;
	int	RETVAL;
	dXSTARG;
#line 13324 "MPFR.xs"
  RETVAL = Rmpfr_rec_root (aTHX_ rop, op, root, round);
#line 20861 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_beta); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_beta)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op1 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	mpfr_t *            op2 = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(2))))
;
	int	round = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_beta(rop, op1, op2, round);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_rootn_ui); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_rootn_ui)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op, k, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            op = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	unsigned long	k = (unsigned long)SvUV(ST(2))
;
	int	round = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = Rmpfr_rootn_ui(rop, op, k, round);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__ld_subnormal_bug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__ld_subnormal_bug)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _ld_subnormal_bug();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_atodouble); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_atodouble)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	char *	str = (char *)SvPV_nolen(ST(0))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = atodouble(str);
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_atonv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_atonv)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	SV *	str = ST(0)
;
	SV *	RETVAL;
#line 13353 "MPFR.xs"
  RETVAL = atonv (aTHX_ str);
#line 20971 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_str_ndigits_alt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_str_ndigits_alt)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "base, prec");
    {
	int	base = (int)SvIV(ST(0))
;
	UV	prec = (UV)SvUV(ST(1))
;
	SV *	RETVAL;
#line 13361 "MPFR.xs"
  RETVAL = Rmpfr_get_str_ndigits_alt (aTHX_ base, prec);
#line 20993 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_get_str_ndigits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_get_str_ndigits)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "base, prec");
    {
	int	base = (int)SvIV(ST(0))
;
	SV *	prec = ST(1)
;
	SV *	RETVAL;
#line 13369 "MPFR.xs"
  RETVAL = Rmpfr_get_str_ndigits (aTHX_ base, prec);
#line 21015 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_Rmpfr_dot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_Rmpfr_dot)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "rop, avref_A, avref_B, len, round");
    {
	mpfr_t *            rop = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	SV *	avref_A = ST(1)
;
	SV *	avref_B = ST(2)
;
	SV *	len = ST(3)
;
	SV *	round = ST(4)
;
	SV *	RETVAL;
#line 13380 "MPFR.xs"
  RETVAL = Rmpfr_dot (aTHX_ rop, avref_A, avref_B, len, round);
#line 21043 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__nvtoa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__nvtoa)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pnv");
    {
	NV	pnv = (NV)SvNV(ST(0))
;
	SV *	RETVAL;
#line 13387 "MPFR.xs"
  RETVAL = _nvtoa (aTHX_ pnv);
#line 21063 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__mpfrtoa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__mpfrtoa)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pnv, min_normal_prec");
    {
	mpfr_t *            pnv = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	int	min_normal_prec = (int)SvIV(ST(1))
;
	SV *	RETVAL;
#line 13395 "MPFR.xs"
  RETVAL = _mpfrtoa (aTHX_ pnv, min_normal_prec);
#line 21085 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_set_fallback_flag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_set_fallback_flag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 13402 "MPFR.xs"
        PL_markstack_ptr++;
        set_fallback_flag(aTHX);
        XSRETURN_EMPTY; /* return empty stack */
#line 21106 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_doubletoa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_doubletoa)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "sv, ...");
    {
	SV *	sv = ST(0)
;
	SV *	RETVAL;
#line 13410 "MPFR.xs"
          PL_markstack_ptr++;
          RETVAL = doubletoa(aTHX_ sv);
#line 21126 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__fallback_notify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__fallback_notify)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _fallback_notify();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__numtoa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__numtoa)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	SV *	RETVAL;
#line 13422 "MPFR.xs"
  RETVAL = _numtoa (aTHX_ in);
#line 21164 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_decimalize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_decimalize)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "a, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	a = ST(0)
;
#line 13429 "MPFR.xs"
        PL_markstack_ptr++;
        decimalize(aTHX_ a);
        return;
#line 21187 "MPFR.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__MPFR_IOK_flag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_IOK_flag)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = IOK_flag(sv);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_POK_flag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_POK_flag)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = POK_flag(sv);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR_NOK_flag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR_NOK_flag)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
	int	RETVAL;
	dXSTARG;

	RETVAL = NOK_flag(sv);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__sis_perl_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__sis_perl_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _sis_perl_version();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__has_pv_nv_bug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__has_pv_nv_bug)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_pv_nv_bug();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__sizeof_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__sizeof_exp)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _sizeof_exp();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__sizeof_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__sizeof_prec)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _sizeof_prec();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__has_bizarre_infnan); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__has_bizarre_infnan)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _has_bizarre_infnan();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__gmp_cflags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__gmp_cflags)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 13468 "MPFR.xs"
  RETVAL = _gmp_cflags (aTHX);
#line 21354 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__gmp_cc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__gmp_cc)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 13475 "MPFR.xs"
  RETVAL = _gmp_cc (aTHX);
#line 21372 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__have_float16); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__have_float16)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _have_float16();
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__gmp_printf_nv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__gmp_printf_nv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "a, b");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	RETVAL;
#line 13488 "MPFR.xs"
  RETVAL = _gmp_printf_nv (aTHX_ a, b);
#line 21412 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__gmp_fprintf_nv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__gmp_fprintf_nv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "stream, a, b");
    {
	FILE *	stream = PerlIO_findFILE(IoIFP(sv_2io(ST(0))))
;
	SV *	a = ST(1)
;
	SV *	b = ST(2)
;
	SV *	RETVAL;
#line 13497 "MPFR.xs"
  RETVAL = _gmp_fprintf_nv (aTHX_ stream, a, b);
#line 21436 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__gmp_sprintf_nv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__gmp_sprintf_nv)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "s, a, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	a = ST(1)
;
	SV *	b = ST(2)
;
	int	buflen = (int)SvIV(ST(3))
;
	SV *	RETVAL;
#line 13507 "MPFR.xs"
  RETVAL = _gmp_sprintf_nv (aTHX_ s, a, b, buflen);
#line 21462 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__gmp_snprintf_nv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__gmp_snprintf_nv)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "s, bytes, a, b, buflen");
    {
	SV *	s = ST(0)
;
	SV *	bytes = ST(1)
;
	SV *	a = ST(2)
;
	SV *	b = ST(3)
;
	int	buflen = (int)SvIV(ST(4))
;
	SV *	RETVAL;
#line 13518 "MPFR.xs"
  RETVAL = _gmp_snprintf_nv (aTHX_ s, bytes, a, b, buflen);
#line 21490 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__looks_like_number); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__looks_like_number)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 13525 "MPFR.xs"
  RETVAL = _looks_like_number (aTHX_ in);
#line 21511 "MPFR.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__overload_fmod); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__overload_fmod)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	mpfr_t *            a = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(0))))
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 13534 "MPFR.xs"
  RETVAL = _overload_fmod (aTHX_ a, b, third);
#line 21535 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__MPFR__overload_fmod_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__MPFR__overload_fmod_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	mpfr_t *            b = INT2PTR(mpfr_t *, SvIVX(SvRV(ST(1))))
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 13543 "MPFR.xs"
  RETVAL = _overload_fmod_eq (aTHX_ a, b, third);
#line 21559 "MPFR.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Math__MPFR); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__MPFR)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Math::MPFR::_has_inttypes", XS_Math__MPFR__has_inttypes);
        newXS_deffile("Math::MPFR::NNW_val", XS_Math__MPFR_NNW_val);
        newXS_deffile("Math::MPFR::NOK_POK_val", XS_Math__MPFR_NOK_POK_val);
        newXS_deffile("Math::MPFR::_win32_infnanstring", XS_Math__MPFR__win32_infnanstring);
        newXS_deffile("Math::MPFR::_fmt_flt", XS_Math__MPFR__fmt_flt);
        newXS_deffile("Math::MPFR::Rmpfr_set_default_rounding_mode", XS_Math__MPFR_Rmpfr_set_default_rounding_mode);
        newXS_deffile("Math::MPFR::Rmpfr_get_default_rounding_mode", XS_Math__MPFR_Rmpfr_get_default_rounding_mode);
        newXS_deffile("Math::MPFR::Rmpfr_prec_round", XS_Math__MPFR_Rmpfr_prec_round);
        newXS_deffile("Math::MPFR::DESTROY", XS_Math__MPFR_DESTROY);
        newXS_deffile("Math::MPFR::Rmpfr_clear", XS_Math__MPFR_Rmpfr_clear);
        newXS_deffile("Math::MPFR::Rmpfr_clear_mpfr", XS_Math__MPFR_Rmpfr_clear_mpfr);
        newXS_deffile("Math::MPFR::Rmpfr_clear_ptr", XS_Math__MPFR_Rmpfr_clear_ptr);
        newXS_deffile("Math::MPFR::Rmpfr_clears", XS_Math__MPFR_Rmpfr_clears);
        newXS_deffile("Math::MPFR::Rmpfr_init", XS_Math__MPFR_Rmpfr_init);
        newXS_deffile("Math::MPFR::Rmpfr_init2", XS_Math__MPFR_Rmpfr_init2);
        newXS_deffile("Math::MPFR::Rmpfr_init_nobless", XS_Math__MPFR_Rmpfr_init_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init2_nobless", XS_Math__MPFR_Rmpfr_init2_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set", XS_Math__MPFR_Rmpfr_init_set);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ui", XS_Math__MPFR_Rmpfr_init_set_ui);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_si", XS_Math__MPFR_Rmpfr_init_set_si);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_d", XS_Math__MPFR_Rmpfr_init_set_d);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ld", XS_Math__MPFR_Rmpfr_init_set_ld);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_f", XS_Math__MPFR_Rmpfr_init_set_f);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_z", XS_Math__MPFR_Rmpfr_init_set_z);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_q", XS_Math__MPFR_Rmpfr_init_set_q);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_str", XS_Math__MPFR_Rmpfr_init_set_str);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_nobless", XS_Math__MPFR_Rmpfr_init_set_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ui_nobless", XS_Math__MPFR_Rmpfr_init_set_ui_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_si_nobless", XS_Math__MPFR_Rmpfr_init_set_si_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_d_nobless", XS_Math__MPFR_Rmpfr_init_set_d_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_ld_nobless", XS_Math__MPFR_Rmpfr_init_set_ld_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_f_nobless", XS_Math__MPFR_Rmpfr_init_set_f_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_z_nobless", XS_Math__MPFR_Rmpfr_init_set_z_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_q_nobless", XS_Math__MPFR_Rmpfr_init_set_q_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_str_nobless", XS_Math__MPFR_Rmpfr_init_set_str_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_deref2", XS_Math__MPFR_Rmpfr_deref2);
        newXS_deffile("Math::MPFR::Rmpfr_set_default_prec", XS_Math__MPFR_Rmpfr_set_default_prec);
        newXS_deffile("Math::MPFR::Rmpfr_get_default_prec", XS_Math__MPFR_Rmpfr_get_default_prec);
        newXS_deffile("Math::MPFR::Rmpfr_min_prec", XS_Math__MPFR_Rmpfr_min_prec);
        newXS_deffile("Math::MPFR::Rmpfr_set_prec", XS_Math__MPFR_Rmpfr_set_prec);
        newXS_deffile("Math::MPFR::Rmpfr_set_prec_raw", XS_Math__MPFR_Rmpfr_set_prec_raw);
        newXS_deffile("Math::MPFR::Rmpfr_get_prec", XS_Math__MPFR_Rmpfr_get_prec);
        newXS_deffile("Math::MPFR::Rmpfr_set", XS_Math__MPFR_Rmpfr_set);
        newXS_deffile("Math::MPFR::Rmpfr_set_ui", XS_Math__MPFR_Rmpfr_set_ui);
        newXS_deffile("Math::MPFR::Rmpfr_set_si", XS_Math__MPFR_Rmpfr_set_si);
        newXS_deffile("Math::MPFR::Rmpfr_set_uj", XS_Math__MPFR_Rmpfr_set_uj);
        newXS_deffile("Math::MPFR::Rmpfr_set_sj", XS_Math__MPFR_Rmpfr_set_sj);
        newXS_deffile("Math::MPFR::Rmpfr_set_NV", XS_Math__MPFR_Rmpfr_set_NV);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_NV", XS_Math__MPFR_Rmpfr_init_set_NV);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_NV_nobless", XS_Math__MPFR_Rmpfr_init_set_NV_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_float128", XS_Math__MPFR_Rmpfr_cmp_float128);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_NV", XS_Math__MPFR_Rmpfr_cmp_NV);
        newXS_deffile("Math::MPFR::Rmpfr_set_ld", XS_Math__MPFR_Rmpfr_set_ld);
        newXS_deffile("Math::MPFR::Rmpfr_set_d", XS_Math__MPFR_Rmpfr_set_d);
        newXS_deffile("Math::MPFR::Rmpfr_set_z", XS_Math__MPFR_Rmpfr_set_z);
        newXS_deffile("Math::MPFR::Rmpfr_set_q", XS_Math__MPFR_Rmpfr_set_q);
        newXS_deffile("Math::MPFR::Rmpfr_set_f", XS_Math__MPFR_Rmpfr_set_f);
        newXS_deffile("Math::MPFR::Rmpfr_set_str", XS_Math__MPFR_Rmpfr_set_str);
        newXS_deffile("Math::MPFR::Rmpfr_set_inf", XS_Math__MPFR_Rmpfr_set_inf);
        newXS_deffile("Math::MPFR::Rmpfr_set_nan", XS_Math__MPFR_Rmpfr_set_nan);
        newXS_deffile("Math::MPFR::Rmpfr_swap", XS_Math__MPFR_Rmpfr_swap);
        newXS_deffile("Math::MPFR::Rmpfr_get_d", XS_Math__MPFR_Rmpfr_get_d);
        newXS_deffile("Math::MPFR::Rmpfr_get_d_2exp", XS_Math__MPFR_Rmpfr_get_d_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_get_ld_2exp", XS_Math__MPFR_Rmpfr_get_ld_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_get_ld", XS_Math__MPFR_Rmpfr_get_ld);
        newXS_deffile("Math::MPFR::Rmpfr_get_d1", XS_Math__MPFR_Rmpfr_get_d1);
        newXS_deffile("Math::MPFR::Rmpfr_get_z_2exp", XS_Math__MPFR_Rmpfr_get_z_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_add", XS_Math__MPFR_Rmpfr_add);
        newXS_deffile("Math::MPFR::Rmpfr_add_ui", XS_Math__MPFR_Rmpfr_add_ui);
        newXS_deffile("Math::MPFR::Rmpfr_add_d", XS_Math__MPFR_Rmpfr_add_d);
        newXS_deffile("Math::MPFR::Rmpfr_add_si", XS_Math__MPFR_Rmpfr_add_si);
        newXS_deffile("Math::MPFR::Rmpfr_add_z", XS_Math__MPFR_Rmpfr_add_z);
        newXS_deffile("Math::MPFR::Rmpfr_get_q", XS_Math__MPFR_Rmpfr_get_q);
        newXS_deffile("Math::MPFR::Rmpfr_add_q", XS_Math__MPFR_Rmpfr_add_q);
        newXS_deffile("Math::MPFR::q_add_fr", XS_Math__MPFR_q_add_fr);
        newXS_deffile("Math::MPFR::Rmpfr_sub", XS_Math__MPFR_Rmpfr_sub);
        newXS_deffile("Math::MPFR::Rmpfr_sub_ui", XS_Math__MPFR_Rmpfr_sub_ui);
        newXS_deffile("Math::MPFR::Rmpfr_sub_d", XS_Math__MPFR_Rmpfr_sub_d);
        newXS_deffile("Math::MPFR::Rmpfr_sub_z", XS_Math__MPFR_Rmpfr_sub_z);
        newXS_deffile("Math::MPFR::Rmpfr_sub_q", XS_Math__MPFR_Rmpfr_sub_q);
        newXS_deffile("Math::MPFR::q_sub_fr", XS_Math__MPFR_q_sub_fr);
        newXS_deffile("Math::MPFR::Rmpfr_ui_sub", XS_Math__MPFR_Rmpfr_ui_sub);
        newXS_deffile("Math::MPFR::Rmpfr_d_sub", XS_Math__MPFR_Rmpfr_d_sub);
        newXS_deffile("Math::MPFR::Rmpfr_mul", XS_Math__MPFR_Rmpfr_mul);
        newXS_deffile("Math::MPFR::Rmpfr_mul_ui", XS_Math__MPFR_Rmpfr_mul_ui);
        newXS_deffile("Math::MPFR::Rmpfr_mul_d", XS_Math__MPFR_Rmpfr_mul_d);
        newXS_deffile("Math::MPFR::Rmpfr_mul_z", XS_Math__MPFR_Rmpfr_mul_z);
        newXS_deffile("Math::MPFR::Rmpfr_mul_q", XS_Math__MPFR_Rmpfr_mul_q);
        newXS_deffile("Math::MPFR::q_mul_fr", XS_Math__MPFR_q_mul_fr);
        newXS_deffile("Math::MPFR::Rmpfr_dim", XS_Math__MPFR_Rmpfr_dim);
        newXS_deffile("Math::MPFR::Rmpfr_div", XS_Math__MPFR_Rmpfr_div);
        newXS_deffile("Math::MPFR::Rmpfr_div_ui", XS_Math__MPFR_Rmpfr_div_ui);
        newXS_deffile("Math::MPFR::Rmpfr_div_d", XS_Math__MPFR_Rmpfr_div_d);
        newXS_deffile("Math::MPFR::Rmpfr_div_z", XS_Math__MPFR_Rmpfr_div_z);
        newXS_deffile("Math::MPFR::Rmpfr_div_q", XS_Math__MPFR_Rmpfr_div_q);
        newXS_deffile("Math::MPFR::q_div_fr", XS_Math__MPFR_q_div_fr);
        newXS_deffile("Math::MPFR::q_fmod_fr", XS_Math__MPFR_q_fmod_fr);
        newXS_deffile("Math::MPFR::Rmpfr_ui_div", XS_Math__MPFR_Rmpfr_ui_div);
        newXS_deffile("Math::MPFR::Rmpfr_d_div", XS_Math__MPFR_Rmpfr_d_div);
        newXS_deffile("Math::MPFR::Rmpfr_sqrt", XS_Math__MPFR_Rmpfr_sqrt);
        newXS_deffile("Math::MPFR::Rmpfr_rec_sqrt", XS_Math__MPFR_Rmpfr_rec_sqrt);
        newXS_deffile("Math::MPFR::Rmpfr_cbrt", XS_Math__MPFR_Rmpfr_cbrt);
        newXS_deffile("Math::MPFR::Rmpfr_sqrt_ui", XS_Math__MPFR_Rmpfr_sqrt_ui);
        newXS_deffile("Math::MPFR::Rmpfr_pow_ui", XS_Math__MPFR_Rmpfr_pow_ui);
        newXS_deffile("Math::MPFR::Rmpfr_pow_uj", XS_Math__MPFR_Rmpfr_pow_uj);
        newXS_deffile("Math::MPFR::Rmpfr_pow_IV", XS_Math__MPFR_Rmpfr_pow_IV);
        newXS_deffile("Math::MPFR::Rmpfr_ui_pow_ui", XS_Math__MPFR_Rmpfr_ui_pow_ui);
        newXS_deffile("Math::MPFR::Rmpfr_ui_pow", XS_Math__MPFR_Rmpfr_ui_pow);
        newXS_deffile("Math::MPFR::Rmpfr_pow_si", XS_Math__MPFR_Rmpfr_pow_si);
        newXS_deffile("Math::MPFR::Rmpfr_pow_sj", XS_Math__MPFR_Rmpfr_pow_sj);
        newXS_deffile("Math::MPFR::Rmpfr_pow", XS_Math__MPFR_Rmpfr_pow);
        newXS_deffile("Math::MPFR::Rmpfr_powr", XS_Math__MPFR_Rmpfr_powr);
        newXS_deffile("Math::MPFR::Rmpfr_pown", XS_Math__MPFR_Rmpfr_pown);
        newXS_deffile("Math::MPFR::Rmpfr_compound_si", XS_Math__MPFR_Rmpfr_compound_si);
        newXS_deffile("Math::MPFR::Rmpfr_compound", XS_Math__MPFR_Rmpfr_compound);
        newXS_deffile("Math::MPFR::Rmpfr_neg", XS_Math__MPFR_Rmpfr_neg);
        newXS_deffile("Math::MPFR::Rmpfr_abs", XS_Math__MPFR_Rmpfr_abs);
        newXS_deffile("Math::MPFR::Rmpfr_mul_2exp", XS_Math__MPFR_Rmpfr_mul_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_mul_2ui", XS_Math__MPFR_Rmpfr_mul_2ui);
        newXS_deffile("Math::MPFR::Rmpfr_mul_2si", XS_Math__MPFR_Rmpfr_mul_2si);
        newXS_deffile("Math::MPFR::Rmpfr_div_2exp", XS_Math__MPFR_Rmpfr_div_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_div_2ui", XS_Math__MPFR_Rmpfr_div_2ui);
        newXS_deffile("Math::MPFR::Rmpfr_div_2si", XS_Math__MPFR_Rmpfr_div_2si);
        newXS_deffile("Math::MPFR::Rmpfr_total_order_p", XS_Math__MPFR_Rmpfr_total_order_p);
        newXS_deffile("Math::MPFR::Rmpfr_cmp", XS_Math__MPFR_Rmpfr_cmp);
        newXS_deffile("Math::MPFR::Rmpfr_cmpabs", XS_Math__MPFR_Rmpfr_cmpabs);
        newXS_deffile("Math::MPFR::Rmpfr_cmpabs_ui", XS_Math__MPFR_Rmpfr_cmpabs_ui);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_ui", XS_Math__MPFR_Rmpfr_cmp_ui);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_si", XS_Math__MPFR_Rmpfr_cmp_si);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_uj", XS_Math__MPFR_Rmpfr_cmp_uj);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_sj", XS_Math__MPFR_Rmpfr_cmp_sj);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_IV", XS_Math__MPFR_Rmpfr_cmp_IV);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_d", XS_Math__MPFR_Rmpfr_cmp_d);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_ld", XS_Math__MPFR_Rmpfr_cmp_ld);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_ui_2exp", XS_Math__MPFR_Rmpfr_cmp_ui_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_si_2exp", XS_Math__MPFR_Rmpfr_cmp_si_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_eq", XS_Math__MPFR_Rmpfr_eq);
        newXS_deffile("Math::MPFR::Rmpfr_nan_p", XS_Math__MPFR_Rmpfr_nan_p);
        newXS_deffile("Math::MPFR::Rmpfr_inf_p", XS_Math__MPFR_Rmpfr_inf_p);
        newXS_deffile("Math::MPFR::Rmpfr_number_p", XS_Math__MPFR_Rmpfr_number_p);
        newXS_deffile("Math::MPFR::Rmpfr_reldiff", XS_Math__MPFR_Rmpfr_reldiff);
        newXS_deffile("Math::MPFR::Rmpfr_sgn", XS_Math__MPFR_Rmpfr_sgn);
        newXS_deffile("Math::MPFR::Rmpfr_greater_p", XS_Math__MPFR_Rmpfr_greater_p);
        newXS_deffile("Math::MPFR::Rmpfr_greaterequal_p", XS_Math__MPFR_Rmpfr_greaterequal_p);
        newXS_deffile("Math::MPFR::Rmpfr_less_p", XS_Math__MPFR_Rmpfr_less_p);
        newXS_deffile("Math::MPFR::Rmpfr_lessequal_p", XS_Math__MPFR_Rmpfr_lessequal_p);
        newXS_deffile("Math::MPFR::Rmpfr_lessgreater_p", XS_Math__MPFR_Rmpfr_lessgreater_p);
        newXS_deffile("Math::MPFR::Rmpfr_equal_p", XS_Math__MPFR_Rmpfr_equal_p);
        newXS_deffile("Math::MPFR::Rmpfr_unordered_p", XS_Math__MPFR_Rmpfr_unordered_p);
        newXS_deffile("Math::MPFR::Rmpfr_sin_cos", XS_Math__MPFR_Rmpfr_sin_cos);
        newXS_deffile("Math::MPFR::Rmpfr_sinh_cosh", XS_Math__MPFR_Rmpfr_sinh_cosh);
        newXS_deffile("Math::MPFR::Rmpfr_sin", XS_Math__MPFR_Rmpfr_sin);
        newXS_deffile("Math::MPFR::Rmpfr_sinu", XS_Math__MPFR_Rmpfr_sinu);
        newXS_deffile("Math::MPFR::Rmpfr_sinpi", XS_Math__MPFR_Rmpfr_sinpi);
        newXS_deffile("Math::MPFR::Rmpfr_cos", XS_Math__MPFR_Rmpfr_cos);
        newXS_deffile("Math::MPFR::Rmpfr_cosu", XS_Math__MPFR_Rmpfr_cosu);
        newXS_deffile("Math::MPFR::Rmpfr_cospi", XS_Math__MPFR_Rmpfr_cospi);
        newXS_deffile("Math::MPFR::Rmpfr_tan", XS_Math__MPFR_Rmpfr_tan);
        newXS_deffile("Math::MPFR::Rmpfr_tanu", XS_Math__MPFR_Rmpfr_tanu);
        newXS_deffile("Math::MPFR::Rmpfr_tanpi", XS_Math__MPFR_Rmpfr_tanpi);
        newXS_deffile("Math::MPFR::Rmpfr_asin", XS_Math__MPFR_Rmpfr_asin);
        newXS_deffile("Math::MPFR::Rmpfr_asinu", XS_Math__MPFR_Rmpfr_asinu);
        newXS_deffile("Math::MPFR::Rmpfr_asinpi", XS_Math__MPFR_Rmpfr_asinpi);
        newXS_deffile("Math::MPFR::Rmpfr_acos", XS_Math__MPFR_Rmpfr_acos);
        newXS_deffile("Math::MPFR::Rmpfr_acosu", XS_Math__MPFR_Rmpfr_acosu);
        newXS_deffile("Math::MPFR::Rmpfr_acospi", XS_Math__MPFR_Rmpfr_acospi);
        newXS_deffile("Math::MPFR::Rmpfr_atan", XS_Math__MPFR_Rmpfr_atan);
        newXS_deffile("Math::MPFR::Rmpfr_atanu", XS_Math__MPFR_Rmpfr_atanu);
        newXS_deffile("Math::MPFR::Rmpfr_atanpi", XS_Math__MPFR_Rmpfr_atanpi);
        newXS_deffile("Math::MPFR::Rmpfr_sinh", XS_Math__MPFR_Rmpfr_sinh);
        newXS_deffile("Math::MPFR::Rmpfr_cosh", XS_Math__MPFR_Rmpfr_cosh);
        newXS_deffile("Math::MPFR::Rmpfr_tanh", XS_Math__MPFR_Rmpfr_tanh);
        newXS_deffile("Math::MPFR::Rmpfr_asinh", XS_Math__MPFR_Rmpfr_asinh);
        newXS_deffile("Math::MPFR::Rmpfr_acosh", XS_Math__MPFR_Rmpfr_acosh);
        newXS_deffile("Math::MPFR::Rmpfr_atanh", XS_Math__MPFR_Rmpfr_atanh);
        newXS_deffile("Math::MPFR::Rmpfr_fac_ui", XS_Math__MPFR_Rmpfr_fac_ui);
        newXS_deffile("Math::MPFR::Rmpfr_log1p", XS_Math__MPFR_Rmpfr_log1p);
        newXS_deffile("Math::MPFR::Rmpfr_expm1", XS_Math__MPFR_Rmpfr_expm1);
        newXS_deffile("Math::MPFR::Rmpfr_exp2m1", XS_Math__MPFR_Rmpfr_exp2m1);
        newXS_deffile("Math::MPFR::Rmpfr_exp10m1", XS_Math__MPFR_Rmpfr_exp10m1);
        newXS_deffile("Math::MPFR::Rmpfr_log2", XS_Math__MPFR_Rmpfr_log2);
        newXS_deffile("Math::MPFR::Rmpfr_log2p1", XS_Math__MPFR_Rmpfr_log2p1);
        newXS_deffile("Math::MPFR::Rmpfr_log10", XS_Math__MPFR_Rmpfr_log10);
        newXS_deffile("Math::MPFR::Rmpfr_log10p1", XS_Math__MPFR_Rmpfr_log10p1);
        newXS_deffile("Math::MPFR::Rmpfr_fma", XS_Math__MPFR_Rmpfr_fma);
        newXS_deffile("Math::MPFR::Rmpfr_fms", XS_Math__MPFR_Rmpfr_fms);
        newXS_deffile("Math::MPFR::Rmpfr_agm", XS_Math__MPFR_Rmpfr_agm);
        newXS_deffile("Math::MPFR::Rmpfr_hypot", XS_Math__MPFR_Rmpfr_hypot);
        newXS_deffile("Math::MPFR::Rmpfr_const_log2", XS_Math__MPFR_Rmpfr_const_log2);
        newXS_deffile("Math::MPFR::Rmpfr_const_pi", XS_Math__MPFR_Rmpfr_const_pi);
        newXS_deffile("Math::MPFR::Rmpfr_const_euler", XS_Math__MPFR_Rmpfr_const_euler);
        newXS_deffile("Math::MPFR::Rmpfr_rint", XS_Math__MPFR_Rmpfr_rint);
        newXS_deffile("Math::MPFR::Rmpfr_ceil", XS_Math__MPFR_Rmpfr_ceil);
        newXS_deffile("Math::MPFR::Rmpfr_floor", XS_Math__MPFR_Rmpfr_floor);
        newXS_deffile("Math::MPFR::Rmpfr_round", XS_Math__MPFR_Rmpfr_round);
        newXS_deffile("Math::MPFR::Rmpfr_trunc", XS_Math__MPFR_Rmpfr_trunc);
        newXS_deffile("Math::MPFR::Rmpfr_can_round", XS_Math__MPFR_Rmpfr_can_round);
        newXS_deffile("Math::MPFR::Rmpfr_print_rnd_mode", XS_Math__MPFR_Rmpfr_print_rnd_mode);
        newXS_deffile("Math::MPFR::Rmpfr_get_emin", XS_Math__MPFR_Rmpfr_get_emin);
        newXS_deffile("Math::MPFR::Rmpfr_get_emax", XS_Math__MPFR_Rmpfr_get_emax);
        newXS_deffile("Math::MPFR::Rmpfr_set_emin", XS_Math__MPFR_Rmpfr_set_emin);
        newXS_deffile("Math::MPFR::Rmpfr_set_emax", XS_Math__MPFR_Rmpfr_set_emax);
        newXS_deffile("Math::MPFR::Rmpfr_check_range", XS_Math__MPFR_Rmpfr_check_range);
        newXS_deffile("Math::MPFR::Rmpfr_clear_underflow", XS_Math__MPFR_Rmpfr_clear_underflow);
        newXS_deffile("Math::MPFR::Rmpfr_clear_overflow", XS_Math__MPFR_Rmpfr_clear_overflow);
        newXS_deffile("Math::MPFR::Rmpfr_clear_nanflag", XS_Math__MPFR_Rmpfr_clear_nanflag);
        newXS_deffile("Math::MPFR::Rmpfr_clear_inexflag", XS_Math__MPFR_Rmpfr_clear_inexflag);
        newXS_deffile("Math::MPFR::Rmpfr_clear_flags", XS_Math__MPFR_Rmpfr_clear_flags);
        newXS_deffile("Math::MPFR::Rmpfr_underflow_p", XS_Math__MPFR_Rmpfr_underflow_p);
        newXS_deffile("Math::MPFR::Rmpfr_overflow_p", XS_Math__MPFR_Rmpfr_overflow_p);
        newXS_deffile("Math::MPFR::Rmpfr_nanflag_p", XS_Math__MPFR_Rmpfr_nanflag_p);
        newXS_deffile("Math::MPFR::Rmpfr_inexflag_p", XS_Math__MPFR_Rmpfr_inexflag_p);
        newXS_deffile("Math::MPFR::Rmpfr_log", XS_Math__MPFR_Rmpfr_log);
        newXS_deffile("Math::MPFR::Rmpfr_exp", XS_Math__MPFR_Rmpfr_exp);
        newXS_deffile("Math::MPFR::Rmpfr_exp2", XS_Math__MPFR_Rmpfr_exp2);
        newXS_deffile("Math::MPFR::Rmpfr_exp10", XS_Math__MPFR_Rmpfr_exp10);
        newXS_deffile("Math::MPFR::Rmpfr_urandomb", XS_Math__MPFR_Rmpfr_urandomb);
        newXS_deffile("Math::MPFR::Rmpfr_random2", XS_Math__MPFR_Rmpfr_random2);
        newXS_deffile("Math::MPFR::_TRmpfr_out_str", XS_Math__MPFR__TRmpfr_out_str);
        newXS_deffile("Math::MPFR::_Rmpfr_out_str", XS_Math__MPFR__Rmpfr_out_str);
        newXS_deffile("Math::MPFR::_TRmpfr_out_strS", XS_Math__MPFR__TRmpfr_out_strS);
        newXS_deffile("Math::MPFR::_TRmpfr_out_strP", XS_Math__MPFR__TRmpfr_out_strP);
        newXS_deffile("Math::MPFR::_TRmpfr_out_strPS", XS_Math__MPFR__TRmpfr_out_strPS);
        newXS_deffile("Math::MPFR::_Rmpfr_out_strS", XS_Math__MPFR__Rmpfr_out_strS);
        newXS_deffile("Math::MPFR::_Rmpfr_out_strP", XS_Math__MPFR__Rmpfr_out_strP);
        newXS_deffile("Math::MPFR::_Rmpfr_out_strPS", XS_Math__MPFR__Rmpfr_out_strPS);
        newXS_deffile("Math::MPFR::TRmpfr_inp_str", XS_Math__MPFR_TRmpfr_inp_str);
        newXS_deffile("Math::MPFR::Rmpfr_inp_str", XS_Math__MPFR_Rmpfr_inp_str);
        newXS_deffile("Math::MPFR::Rmpfr_gamma", XS_Math__MPFR_Rmpfr_gamma);
        newXS_deffile("Math::MPFR::Rmpfr_zeta", XS_Math__MPFR_Rmpfr_zeta);
        newXS_deffile("Math::MPFR::Rmpfr_zeta_ui", XS_Math__MPFR_Rmpfr_zeta_ui);
        newXS_deffile("Math::MPFR::Rmpfr_erf", XS_Math__MPFR_Rmpfr_erf);
        newXS_deffile("Math::MPFR::Rmpfr_frac", XS_Math__MPFR_Rmpfr_frac);
        newXS_deffile("Math::MPFR::Rmpfr_remainder", XS_Math__MPFR_Rmpfr_remainder);
        newXS_deffile("Math::MPFR::Rmpfr_modf", XS_Math__MPFR_Rmpfr_modf);
        newXS_deffile("Math::MPFR::Rmpfr_fmod", XS_Math__MPFR_Rmpfr_fmod);
        newXS_deffile("Math::MPFR::Rmpfr_fmod_ui", XS_Math__MPFR_Rmpfr_fmod_ui);
        newXS_deffile("Math::MPFR::Rmpfr_remquo", XS_Math__MPFR_Rmpfr_remquo);
        newXS_deffile("Math::MPFR::Rmpfr_integer_p", XS_Math__MPFR_Rmpfr_integer_p);
        newXS_deffile("Math::MPFR::Rmpfr_nexttoward", XS_Math__MPFR_Rmpfr_nexttoward);
        newXS_deffile("Math::MPFR::Rmpfr_nextabove", XS_Math__MPFR_Rmpfr_nextabove);
        newXS_deffile("Math::MPFR::Rmpfr_nextbelow", XS_Math__MPFR_Rmpfr_nextbelow);
        newXS_deffile("Math::MPFR::Rmpfr_min", XS_Math__MPFR_Rmpfr_min);
        newXS_deffile("Math::MPFR::Rmpfr_max", XS_Math__MPFR_Rmpfr_max);
        newXS_deffile("Math::MPFR::Rmpfr_get_exp", XS_Math__MPFR_Rmpfr_get_exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_exp", XS_Math__MPFR_Rmpfr_set_exp);
        newXS_deffile("Math::MPFR::Rmpfr_signbit", XS_Math__MPFR_Rmpfr_signbit);
        newXS_deffile("Math::MPFR::Rmpfr_setsign", XS_Math__MPFR_Rmpfr_setsign);
        newXS_deffile("Math::MPFR::Rmpfr_copysign", XS_Math__MPFR_Rmpfr_copysign);
        newXS_deffile("Math::MPFR::get_refcnt", XS_Math__MPFR_get_refcnt);
        newXS_deffile("Math::MPFR::get_package_name", XS_Math__MPFR_get_package_name);
        newXS_deffile("Math::MPFR::Rmpfr_dump", XS_Math__MPFR_Rmpfr_dump);
        newXS_deffile("Math::MPFR::gmp_v", XS_Math__MPFR_gmp_v);
        newXS_deffile("Math::MPFR::Rmpfr_set_ui_2exp", XS_Math__MPFR_Rmpfr_set_ui_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_si_2exp", XS_Math__MPFR_Rmpfr_set_si_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_uj_2exp", XS_Math__MPFR_Rmpfr_set_uj_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_set_sj_2exp", XS_Math__MPFR_Rmpfr_set_sj_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_get_z", XS_Math__MPFR_Rmpfr_get_z);
        newXS_deffile("Math::MPFR::Rmpfr_si_sub", XS_Math__MPFR_Rmpfr_si_sub);
        newXS_deffile("Math::MPFR::Rmpfr_sub_si", XS_Math__MPFR_Rmpfr_sub_si);
        newXS_deffile("Math::MPFR::Rmpfr_mul_si", XS_Math__MPFR_Rmpfr_mul_si);
        newXS_deffile("Math::MPFR::Rmpfr_si_div", XS_Math__MPFR_Rmpfr_si_div);
        newXS_deffile("Math::MPFR::Rmpfr_div_si", XS_Math__MPFR_Rmpfr_div_si);
        newXS_deffile("Math::MPFR::Rmpfr_sqr", XS_Math__MPFR_Rmpfr_sqr);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_z", XS_Math__MPFR_Rmpfr_cmp_z);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_q", XS_Math__MPFR_Rmpfr_cmp_q);
        newXS_deffile("Math::MPFR::fr_cmp_q_rounded", XS_Math__MPFR_fr_cmp_q_rounded);
        newXS_deffile("Math::MPFR::Rmpfr_cmp_f", XS_Math__MPFR_Rmpfr_cmp_f);
        newXS_deffile("Math::MPFR::Rmpfr_zero_p", XS_Math__MPFR_Rmpfr_zero_p);
        newXS_deffile("Math::MPFR::Rmpfr_free_cache", XS_Math__MPFR_Rmpfr_free_cache);
        newXS_deffile("Math::MPFR::Rmpfr_free_cache2", XS_Math__MPFR_Rmpfr_free_cache2);
        newXS_deffile("Math::MPFR::Rmpfr_free_pool", XS_Math__MPFR_Rmpfr_free_pool);
        newXS_deffile("Math::MPFR::Rmpfr_get_version", XS_Math__MPFR_Rmpfr_get_version);
        newXS_deffile("Math::MPFR::Rmpfr_get_patches", XS_Math__MPFR_Rmpfr_get_patches);
        newXS_deffile("Math::MPFR::Rmpfr_get_emin_min", XS_Math__MPFR_Rmpfr_get_emin_min);
        newXS_deffile("Math::MPFR::Rmpfr_get_emin_max", XS_Math__MPFR_Rmpfr_get_emin_max);
        newXS_deffile("Math::MPFR::Rmpfr_get_emax_min", XS_Math__MPFR_Rmpfr_get_emax_min);
        newXS_deffile("Math::MPFR::Rmpfr_get_emax_max", XS_Math__MPFR_Rmpfr_get_emax_max);
        newXS_deffile("Math::MPFR::Rmpfr_clear_erangeflag", XS_Math__MPFR_Rmpfr_clear_erangeflag);
        newXS_deffile("Math::MPFR::Rmpfr_erangeflag_p", XS_Math__MPFR_Rmpfr_erangeflag_p);
        newXS_deffile("Math::MPFR::Rmpfr_rint_round", XS_Math__MPFR_Rmpfr_rint_round);
        newXS_deffile("Math::MPFR::Rmpfr_rint_trunc", XS_Math__MPFR_Rmpfr_rint_trunc);
        newXS_deffile("Math::MPFR::Rmpfr_rint_ceil", XS_Math__MPFR_Rmpfr_rint_ceil);
        newXS_deffile("Math::MPFR::Rmpfr_rint_floor", XS_Math__MPFR_Rmpfr_rint_floor);
        newXS_deffile("Math::MPFR::Rmpfr_get_ui", XS_Math__MPFR_Rmpfr_get_ui);
        newXS_deffile("Math::MPFR::Rmpfr_get_si", XS_Math__MPFR_Rmpfr_get_si);
        newXS_deffile("Math::MPFR::Rmpfr_get_uj", XS_Math__MPFR_Rmpfr_get_uj);
        newXS_deffile("Math::MPFR::Rmpfr_get_sj", XS_Math__MPFR_Rmpfr_get_sj);
        newXS_deffile("Math::MPFR::Rmpfr_get_IV", XS_Math__MPFR_Rmpfr_get_IV);
        newXS_deffile("Math::MPFR::Rmpfr_set_IV", XS_Math__MPFR_Rmpfr_set_IV);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_IV", XS_Math__MPFR_Rmpfr_init_set_IV);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_IV_nobless", XS_Math__MPFR_Rmpfr_init_set_IV_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_get_NV", XS_Math__MPFR_Rmpfr_get_NV);
        newXS_deffile("Math::MPFR::Rmpfr_fits_ulong_p", XS_Math__MPFR_Rmpfr_fits_ulong_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_slong_p", XS_Math__MPFR_Rmpfr_fits_slong_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_ushort_p", XS_Math__MPFR_Rmpfr_fits_ushort_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_sshort_p", XS_Math__MPFR_Rmpfr_fits_sshort_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_uint_p", XS_Math__MPFR_Rmpfr_fits_uint_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_sint_p", XS_Math__MPFR_Rmpfr_fits_sint_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_uintmax_p", XS_Math__MPFR_Rmpfr_fits_uintmax_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_intmax_p", XS_Math__MPFR_Rmpfr_fits_intmax_p);
        newXS_deffile("Math::MPFR::Rmpfr_fits_IV_p", XS_Math__MPFR_Rmpfr_fits_IV_p);
        newXS_deffile("Math::MPFR::Rmpfr_strtofr", XS_Math__MPFR_Rmpfr_strtofr);
        newXS_deffile("Math::MPFR::Rmpfr_set_erangeflag", XS_Math__MPFR_Rmpfr_set_erangeflag);
        newXS_deffile("Math::MPFR::Rmpfr_set_underflow", XS_Math__MPFR_Rmpfr_set_underflow);
        newXS_deffile("Math::MPFR::Rmpfr_set_overflow", XS_Math__MPFR_Rmpfr_set_overflow);
        newXS_deffile("Math::MPFR::Rmpfr_set_nanflag", XS_Math__MPFR_Rmpfr_set_nanflag);
        newXS_deffile("Math::MPFR::Rmpfr_set_inexflag", XS_Math__MPFR_Rmpfr_set_inexflag);
        newXS_deffile("Math::MPFR::Rmpfr_erfc", XS_Math__MPFR_Rmpfr_erfc);
        newXS_deffile("Math::MPFR::Rmpfr_j0", XS_Math__MPFR_Rmpfr_j0);
        newXS_deffile("Math::MPFR::Rmpfr_j1", XS_Math__MPFR_Rmpfr_j1);
        newXS_deffile("Math::MPFR::Rmpfr_jn", XS_Math__MPFR_Rmpfr_jn);
        newXS_deffile("Math::MPFR::Rmpfr_y0", XS_Math__MPFR_Rmpfr_y0);
        newXS_deffile("Math::MPFR::Rmpfr_y1", XS_Math__MPFR_Rmpfr_y1);
        newXS_deffile("Math::MPFR::Rmpfr_yn", XS_Math__MPFR_Rmpfr_yn);
        newXS_deffile("Math::MPFR::Rmpfr_atan2", XS_Math__MPFR_Rmpfr_atan2);
        newXS_deffile("Math::MPFR::Rmpfr_atan2u", XS_Math__MPFR_Rmpfr_atan2u);
        newXS_deffile("Math::MPFR::Rmpfr_atan2pi", XS_Math__MPFR_Rmpfr_atan2pi);
        newXS_deffile("Math::MPFR::Rmpfr_pow_z", XS_Math__MPFR_Rmpfr_pow_z);
        newXS_deffile("Math::MPFR::Rmpfr_subnormalize", XS_Math__MPFR_Rmpfr_subnormalize);
        newXS_deffile("Math::MPFR::Rmpfr_const_catalan", XS_Math__MPFR_Rmpfr_const_catalan);
        newXS_deffile("Math::MPFR::Rmpfr_sec", XS_Math__MPFR_Rmpfr_sec);
        newXS_deffile("Math::MPFR::Rmpfr_csc", XS_Math__MPFR_Rmpfr_csc);
        newXS_deffile("Math::MPFR::Rmpfr_cot", XS_Math__MPFR_Rmpfr_cot);
        newXS_deffile("Math::MPFR::Rmpfr_root", XS_Math__MPFR_Rmpfr_root);
        newXS_deffile("Math::MPFR::Rmpfr_eint", XS_Math__MPFR_Rmpfr_eint);
        newXS_deffile("Math::MPFR::Rmpfr_li2", XS_Math__MPFR_Rmpfr_li2);
        newXS_deffile("Math::MPFR::Rmpfr_get_f", XS_Math__MPFR_Rmpfr_get_f);
        newXS_deffile("Math::MPFR::Rmpfr_sech", XS_Math__MPFR_Rmpfr_sech);
        newXS_deffile("Math::MPFR::Rmpfr_csch", XS_Math__MPFR_Rmpfr_csch);
        newXS_deffile("Math::MPFR::Rmpfr_coth", XS_Math__MPFR_Rmpfr_coth);
        newXS_deffile("Math::MPFR::Rmpfr_lngamma", XS_Math__MPFR_Rmpfr_lngamma);
        newXS_deffile("Math::MPFR::Rmpfr_lgamma", XS_Math__MPFR_Rmpfr_lgamma);
        newXS_deffile("Math::MPFR::_MPFR_VERSION", XS_Math__MPFR__MPFR_VERSION);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_MAJOR", XS_Math__MPFR__MPFR_VERSION_MAJOR);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_MINOR", XS_Math__MPFR__MPFR_VERSION_MINOR);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_PATCHLEVEL", XS_Math__MPFR__MPFR_VERSION_PATCHLEVEL);
        newXS_deffile("Math::MPFR::_MPFR_VERSION_STRING", XS_Math__MPFR__MPFR_VERSION_STRING);
        newXS_deffile("Math::MPFR::RMPFR_VERSION_NUM", XS_Math__MPFR_RMPFR_VERSION_NUM);
        newXS_deffile("Math::MPFR::Rmpfr_sum", XS_Math__MPFR_Rmpfr_sum);
        newXS_deffile("Math::MPFR::_fr_to_q", XS_Math__MPFR__fr_to_q);
        newXS_deffile("Math::MPFR::Rmpfr_q_div", XS_Math__MPFR_Rmpfr_q_div);
        newXS_deffile("Math::MPFR::Rmpfr_z_div", XS_Math__MPFR_Rmpfr_z_div);
        newXS_deffile("Math::MPFR::overload_mul", XS_Math__MPFR_overload_mul);
        newXS_deffile("Math::MPFR::overload_add", XS_Math__MPFR_overload_add);
        newXS_deffile("Math::MPFR::overload_sub", XS_Math__MPFR_overload_sub);
        newXS_deffile("Math::MPFR::overload_div", XS_Math__MPFR_overload_div);
        newXS_deffile("Math::MPFR::overload_copy", XS_Math__MPFR_overload_copy);
        newXS_deffile("Math::MPFR::overload_abs", XS_Math__MPFR_overload_abs);
        newXS_deffile("Math::MPFR::overload_gt", XS_Math__MPFR_overload_gt);
        newXS_deffile("Math::MPFR::overload_gte", XS_Math__MPFR_overload_gte);
        newXS_deffile("Math::MPFR::overload_lt", XS_Math__MPFR_overload_lt);
        newXS_deffile("Math::MPFR::overload_lte", XS_Math__MPFR_overload_lte);
        newXS_deffile("Math::MPFR::overload_spaceship", XS_Math__MPFR_overload_spaceship);
        newXS_deffile("Math::MPFR::overload_equiv", XS_Math__MPFR_overload_equiv);
        newXS_deffile("Math::MPFR::overload_not_equiv", XS_Math__MPFR_overload_not_equiv);
        newXS_deffile("Math::MPFR::overload_true", XS_Math__MPFR_overload_true);
        newXS_deffile("Math::MPFR::overload_not", XS_Math__MPFR_overload_not);
        newXS_deffile("Math::MPFR::overload_sqrt", XS_Math__MPFR_overload_sqrt);
        newXS_deffile("Math::MPFR::overload_pow", XS_Math__MPFR_overload_pow);
        newXS_deffile("Math::MPFR::overload_log", XS_Math__MPFR_overload_log);
        newXS_deffile("Math::MPFR::log_2", XS_Math__MPFR_log_2);
        newXS_deffile("Math::MPFR::log_10", XS_Math__MPFR_log_10);
        newXS_deffile("Math::MPFR::overload_exp", XS_Math__MPFR_overload_exp);
        newXS_deffile("Math::MPFR::overload_sin", XS_Math__MPFR_overload_sin);
        newXS_deffile("Math::MPFR::sind", XS_Math__MPFR_sind);
        newXS_deffile("Math::MPFR::overload_cos", XS_Math__MPFR_overload_cos);
        newXS_deffile("Math::MPFR::cosd", XS_Math__MPFR_cosd);
        newXS_deffile("Math::MPFR::tangent", XS_Math__MPFR_tangent);
        newXS_deffile("Math::MPFR::tand", XS_Math__MPFR_tand);
        newXS_deffile("Math::MPFR::overload_int", XS_Math__MPFR_overload_int);
        newXS_deffile("Math::MPFR::overload_atan2", XS_Math__MPFR_overload_atan2);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_default_nobless", XS_Math__MPFR_Rmpfr_randinit_default_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_mt_nobless", XS_Math__MPFR_Rmpfr_randinit_mt_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_lc_2exp_nobless", XS_Math__MPFR_Rmpfr_randinit_lc_2exp_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randinit_lc_2exp_size_nobless", XS_Math__MPFR_Rmpfr_randinit_lc_2exp_size_nobless);
        newXS_deffile("Math::MPFR::Rmpfr_randclear", XS_Math__MPFR_Rmpfr_randclear);
        newXS_deffile("Math::MPFR::Rmpfr_randseed", XS_Math__MPFR_Rmpfr_randseed);
        newXS_deffile("Math::MPFR::Rmpfr_randseed_ui", XS_Math__MPFR_Rmpfr_randseed_ui);
        newXS_deffile("Math::MPFR::overload_pow_eq", XS_Math__MPFR_overload_pow_eq);
        newXS_deffile("Math::MPFR::overload_div_eq", XS_Math__MPFR_overload_div_eq);
        newXS_deffile("Math::MPFR::overload_sub_eq", XS_Math__MPFR_overload_sub_eq);
        newXS_deffile("Math::MPFR::overload_add_eq", XS_Math__MPFR_overload_add_eq);
        newXS_deffile("Math::MPFR::overload_mul_eq", XS_Math__MPFR_overload_mul_eq);
        newXS_deffile("Math::MPFR::_itsa", XS_Math__MPFR__itsa);
        newXS_deffile("Math::MPFR::_has_longlong", XS_Math__MPFR__has_longlong);
        newXS_deffile("Math::MPFR::_has_longdouble", XS_Math__MPFR__has_longdouble);
        newXS_deffile("Math::MPFR::_ivsize_bits", XS_Math__MPFR__ivsize_bits);
        (void)newXSproto_portable("Math::MPFR::RMPFR_PREC_MAX", XS_Math__MPFR_RMPFR_PREC_MAX, file, "");
        (void)newXSproto_portable("Math::MPFR::RMPFR_PREC_MIN", XS_Math__MPFR_RMPFR_PREC_MIN, file, "");
        newXS_deffile("Math::MPFR::wrap_mpfr_printf", XS_Math__MPFR_wrap_mpfr_printf);
        newXS_deffile("Math::MPFR::wrap_mpfr_fprintf", XS_Math__MPFR_wrap_mpfr_fprintf);
        newXS_deffile("Math::MPFR::wrap_mpfr_sprintf", XS_Math__MPFR_wrap_mpfr_sprintf);
        newXS_deffile("Math::MPFR::wrap_mpfr_snprintf", XS_Math__MPFR_wrap_mpfr_snprintf);
        newXS_deffile("Math::MPFR::wrap_mpfr_printf_rnd", XS_Math__MPFR_wrap_mpfr_printf_rnd);
        newXS_deffile("Math::MPFR::wrap_mpfr_fprintf_rnd", XS_Math__MPFR_wrap_mpfr_fprintf_rnd);
        newXS_deffile("Math::MPFR::wrap_mpfr_sprintf_rnd", XS_Math__MPFR_wrap_mpfr_sprintf_rnd);
        newXS_deffile("Math::MPFR::wrap_mpfr_snprintf_rnd", XS_Math__MPFR_wrap_mpfr_snprintf_rnd);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_tls_p", XS_Math__MPFR_Rmpfr_buildopt_tls_p);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_float16_p", XS_Math__MPFR_Rmpfr_buildopt_float16_p);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_decimal_p", XS_Math__MPFR_Rmpfr_buildopt_decimal_p);
        newXS_deffile("Math::MPFR::Rmpfr_regular_p", XS_Math__MPFR_Rmpfr_regular_p);
        newXS_deffile("Math::MPFR::Rmpfr_set_zero", XS_Math__MPFR_Rmpfr_set_zero);
        newXS_deffile("Math::MPFR::Rmpfr_digamma", XS_Math__MPFR_Rmpfr_digamma);
        newXS_deffile("Math::MPFR::Rmpfr_trigamma", XS_Math__MPFR_Rmpfr_trigamma);
        newXS_deffile("Math::MPFR::Rmpfr_ai", XS_Math__MPFR_Rmpfr_ai);
        newXS_deffile("Math::MPFR::Rmpfr_get_flt", XS_Math__MPFR_Rmpfr_get_flt);
        newXS_deffile("Math::MPFR::Rmpfr_get_float16", XS_Math__MPFR_Rmpfr_get_float16);
        newXS_deffile("Math::MPFR::Rmpfr_set_flt", XS_Math__MPFR_Rmpfr_set_flt);
        newXS_deffile("Math::MPFR::Rmpfr_set_float16", XS_Math__MPFR_Rmpfr_set_float16);
        newXS_deffile("Math::MPFR::Rmpfr_urandom", XS_Math__MPFR_Rmpfr_urandom);
        newXS_deffile("Math::MPFR::Rmpfr_set_z_2exp", XS_Math__MPFR_Rmpfr_set_z_2exp);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_tune_case", XS_Math__MPFR_Rmpfr_buildopt_tune_case);
        newXS_deffile("Math::MPFR::Rmpfr_frexp", XS_Math__MPFR_Rmpfr_frexp);
        newXS_deffile("Math::MPFR::Rmpfr_z_sub", XS_Math__MPFR_Rmpfr_z_sub);
        newXS_deffile("Math::MPFR::Rmpfr_grandom", XS_Math__MPFR_Rmpfr_grandom);
        newXS_deffile("Math::MPFR::Rmpfr_clear_divby0", XS_Math__MPFR_Rmpfr_clear_divby0);
        newXS_deffile("Math::MPFR::Rmpfr_set_divby0", XS_Math__MPFR_Rmpfr_set_divby0);
        newXS_deffile("Math::MPFR::Rmpfr_divby0_p", XS_Math__MPFR_Rmpfr_divby0_p);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_gmpinternals_p", XS_Math__MPFR_Rmpfr_buildopt_gmpinternals_p);
        newXS_deffile("Math::MPFR::_get_xs_version", XS_Math__MPFR__get_xs_version);
        newXS_deffile("Math::MPFR::overload_inc", XS_Math__MPFR_overload_inc);
        newXS_deffile("Math::MPFR::overload_dec", XS_Math__MPFR_overload_dec);
        newXS_deffile("Math::MPFR::_overload_lshift", XS_Math__MPFR__overload_lshift);
        newXS_deffile("Math::MPFR::_overload_rshift", XS_Math__MPFR__overload_rshift);
        newXS_deffile("Math::MPFR::_overload_lshift_eq", XS_Math__MPFR__overload_lshift_eq);
        newXS_deffile("Math::MPFR::_overload_rshift_eq", XS_Math__MPFR__overload_rshift_eq);
        newXS_deffile("Math::MPFR::_wrap_count", XS_Math__MPFR__wrap_count);
        newXS_deffile("Math::MPFR::Rmpfr_set_LD", XS_Math__MPFR_Rmpfr_set_LD);
        newXS_deffile("Math::MPFR::Rmpfr_set_DECIMAL64", XS_Math__MPFR_Rmpfr_set_DECIMAL64);
        newXS_deffile("Math::MPFR::Rmpfr_set_DECIMAL128", XS_Math__MPFR_Rmpfr_set_DECIMAL128);
        newXS_deffile("Math::MPFR::Rmpfr_get_LD", XS_Math__MPFR_Rmpfr_get_LD);
        newXS_deffile("Math::MPFR::Rmpfr_get_DECIMAL64", XS_Math__MPFR_Rmpfr_get_DECIMAL64);
        newXS_deffile("Math::MPFR::Rmpfr_get_DECIMAL128", XS_Math__MPFR_Rmpfr_get_DECIMAL128);
        newXS_deffile("Math::MPFR::_MPFR_WANT_DECIMAL_FLOATS", XS_Math__MPFR__MPFR_WANT_DECIMAL_FLOATS);
        newXS_deffile("Math::MPFR::_MPFR_WANT_DECIMAL64", XS_Math__MPFR__MPFR_WANT_DECIMAL64);
        newXS_deffile("Math::MPFR::_MPFR_WANT_DECIMAL128", XS_Math__MPFR__MPFR_WANT_DECIMAL128);
        newXS_deffile("Math::MPFR::_MPFR_WANT_FLOAT128", XS_Math__MPFR__MPFR_WANT_FLOAT128);
        newXS_deffile("Math::MPFR::_max_base", XS_Math__MPFR__max_base);
        newXS_deffile("Math::MPFR::_isobject", XS_Math__MPFR__isobject);
        newXS_deffile("Math::MPFR::_mp_sizes", XS_Math__MPFR__mp_sizes);
        newXS_deffile("Math::MPFR::_ivsize", XS_Math__MPFR__ivsize);
        newXS_deffile("Math::MPFR::_nvsize", XS_Math__MPFR__nvsize);
        newXS_deffile("Math::MPFR::_FLT128_DIG", XS_Math__MPFR__FLT128_DIG);
        newXS_deffile("Math::MPFR::_LDBL_DIG", XS_Math__MPFR__LDBL_DIG);
        newXS_deffile("Math::MPFR::_DBL_DIG", XS_Math__MPFR__DBL_DIG);
        newXS_deffile("Math::MPFR::_FLT128_MANT_DIG", XS_Math__MPFR__FLT128_MANT_DIG);
        newXS_deffile("Math::MPFR::_LDBL_MANT_DIG", XS_Math__MPFR__LDBL_MANT_DIG);
        newXS_deffile("Math::MPFR::_DBL_MANT_DIG", XS_Math__MPFR__DBL_MANT_DIG);
        newXS_deffile("Math::MPFR::Rmpfr_get_float128", XS_Math__MPFR_Rmpfr_get_float128);
        newXS_deffile("Math::MPFR::Rmpfr_get_FLOAT128", XS_Math__MPFR_Rmpfr_get_FLOAT128);
        newXS_deffile("Math::MPFR::Rmpfr_set_FLOAT128", XS_Math__MPFR_Rmpfr_set_FLOAT128);
        newXS_deffile("Math::MPFR::Rmpfr_set_float128", XS_Math__MPFR_Rmpfr_set_float128);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_float128", XS_Math__MPFR_Rmpfr_init_set_float128);
        newXS_deffile("Math::MPFR::Rmpfr_init_set_float128_nobless", XS_Math__MPFR_Rmpfr_init_set_float128_nobless);
        newXS_deffile("Math::MPFR::_is_readonly", XS_Math__MPFR__is_readonly);
        newXS_deffile("Math::MPFR::_readonly_on", XS_Math__MPFR__readonly_on);
        newXS_deffile("Math::MPFR::_readonly_off", XS_Math__MPFR__readonly_off);
        newXS_deffile("Math::MPFR::_can_pass_float128", XS_Math__MPFR__can_pass_float128);
        newXS_deffile("Math::MPFR::_mpfr_want_float128", XS_Math__MPFR__mpfr_want_float128);
        newXS_deffile("Math::MPFR::nnumflag", XS_Math__MPFR_nnumflag);
        newXS_deffile("Math::MPFR::nok_pokflag", XS_Math__MPFR_nok_pokflag);
        newXS_deffile("Math::MPFR::clear_nnum", XS_Math__MPFR_clear_nnum);
        newXS_deffile("Math::MPFR::clear_nok_pok", XS_Math__MPFR_clear_nok_pok);
        newXS_deffile("Math::MPFR::set_nnum", XS_Math__MPFR_set_nnum);
        newXS_deffile("Math::MPFR::set_nok_pok", XS_Math__MPFR_set_nok_pok);
        newXS_deffile("Math::MPFR::_d_bytes", XS_Math__MPFR__d_bytes);
        newXS_deffile("Math::MPFR::_bytes_fr", XS_Math__MPFR__bytes_fr);
        newXS_deffile("Math::MPFR::_dd_bytes", XS_Math__MPFR__dd_bytes);
        newXS_deffile("Math::MPFR::_ld_bytes", XS_Math__MPFR__ld_bytes);
        newXS_deffile("Math::MPFR::_f128_bytes", XS_Math__MPFR__f128_bytes);
        newXS_deffile("Math::MPFR::_required_ldbl_mant_dig", XS_Math__MPFR__required_ldbl_mant_dig);
        newXS_deffile("Math::MPFR::_GMP_LIMB_BITS", XS_Math__MPFR__GMP_LIMB_BITS);
        newXS_deffile("Math::MPFR::_GMP_NAIL_BITS", XS_Math__MPFR__GMP_NAIL_BITS);
        newXS_deffile("Math::MPFR::Rmpfr_fmodquo", XS_Math__MPFR_Rmpfr_fmodquo);
        newXS_deffile("Math::MPFR::Rmpfr_fpif_export", XS_Math__MPFR_Rmpfr_fpif_export);
        newXS_deffile("Math::MPFR::Rmpfr_fpif_import", XS_Math__MPFR_Rmpfr_fpif_import);
        newXS_deffile("Math::MPFR::Rmpfr_flags_clear", XS_Math__MPFR_Rmpfr_flags_clear);
        newXS_deffile("Math::MPFR::Rmpfr_flags_set", XS_Math__MPFR_Rmpfr_flags_set);
        newXS_deffile("Math::MPFR::Rmpfr_flags_test", XS_Math__MPFR_Rmpfr_flags_test);
        newXS_deffile("Math::MPFR::Rmpfr_flags_save", XS_Math__MPFR_Rmpfr_flags_save);
        newXS_deffile("Math::MPFR::Rmpfr_flags_restore", XS_Math__MPFR_Rmpfr_flags_restore);
        newXS_deffile("Math::MPFR::Rmpfr_rint_roundeven", XS_Math__MPFR_Rmpfr_rint_roundeven);
        newXS_deffile("Math::MPFR::Rmpfr_roundeven", XS_Math__MPFR_Rmpfr_roundeven);
        newXS_deffile("Math::MPFR::Rmpfr_nrandom", XS_Math__MPFR_Rmpfr_nrandom);
        newXS_deffile("Math::MPFR::Rmpfr_erandom", XS_Math__MPFR_Rmpfr_erandom);
        newXS_deffile("Math::MPFR::Rmpfr_fmma", XS_Math__MPFR_Rmpfr_fmma);
        newXS_deffile("Math::MPFR::Rmpfr_fmms", XS_Math__MPFR_Rmpfr_fmms);
        newXS_deffile("Math::MPFR::Rmpfr_log_ui", XS_Math__MPFR_Rmpfr_log_ui);
        newXS_deffile("Math::MPFR::Rmpfr_gamma_inc", XS_Math__MPFR_Rmpfr_gamma_inc);
        newXS_deffile("Math::MPFR::_have_IEEE_754_long_double", XS_Math__MPFR__have_IEEE_754_long_double);
        newXS_deffile("Math::MPFR::_have_extended_precision_long_double", XS_Math__MPFR__have_extended_precision_long_double);
        newXS_deffile("Math::MPFR::nanflag_bug", XS_Math__MPFR_nanflag_bug);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_float128_p", XS_Math__MPFR_Rmpfr_buildopt_float128_p);
        newXS_deffile("Math::MPFR::Rmpfr_buildopt_sharedcache_p", XS_Math__MPFR_Rmpfr_buildopt_sharedcache_p);
        newXS_deffile("Math::MPFR::_nv_is_float128", XS_Math__MPFR__nv_is_float128);
        newXS_deffile("Math::MPFR::_SvNOK", XS_Math__MPFR__SvNOK);
        newXS_deffile("Math::MPFR::_SvPOK", XS_Math__MPFR__SvPOK);
        newXS_deffile("Math::MPFR::_lsb", XS_Math__MPFR__lsb);
        newXS_deffile("Math::MPFR::Rmpfr_rec_root", XS_Math__MPFR_Rmpfr_rec_root);
        newXS_deffile("Math::MPFR::Rmpfr_beta", XS_Math__MPFR_Rmpfr_beta);
        newXS_deffile("Math::MPFR::Rmpfr_rootn_ui", XS_Math__MPFR_Rmpfr_rootn_ui);
        newXS_deffile("Math::MPFR::_ld_subnormal_bug", XS_Math__MPFR__ld_subnormal_bug);
        newXS_deffile("Math::MPFR::atodouble", XS_Math__MPFR_atodouble);
        newXS_deffile("Math::MPFR::atonv", XS_Math__MPFR_atonv);
        newXS_deffile("Math::MPFR::Rmpfr_get_str_ndigits_alt", XS_Math__MPFR_Rmpfr_get_str_ndigits_alt);
        newXS_deffile("Math::MPFR::Rmpfr_get_str_ndigits", XS_Math__MPFR_Rmpfr_get_str_ndigits);
        newXS_deffile("Math::MPFR::Rmpfr_dot", XS_Math__MPFR_Rmpfr_dot);
        newXS_deffile("Math::MPFR::_nvtoa", XS_Math__MPFR__nvtoa);
        newXS_deffile("Math::MPFR::_mpfrtoa", XS_Math__MPFR__mpfrtoa);
        newXS_deffile("Math::MPFR::set_fallback_flag", XS_Math__MPFR_set_fallback_flag);
        newXS_deffile("Math::MPFR::doubletoa", XS_Math__MPFR_doubletoa);
        newXS_deffile("Math::MPFR::_fallback_notify", XS_Math__MPFR__fallback_notify);
        newXS_deffile("Math::MPFR::_numtoa", XS_Math__MPFR__numtoa);
        newXS_deffile("Math::MPFR::decimalize", XS_Math__MPFR_decimalize);
        newXS_deffile("Math::MPFR::IOK_flag", XS_Math__MPFR_IOK_flag);
        newXS_deffile("Math::MPFR::POK_flag", XS_Math__MPFR_POK_flag);
        newXS_deffile("Math::MPFR::NOK_flag", XS_Math__MPFR_NOK_flag);
        newXS_deffile("Math::MPFR::_sis_perl_version", XS_Math__MPFR__sis_perl_version);
        newXS_deffile("Math::MPFR::_has_pv_nv_bug", XS_Math__MPFR__has_pv_nv_bug);
        newXS_deffile("Math::MPFR::_sizeof_exp", XS_Math__MPFR__sizeof_exp);
        newXS_deffile("Math::MPFR::_sizeof_prec", XS_Math__MPFR__sizeof_prec);
        newXS_deffile("Math::MPFR::_has_bizarre_infnan", XS_Math__MPFR__has_bizarre_infnan);
        newXS_deffile("Math::MPFR::_gmp_cflags", XS_Math__MPFR__gmp_cflags);
        newXS_deffile("Math::MPFR::_gmp_cc", XS_Math__MPFR__gmp_cc);
        newXS_deffile("Math::MPFR::_have_float16", XS_Math__MPFR__have_float16);
        newXS_deffile("Math::MPFR::_gmp_printf_nv", XS_Math__MPFR__gmp_printf_nv);
        newXS_deffile("Math::MPFR::_gmp_fprintf_nv", XS_Math__MPFR__gmp_fprintf_nv);
        newXS_deffile("Math::MPFR::_gmp_sprintf_nv", XS_Math__MPFR__gmp_sprintf_nv);
        newXS_deffile("Math::MPFR::_gmp_snprintf_nv", XS_Math__MPFR__gmp_snprintf_nv);
        newXS_deffile("Math::MPFR::_looks_like_number", XS_Math__MPFR__looks_like_number);
        newXS_deffile("Math::MPFR::_overload_fmod", XS_Math__MPFR__overload_fmod);
        newXS_deffile("Math::MPFR::_overload_fmod_eq", XS_Math__MPFR__overload_fmod_eq);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
